
    /**     **
       *     *
      *   ** *  SessionSaver 0.2d : rue + Pike
     *   *  **
 *  ****  ** */



/*
** Main object
*/

var SessionSaver = {
	
	// Pref-branch properties
	prefBranch:      'sessionsaver.',
	prefBranchDownSync:  'downsync.', // the downSync session, culled from the server
	prefBranchWindows:    'windows.', // the "live" capture of the current session
	prefBranchCrash:      'windows.', // the branch crashes are restored from
	prefBranchStatic:      'static.', // all manually captured sessions
	staticBranchDefault:  'default.', // the default manual-session
	prefBranchSettings:  'settings.',
	rootBranchRetrieve: #4=function(){try{ return Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch(null);}catch(e){return null;}},
	rootBranch: #4#(), // ..i think this was for SessionSaverSettings/Sync, to handle a particular startup-sequence without any browser-window to rely on; but it was possibly only debug.  [ hmm... -rue]
	wnd: window,       // for the hidden-observer's load -- in-case the iframe's load doesn't initialize the Components in time, we'll leech from here ('loader')
	//isMac: false,    // ..and now we'll know -! (zing) n30
	get isMac() { try{if(window.navigator.platform.match(/mac(?=ppc|os|x| |$)/i))return true}catch(e){} return false;},

	// Called when window first loads
	onLoad: function(evt) {
	
		window.removeEventListener('load', ssLoad, true); // remove startup-check (only run once)
		
		// Setup object properties
		this.promptService   = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService); 
		this.windowMediator  = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator); // for getWindows()
		this.observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		this.prefService     = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService);
		this.rootBranch         = this.prefService.getBranch(null);
		this.Branch             = this.prefService.getBranch(this.prefBranch);
		this.downSyncBranch     = this.prefService.getBranch(this.prefBranch + this.prefBranchDownSync);
		this.windowBranch       = this.prefService.getBranch(this.prefBranch + this.prefBranchWindows);
		this.staticBranch       = this.prefService.getBranch(this.prefBranch + this.prefBranchStatic);
		this.settingsBranch     = this.prefService.getBranch(this.prefBranch + this.prefBranchSettings);
		this.browserChromeUrl   = this.rootBranch.getCharPref('browser.chromeURL');
		this.autoLoad           = !this.settingsBranch.prefHasUserValue("autoload")         ||  this.settingsBranch.getBoolPref("autoload");         // default:true
		this.autoLoadBranch     = (this.settingsBranch.prefHasUserValue('autoload.branch')) ?   this.settingsBranch.getCharPref('autoload.branch') : this.prefBranchWindows; // default:'windows.'
		this.crashLoad          = !this.settingsBranch.prefHasUserValue("crashload")        ||  this.settingsBranch.getBoolPref("crashload");        // default:true
		this.crashLoadBranch    =  this.prefBranchCrash; // XXX theoretically, this could be assigned through prefs; but why?
		this.overwriteWindows   = !this.settingsBranch.prefHasUserValue('overwritewindows') ||  this.settingsBranch.getBoolPref('overwritewindows'); // default:true
		this.overwriteTabs      = !this.settingsBranch.prefHasUserValue('overwritetabs')    ||  this.settingsBranch.getBoolPref('overwritetabs');    // default:true
		this.concatenate        =  this.settingsBranch.prefHasUserValue('concatenate')      &&  this.settingsBranch.getBoolPref('concatenate');      // default:false
		this.shutdownSave       = !this.settingsBranch.prefHasUserValue('shutdownsave')     ||  this.settingsBranch.getBoolPref('shutdownsave');     // default:true
		this.shutdownSaveBranch = (this.settingsBranch.prefHasUserValue('shutdownsave.branch')) ? this.settingsBranch.getCharPref('shutdownsave.branch') : this.prefBranchStatic+this.staticBranchDefault; // default:'static.default.'
		this.snapback_noFX      =  this.settingsBranch.prefHasUserValue('nofx')             &&  this.settingsBranch.getBoolPref('nofx');             // default:false
		this.snapback_willFocus = !this.settingsBranch.prefHasUserValue('willfocus')        ||  this.settingsBranch.getBoolPref('willfocus');        // default:false
		this.lastSessionCrashed =  this.settingsBranch.prefHasUserValue("shutdown")         && !this.settingsBranch.getBoolPref("shutdown");         // default:false, needs to come before "checkLoaded()"
		this.winLocalPrefix = 'session';
		this.winPrefPrefix  = 'saved';
		this.oldD = [" ",  "|", "||", "|||"]; // old-style delimiters
		this.D    = ["  ", "| "," |", " ||"]; // new-style
		this.tabCounter = 0;  // ensure unique tab-count
		this.activeTabs = {}; // set by onTabLoad() -- the hash of active tabs, for snapback
		this.closedTabs = []; // ditto -- the array of Closed tabs, for snapback
		this.msgboardElem = document.getElementById("sessionsaver-messageboard"); // per sessionsavwr.xul, for dtd-import in js -- used by SessionSaver.msgboard()
		this.closeWasHandled = false;
		this.lastSaved = 0;
		this.slurpLast = 0;
		this.useCount  = false; // we'll assume miniT plays nice, by default
		this.hostHash   = {keys:{},regexps:{},regexpsKeyCount:{},evictionQueue:[]};
		this.dataPrefix    = 'http://sessionsaver.mozilla.org/rdf#';
		
		// Hidden window stuff
		this.firstWindow = !this.checkLoaded(); // load shutdown-observer / startup-flag
		this.hiddenObserver = this.hiddenWnd.SessionSaverObserver; // global shutdown-observer
		this.hiddenHash = this.hiddenObserver.activeWindows; // global-hash of "active" windows
			this.firstWindow && this.setPrefs(); // run any version-update stuffs
		this.checkShutdownRequest(true); // re-activate, if a shutdown was previously observed
				
		// Menu handling -- for initMenu()
		this.rdf   = Components.classes['@mozilla.org/rdf/rdf-service;1'].getService(Components.interfaces.nsIRDFService);
		this.utils = Components.classes['@mozilla.org/rdf/container-utils;1'].getService(Components.interfaces.nsIRDFContainerUtils);
		//this.dataPrefix    = 'http://sessionsaver.mozilla.org/rdf#'; // XXX MOVED (above) so the hiddenObserver can grab it
		this.mozillaMenuId = "sessionsaver-mozillamenu";
		this.firefoxMenuId = "sessionsaver-firefoxmenu";
		this.initMenu(this.mozillaMenuId);
		this.initMenu(this.firefoxMenuId);
		this.prefObserverLoad(); // load pref-observer - set menuitems + listeners
		
		// Removal menu (older browsers, only)
		if (this.hiddenObserver.getDontWarn(2)) { 
			var idArray = ['sessionsaver-remove-mozillaseparator','sessionsaver-remove-firefoxseparator','sessionsaver-remove-mozillamenu','sessionsaver-remove-firefoxmenu'];
			while (idArray[0])  {  try{ document.getElementById(idArray.shift()).hidden = false; } catch(e) {}  }    }

		// Sync Startup branch (sync vs. local)
		var startupBranch = null;
		var ssObj =this, deferredCallback =function(rv,observer){ var startupBranch = ssObj.hiddenObserver.prefBranchSyncStartup; if (waitForSync) ssObj.onLoadMid(startupBranch);   }; // called by the sync-discovery phase
		if (this.firstWindow && this.hiddenObserver.sync) {
			try{ 
				var testUrl = this.hiddenObserver.setSyncUrl("test");
				if (testUrl) { 
					var waitForSync = (this.hiddenObserver.syncFlip in {Retrieve:0,Both:0});
					var isFTP = (testUrl.match(/^ftp/i));
					if (isFTP) this.hiddenObserver.discoverSyncSessions(deferredCallback,window,true); // XXX ftp must always be async, to avoid crash-prone browser bugs
					else if (waitForSync) startupBranch = this.hiddenObserver.discoverSyncSessions(null,null,true).resultValue; // ..idisk / dav / local-file
					else this.hiddenObserver.discoverSyncSessions(deferredCallback,null,true); // Store-only, which means we don't need to wait (can be async)
					if (isFTP && waitForSync) return;   }
			}catch(e){ this.log("sync-startup failed: "+e); } 
		}
		
		var isSyncRestore = Boolean(startupBranch && startupBranch != this.prefBranchWindows);
		return this.onLoadMid(startupBranch,isSyncRestore);

	},
		
	onLoadMid: function(startupBranch, isSyncRestore) {
			//this.log("startupBranch: "+startupBranch+"   ->   "+this.Branch.prefHasUserValue(startupBranch+"zorder")); 
			//startupBranch = null; // XXX remove this, naturally !
		var goodStartupBranch = this.Branch.prefHasUserValue(startupBranch+"zorder");
		if (!startupBranch || !goodStartupBranch) startupBranch = (this.lastSessionCrashed?this.crashLoadBranch:this.autoLoadBranch);
		goodStartupBranch = this.Branch.prefHasUserValue(startupBranch+"zorder");

		// The intelligent orbiter
		this.orbiterSaveBranch = this.mb("startupfailure");
		var orbiterPreviousCrashed = this.firstWindow && this.lastSessionCrashed && this.settingsBranch.prefHasUserValue("orbiter"); // did the last session crash during recall?
		if (orbiterPreviousCrashed) var problemBranch = this.settingsBranch.getCharPref("orbiter"), validProblemBranch = this.Branch.prefHasUserValue(problemBranch+"zorder"), nixed = this.settingsBranch.deleteBranch("orbiter"); // theoretically, the user might delete the problem-branch before restarting; no need to prompt, if so
		if (validProblemBranch) {
			var buttonPressed = this.promptService.confirmEx(this.hiddenWnd /*window*/,this.mb('orbiterconfirmtitle'),this.mb('orbiterconfirmmsg'),this.promptService.BUTTON_TITLE_IS_STRING * this.promptService.BUTTON_POS_0 + this.promptService.BUTTON_TITLE_IS_STRING * this.promptService.BUTTON_POS_1,this.mb('continue'),this.mb('abort'),null,null,{});
			if (buttonPressed == 1) {
				var dontLoad = true;
				var wasCrashLoad = (this.crashLoad && this.crashLoadBranch==problemBranch);
				var wasFixedLoad = (!wasCrashLoad && this.autoLoad && this.prefBranchWindows!=problemBranch);
				var wasFixedSync = (wasFixedLoad && this.autoLoadBranch!=this.prefBranchWindows && this.shutdownSave && this.shutdownSaveBranch==this.autoLoadBranch);
				// if the startup-session is fixed/non-updated -- the only option: disable 'autoload'
				if (wasFixedLoad && !wasFixedSync) 
					this.settingsBranch.setBoolPref("autoload", false), alert(this.mb('orbiterdisabledmsg')), this.openSettings().addEventListener("load", function(evt){var wnd = evt.target.defaultView || evt.target.ownerDocument.defaultView; /*alert("opener: "+wnd.opener);*/ var elem = wnd.document.getElementById("autoload"); /*alert("SessionSaverSettings: "+wnd.SessionSaverSettings);*/ wnd.SessionSaverSettings.showExpert(false), wnd.SessionSaverSettings.newOrSavedFlasher("FlasherA").start(elem, false, "fade-in", 70, null,null,null,null,null,null, 'setTimeout');}, 1000, this); // 11 params: elem, append, flashType, speed, dontRun, overlap, overlapPrincipal, overlapFlip, runningTime, runRelative, timerType
				// ..or it's "updatable" or was crash-recovering -- rename + move it
				else { 
					this.hiddenObserver.replicateBranch(problemBranch, this.prefBranchStatic+this.orbiterSaveBranch);
					this.Branch.deleteBranch(problemBranch); // probably unnecessary, but.. better-safe-than-sorry
					var sessionDescription = this.orbiterSaveBranch.replace(/\.$/,"").replace(/[_]/g," ");
					alert(this.mb('orbitersavedmsg')+sessionDescription+"\n"); }
			}
		}
		// Bluefyre's Startup prompt
		if (this.firstWindow && !orbiterPreviousCrashed) // if the orbiter already tripped, dont ask again
			if (this.autoLoad || (this.crashLoad && this.lastSessionCrashed))
				if (this.hiddenObserver.bluefyreStyle && this.hiddenObserver.bluefyreFlip in {Startup:0,Both:0})
					if (goodStartupBranch) { // if there's something to restore
						var isRecover = (this.crashLoad && this.lastSessionCrashed),  isResume = !isRecover && (this.autoLoad && ((this.autoLoadBranch == this.prefBranchWindows) || (this.shutdownSave && this.autoLoadBranch == this.shutdownSaveBranch)));
						     if (isRecover) var confirmTitle = this.mb("recovertitle"), confirmMsg = this.mb("recovermsg"), confirmButton = this.mb("recover" ), declineButton = this.mb("clear");
						else if (isResume )     confirmTitle = this.mb("resumetitle" ), confirmMsg = this.mb("resumemsg" ), confirmButton = this.mb("resume"  ), declineButton = this.mb("clear");
						else                    confirmTitle = this.mb("restoretitle"), confirmMsg = this.mb("restoremsg"), confirmButton = this.mb("activate"), declineButton = this.mb("ignore");
						dontLoad = (1 == this.promptService.confirmEx(this.hiddenWnd /*window*/,confirmTitle,confirmMsg,this.promptService.BUTTON_TITLE_IS_STRING * this.promptService.BUTTON_POS_0 + this.promptService.BUTTON_TITLE_IS_STRING * this.promptService.BUTTON_POS_1,confirmButton,declineButton,null,null,{}) );  }
		// Patch Tabbrowser
		// XXX n27 fixup-ii: for Luhmann, since Tiger-builds of Firefox seem to die somewhere around here, now
		try{ this.TabbrowserPatchUp(); } catch(e){this.settingsBranch.setBoolPref('nofx',true), this.snapback_noFX=true;} // (though we'll have to run it again, later -- per other extensions' delayed mods; miniT)
		window.setTimeout(function(ssObj){ if (ssObj.snapback_noFX) return; try{ssObj.TabbrowserPatchUp();} catch(e){ssObj.settingsBranch.setBoolPref('nofx',true), ssObj.snapback_noFX=true;} }, 500,this);

		// If first window
		if (this.firstWindow) {
			// ..should we autoload / did the last session crash?
			if (!dontLoad && (this.autoLoad || (this.crashLoad && this.lastSessionCrashed)) && goodStartupBranch) {
			
				//var startupBranch = this.lastSessionCrashed?this.crashLoadBranch:this.autoLoadBranch;
				this.hiddenObserver.orbiterCount = 1;
				this.hiddenObserver.orbiterActive = true; // since we'll be opening all child-windows for our session synchronously, we'll have them only register with the orbiter-count while this flag is set
				this.orbiterChild = 1;
				this.settingsBranch.setCharPref('orbiter', startupBranch); // we're the first window -- orbiter pending.
				this.prefService.savePrefFile(null); // store the orbiter immediately
							
				// check startup-page type (0:blank, 1:homepage(s), 2:last)
				var startupPagePref = this.rootBranch.prefHasUserValue("browser.startup.page") ? this.rootBranch.getIntPref("browser.startup.page") : 1; // the pref defaults to 1 internally, so we're good.
				var homepages = new String();
				switch (startupPagePref) { 
					case 0: homepages += "about:blank"; break;
					case 1: try { var pageArray = this.rootBranch.getChildList("browser.startup.homepage", {}); } catch(e) { break; }
							for (var n in pageArray)
								if (! /^browser\.startup\.homepage(\.count|_)/.test(pageArray[n])) {
									try { homepages += " "+this.rootBranch.getComplexValue(pageArray[n], Components.interfaces.nsIPrefLocalizedString).data; } catch(e) {}   }
							break;
					case 2: var historyService, comp, compArray = ["@mozilla.org/browser/global-history;1", "@mozilla.org/browser/global-history;2"]; 
							while ((comp=compArray.shift()) && !historyService) { // XXX n27 fixup-ii: for Luhmann, since Tiger-builds of Firefox seem to die on the old history-iid, now
								try{ historyService = Components.classes[comp].getService(Components.interfaces.nsIBrowserHistory); }catch(e){}   }
							if (historyService && typeof(historyService.lastPageVisited)!='undefined') homepages += historyService.lastPageVisited; // will be an empty-string "", if no page is stored
							break;
				}
				
				// check for window URL arguments
				//this.log("window.arguments: "+window.arguments+"\nthis.arguments: "+this.arguments);
				var args = (this.arguments||window.arguments);
				if (args && args.length > 0)
					// overwrite existing tabs unless a non-homepage URL argument was passed
					for (var i=0, overwriteTabs=true, changed=false; i < args.length; i++)
						for (var j=0, subArguments=args[i].split("\n"); j < subArguments.length; j++) {
							// XXX all possible, since there's no 'opener' for the first window
							//this.log("homepages: "+homepages+"\nsubArguments["+j+"]: "+subArguments[j]+"\nindexOf: "+homepages.indexOf(subArguments[j]));
							if (homepages.indexOf(subArguments[j]) == -1) overwriteTabs = false;
							else { 
								changed = true;
								subArguments.splice(j--, 1), args[i]=subArguments.join("\n"); 
								if (args[i]=="") args.splice(i--, 1);  }
							if (this.arguments||changed) window.arguments=args;
							//this.log(" -> window.arguments: "+window.arguments);
						}
				else overwriteTabs = true; // overwrite if no window-url's were passed
				
				// Load saved session
				//this.sessionRecall(overwriteTabs, startupBranch, isSyncRestore);
				//this.downloadRecall();
				var ssObj = this,  Tabbrowser=window.getBrowser();
				var callback = function(evt){ 
					Tabbrowser.removeEventListener("load",callback,true);
					ssObj.sessionRecall(overwriteTabs, startupBranch, isSyncRestore); 
					ssObj.downloadRecall();
				};
				Tabbrowser.addEventListener("load",callback,true);
				//setTimeout(this.deferredRecall,300, this,true,overwriteTabs,startupBranch,isSyncRestore);
				return;
			}
		}
		// Not the first window:
		else if (opener && opener.SessionSaver) { // once loaded, check to see if there's any pending tabs to restore
			var tabObject = opener.SessionSaver[window.name];
			if (tabObject && tabObject[0] == window) {
				if (this.hiddenObserver.orbiterActive) { this.orbiterChild = 1; this.hiddenObserver.orbiterCount++; }
				//this.windowRecall(tabObject[1], tabObject[2], tabObject[3]); // @params: storedWinName, prefArray, overwriteTabs
				ssObj = this,  Tabbrowser=window.getBrowser();
				callback = function(evt){ 
					Tabbrowser.removeEventListener("load",callback,true);
					ssObj.windowRecall(tabObject[1], tabObject[2], tabObject[3]); 
				};
				Tabbrowser.addEventListener("load",callback,true);
				//setTimeout(this.deferredRecall, 300, this,false,tabObject[1], tabObject[2], tabObject[3]); // @params: x,x, storedWinName, prefArray, overwriteTabs
				delete opener.SessionSaver[window.name]; // remove "pending recall" from opener
				return; }
		}

		if (this.arguments) window.arguments = this.arguments; // drag-opening a file from the OS launches a new window with.. *ding: no opener.
		this.onLoadPtII("none"); // attach the pref-observer -- no recall occurred
		
	},
	
	// Completes our load-process: called by sessionRecall, tabRecall() or onLoad()
	onLoadPtII: function(marker) {
		if (this.activated) return; // if already loaded, don't continue
		this.activated = true;
		
		if (this.firstWindow) this.hiddenObserver.orbiterActive = false;
		
		this.hiddenObserver.addWindow(window, this); // add our window to the global-hash -- also builds a unique window-name for us
		// Pref-Observer + cleanup
		this.observe(null,null,"init2");
		//this.prefObserverLoad(); // load pref-observer - set menuitems + listeners
		if ((this.origBrowserCloseWindow = window.BrowserCloseWindow)) // backup the original
			window.BrowserCloseWindow    = this.onCloseWrap;          // see ya.
		if ((this.origWindowIsClosing    = window.WindowIsClosing))    // backup the original
			window.WindowIsClosing       = this.onCloseWrapII;        // zap.
		if ((window.__ssOrigClose        = window.close))              // backup the original
			window.close                 = this.onCloseWrapIII;       // cheers.
	},
	// Decrements the orbiterCount when all startup-tabs have loaded
	orbiterControl: function(override) {
		if (this.orbiterChild && (override || !--this.orbiterChild)
				&& this.hiddenObserver.orbiterCount && !--this.hiddenObserver.orbiterCount) { // orbiter success.
			 this.settingsBranch.deleteBranch("orbiter"); 
			 this.prefService.savePrefFile(null); }
	},
	/*
		Possible routes for closure:
		i.  OlderBrowser
			- [X]:                             -> [WindowIsClosing]
			- File > Close: BrowserCloseWindow ->                   -> window.close
			- Shutdown:                        ->                   -> window.close
		ii. NewerBrowser
			- [X]:                                [WindowIsClosing] -> window.close
			- File > Close: BrowserCloseWindow -> [WindowIsClosing] -> window.close
			- Shutdown:     BrowserCloseWindow -> [WindowIsClosing] -> window.close
		* bracketed routine alerts warnOnClose, which we're intercepting
		** somehow, the tabbrowser loses its selected-tab just before window.close
	*/	
	// Trips for File > Close -- older browsers
	onCloseWrap: function() { 
		var a = arguments, ss = SessionSaver;
		return (SessionSaver.onClose() 
				&& (ss.closeLevelI=true) // XXX is reset by window-capture.. which is why it must *follow the onClose() call
				&& ((typeof(SessionSaver.origBrowserCloseWindow) == 'function') ?
						( (a.length > 0) ? SessionSaver.origBrowserCloseWindow(a[0],a[1],a[2],a[3],a[4]) : SessionSaver.origBrowserCloseWindow() ) 
						: true));
	},
	// Trips for File > Close (newer) + [X] (older+newer)
	onCloseWrapII: function() {
		var a = arguments, ss = SessionSaver;
		return ((ss.closeLevelI || SessionSaver.onClose()) 
				&& (ss.closeLevelII=true) // XXX is reset by window-capture.. which is why it must *follow the onClose() call
				&& ((typeof(SessionSaver.origWindowIsClosing) == 'function') ?
						( (a.length > 0) ? SessionSaver.origWindowIsClosing(a[0],a[1],a[2],a[3],a[4]) : SessionSaver.origWindowIsClosing() ) 
						: true));
	},
	// Trips *after* File > Close (all) + [X] (all) + shutdown (all)
	onCloseWrapIII: function() {
		var a = arguments, ss = SessionSaver; 
		return ((ss.closeLevelI || ss.closeLevelII || ss.onClose(null,true)) 
				&& ((typeof(window.__ssOrigClose) == 'function') ?
						( (a.length > 0) ? window.__ssOrigClose(a[0],a[1],a[2],a[3],a[4]) : window.__ssOrigClose() ) 
						: true));
	},
	// MessageBoard for DTD-import (of js-strings)
	mb: #1=function(entry) { 
		if (!this.mbCache) this.mbCache = {}; // XXX it seems dtd-strings are only imported at overlay-compilation time -- manually adding them to an un-appended element, then inserting, fails  [naturally, they're called "pre-parser" for a reason -rue]
		return (this.mbCache[entry]) ? this.mbCache[entry] : (this.mbCache[entry] = this.msgboardElem.getAttribute(entry).replace(/[\\]n/g, "\n")); 
	},
	
	// Converts the chromeProperties from bool -> numeric (and back again)
	convertObj: #2={'true':1,'false':0,'1':true,'0':false,'null':null,'':null,'undefined':null,forceNumber:{'true':1,'false':0,'1':1,'0':0}},
	boolToPref: #2#, // "yum" -- sharp-variables

	// Initializes the datasource for our Tools-menu
	initMenu: function(menuId, menu, prefix,suffix) {
		if (!menu) menu = document.getElementById(menuId);   if (!menu) return;
		if (prefix&&suffix)
		try{ // without multiple windows open, we don't want "Save All Windows.." enabled
			var isOne = (this.getWindows("navigator:browser").length==1) ? true:false;
			var capture    = document.getElementById(  prefix+"capture"    +suffix  );
			var captureone = document.getElementById(  prefix+"capture-one"+suffix  );
			var captureall = document.getElementById(  prefix+"capture-all"+suffix  );
			capture   .setAttribute("hidden",!isOne); // ..elegant; cheers.
			captureone.setAttribute("hidden", isOne); 
			captureall.setAttribute("hidden", isOne); 
		}catch(e){this.log("initMenu failed: "+menuId+"  ->  "+e)}
		
		if (!this.resHash) { this.resHash = {}; var label, labels = ['label','value','br','pathto','desc','aky','dsbl','sync','tempest','descbr']; while((label=labels.shift())) this.resHash[label] = this.rdf.GetResource(this.dataPrefix + label);  }

		//remove the old database in case there is one
		var sources = menu.database.GetDataSources(), item, oldDataSource;
		while (sources.hasMoreElements()) {
			item = sources.getNext();
			oldDataSource = item.QueryInterface(Components.interfaces.nsIRDFDataSource);
			menu.database.RemoveDataSource(oldDataSource); }
		var datasource = Components.classes['@mozilla.org/rdf/datasource;1?name=in-memory-datasource'].createInstance(Components.interfaces.nsIRDFDataSource);
		menu.database.AddDataSource(datasource);
		//if (this.hiddenObserver.sync && this.hiddenObserver.syncDatasource) 
			//menu.database.AddDataSource(this.hiddenObserver.syncDatasource);
		
		var sequence = this.utils.MakeSeq(datasource, this.rdf.GetResource('urn:root:sessions'));
		
		// don't list duplicates (branches have multiple prefs)
		var sessionArray = this.Branch.getChildList(this.prefBranchStatic, {}); // array of pref-names holding custom-sessions
		sessionArray.sort(); // the ordering is initially skewed / random
		sessionArray.unshift(this.prefBranchStatic+this.staticBranchDefault+"zorder"); // always include the default branch
		var checkHash = {}, defaultArray = [], branch;
		var checkRe = /(.*\.)[^\.]+$/, defaultRe = new RegExp("^"+ this.prefBranchStatic.replace(/([^\w\d])/g,"\\$1") +"default","i");
		for (var l = 0; l < sessionArray.length; l++) {
			branch = sessionArray[l] = sessionArray[l].match(checkRe)[1];
			if ( checkHash[branch]) { sessionArray.splice(l--,1); continue; }
			if ((checkHash[branch]=true) && defaultRe.test(branch)) defaultArray.push(sessionArray.splice(l--,1)[0]);
		}
		// XXX Future Note: brilliant!- the 'concat()' method allows instant duplication of an array !
		sessionArray = defaultArray.concat(sessionArray);
		var branchRe = new RegExp("^"+ this.prefBranchStatic +"(.*)\\.$");
		var r = this.rdf, g = "GetResource", d = this.dataPrefix;
		var isMac = this.isMac; // ..so we don't penalize for calling the getter, in our loop
		for (var n = 0, a=-1; n < sessionArray.length; n++) {
			var resource = this.rdf.GetResource(sessionArray[n]);
			if (!(branch = sessionArray[n].match(branchRe))) {continue;} //branch = sessionArray[n].match(branchRe)[1]; 
			branch = branch[1];
			var sessionBranch = branch+".";
			var sessionDescription = branch.replace(/[_]/g, " ").split(" ");
			for (var x in sessionDescription) sessionDescription[x] = sessionDescription[x].replace(/^./, sessionDescription[x].charAt(0).toUpperCase());
			sessionDescription = sessionDescription.join(" ");
			//var dscPrefix = n%2 ? " +":" -";
			//sessionDescription = " -    "+sessionDescription;
			var accessKey = (sessionBranch == this.staticBranchDefault || ++a > 26) ? "" : this.mb('sskey'+String.fromCharCode(97+a));
			var accessKeyDisplay = (accessKey == "") ? this.mb('decordefaultleft') : accessKey+this.mb('decorright');
			/*var*/ label = " "+ accessKeyDisplay +"   "+sessionDescription; // ah- label is declared for the res-hash loop (above)
			var sessionLocation = sessionArray[n];
			var disabled = (sessionBranch==this.staticBranchDefault && !this.staticBranch.prefHasUserValue(this.staticBranchDefault+"zorder")) ? "true" : "false";
			var tempest = (false/*isMac*/) ? "slow-time" : "indigo";
			datasource.Assert(resource, this.resHash['dsbl'   ], this.rdf.GetLiteral(disabled          ), true);
			datasource.Assert(resource, this.resHash['label'  ], this.rdf.GetLiteral(label             ), true);
			datasource.Assert(resource, this.resHash['value'  ], this.rdf.GetLiteral(sessionLocation   ), true);
			datasource.Assert(resource, this.resHash['br'     ], this.rdf.GetLiteral(sessionBranch     ), true); // wow- using "#branch" resulted in much wierdness: the attribute's ultimate value was always pre-pended with "static."
			datasource.Assert(resource, this.resHash['desc'   ], this.rdf.GetLiteral(branch            ), true);
			datasource.Assert(resource, this.resHash['descbr' ], this.rdf.GetLiteral(sessionDescription), true);
			datasource.Assert(resource, this.resHash['aky'    ], this.rdf.GetLiteral(accessKey         ), true);
			datasource.Assert(resource, this.resHash['tempest'], this.rdf.GetLiteral(tempest           ), true);
			sequence.AppendElement(resource);
		}
		// final run, for pref-item
		resource = this.rdf.GetResource("ss-live-prefitem");
		datasource.Assert(resource, this.resHash['tempest'], this.rdf.GetLiteral("metaphor"), true);
		sequence.AppendElement(resource);
		
		menu.builder.rebuild();
	},
	// Initializes the datasource for our Tools Sync-submenu
	initSyncMenu: function(menuId, menu) {
		if (!this.hiddenObserver.syncListings || this.winNameUnique in this.hiddenObserver.syncListingsChanged) return;
		if (!menu) menu = document.getElementById(menuId);   if (!menu) return;
		if (!this.resHash) { this.resHash = {}; var label, labels = ['label','value','br','pathto','desc','aky','dsbl','sync','tempest','descbr']; while((label=labels.shift())) this.resHash[label] = this.rdf.GetResource(this.dataPrefix + label);  }

		//remove the old database in case there is one
		var sources = menu.database.GetDataSources(), item, oldDataSource;
		while (sources.hasMoreElements())
			oldDataSource=sources.getNext().QueryInterface(Components.interfaces.nsIRDFDataSource),   menu.database.RemoveDataSource(oldDataSource);
		var datasource = Components.classes['@mozilla.org/rdf/datasource;1?name=in-memory-datasource'].createInstance(Components.interfaces.nsIRDFDataSource);
		menu.database.AddDataSource(datasource);
		//if (this.hiddenObserver.sync && this.hiddenObserver.syncDatasource) 
			//menu.database.AddDataSource(this.hiddenObserver.syncDatasource);
		
		var sequence = this.utils.MakeSeq(datasource, this.rdf.GetResource('urn:root:sync'));
		this.hiddenObserver.setSyncListing(this.rdf,datasource,sequence,this.winNameUnique,this.resHash, true);
		menu.builder.rebuild(); // XXX -!   how could we have missed this ?
	},
	// Initializes each datasource for our SnapBack Dropdown-menus
	initSnapBackMenu: function(menuId, menu) {
		if (!menu) menu = document.getElementById(menuId);   if (!menu) return;
		if (!menuId) menuId = menu.id;
		
		if (typeof(menu.__ssMenuCounter)=='undefined')
			menu.__ssMenuCounter = this.menuCounter = (typeof(this.menuCounter)=='undefined') ? 1 : this.menuCounter++;
		
		// remove the old database in case there is one
		var sources = menu.database.GetDataSources(), item, oldDataSource; // XXX hmm.. the datasources attribute has to be set before script-instantiated elements can be inserted
		while (sources.hasMoreElements())
			item = sources.getNext(), oldDataSource = item.QueryInterface(Components.interfaces.nsIRDFDataSource), menu.database.RemoveDataSource(oldDataSource);
		var datasource = Components.classes['@mozilla.org/rdf/datasource;1?name=in-memory-datasource'].createInstance(Components.interfaces.nsIRDFDataSource);
		menu.database.AddDataSource(datasource);
		
		var isTabMenu = /tabback/.test(menuId); // XXX 'sequence' is defined using this (next)
		var ref = 'urn:root:snapback'+  (isTabMenu?'tabs':'windows')  +menu.__ssMenuCounter;
		menu.setAttribute("ref", ref);
		var sequence = this.utils.MakeSeq(datasource, this.rdf.GetResource(ref));
		var uri = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
		
		var titleLimit = 27,      hostLimit  = 17;
		var emptyRe = /^\s*$/,    spaceRe = /[\s\W]/,    vowelRe = /[aeiou]/g,    headTailSpaceRe = /^\s*(.*?)\s*$/;
		
		var snapBackArray = ((isTabMenu) ? this.closedTabs : this.hiddenObserver.closedWindows).slice(0,10);
		var hostHash = {};
		for (var n = 0, a=-1, finalArray=[], labelArray=[]; n < snapBackArray.length; n++) {
			var resource = this.rdf.GetResource(""+n);
			var title = (isTabMenu ? snapBackArray[n][4] : snapBackArray[n][0][0]  ).replace(headTailSpaceRe, "$1").toLowerCase(); //"Window "+n;
			var host  =  "";
			var spec  =  isTabMenu ? snapBackArray[n][5] : "";
			try{ if (spec != "") (uri.spec = spec) && (host = uri.host.replace(/^www\./,"")); } catch(e) {  setTimeout(function(){throw "e: "+e;},0);  }
			// ..a lot.
			var spacer1 =this.mb("spaceri"), spacer2 =this.mb("spacerii"), spacer3 =this.mb("spaceriii"), joinder =this.mb("joinder"), elipsis =this.mb("elipsis"), blank =this.mb("blank"), tabRight =this.mb("tabdecorright"), tabLeft =this.mb("tabdecorleft"), tabSingular =this.mb("tab"), tabPlural =this.mb("tabs"), hostLeft =this.mb("hostdecorleft"), hostRight =this.mb("hostdecorright"), accessDefault =this.mb('decordefaultleft'), accessRight =this.mb('decorright');
			var description_ptII, preSliceTitle, isDuplicate = false;

			if (host!="" || !isTabMenu) { // remove duplicate portions from head + tail
				var matchedB,matchBII, matchedF=matchedB=matchBII= 0, localRes, localProp, localOld, localNew, origTitle = title, origHost = host.replace(/.*?([^\.]+\.[^\.]+)$/, "$1"), tempHash;
				if (!hostHash[origHost] || ((tempHash = hostHash[origHost]) && false)) hostHash[origHost] = [], tempHash = null; //, tempHash = [origHost,null];
				if (tempHash) // stuff: o'hearn  +  stuff: william orbit  ->  o'hearn + william orbit
					for (var t in tempHash) {
						var matchLimit = 5, countF = -1, countB = title.length, titleCached = tempHash[t][0], countB2 = titleCached.length;
						if (title == titleCached) { isDuplicate=tempHash[t][1], matchedF=matchedB=1; break; } // we'll just borrow the duplicate's label -- thus, a single update reflects everywhere
						if (!matchedF) {  // forward-search
							while (title[++countF] && title[countF] == titleCached[countF]) if (spaceRe.test(title[countF+1])) matchedF = countF+1;
							// XXX new technique: wrapping the 'else-clause' into the if's conditional
							if ((matchedF && matchedF > matchLimit-1 && matchedF < title.length-matchLimit) || ((matchedF = 0) && false)) title = title.slice(matchedF);
							if ( matchedF && matchedF > matchLimit-1 && matchedF < titleCached.length-matchLimit && !finalArray[tempHash[t][1]] [0][0]++) 
								// assert the cached + altered title back into the ds
								titleCached = titleCached.slice(matchedF).replace(headTailSpaceRe, "$1"), finalArray[tempHash[t][1]] [1][3] = (titleCached.length>titleLimit)?titleCached.slice(0,titleLimit)+elipsis:titleCached, localRes  = finalArray[tempHash[t][1]] [2], localProp = this.rdf.GetResource(this.dataPrefix + 'label'), localOld  = datasource.GetTarget(localRes, localProp, true), localNew  = this.rdf.GetLiteral(  finalArray[tempHash[t][1]] [1].join("")  ), datasource.Change(localRes, localProp, localOld, localNew, true)/*, setTimeout("throw '1localOld: "+localOld.Value.replace(/\'/g,"`")+"  ->  localNew: "+localNew.Value.replace(/\'/g,"`")+"'",0)*/;
						}
						// XXX backward-replacement isn't always intuitive -- we can end up with stuff like: "amazon book search: o'hearn" + "amazon music search: o'hearn"  ->  "book" + "music" (which, by the way, didn't happen, because those results were under the min-limit; so the tail-match was discarded)
						if (!matchedB) {  // backward-search
							while (title[--countB] && title[countB] == titleCached[--countB2]) if (spaceRe.test(title[countB-1])) matchedB = countB-1, matchBII = (title[countB2-1]&&spaceRe.test(title[countB2-1]))? countB2-1:countB2;
							if ((matchedB && matchedB > matchLimit && title.length-matchedB > matchLimit) || ((matchedB = 0) && false)) title = title.slice(0, matchedB+1);
							if ( matchBII && matchBII > matchLimit && titleCached.length-matchBII > matchLimit && !finalArray[tempHash[t][1]] [0][1]++) 
								titleCached = titleCached.slice(0, matchBII+1).replace(headTailSpaceRe, "$1"), finalArray[tempHash[t][1]] [1][3] = (titleCached.length>titleLimit)?titleCached.slice(0,titleLimit)+elipsis:titleCached, localRes  = finalArray[tempHash[t][1]] [2], localProp = this.rdf.GetResource(this.dataPrefix + 'label'), localOld  = datasource.GetTarget(localRes, localProp, true), localNew  = this.rdf.GetLiteral(  finalArray[tempHash[t][1]] [1].join("")  ), datasource.Change(localRes, localProp, localOld, localNew, true)/*, setTimeout("throw '2localOld: "+localOld.Value.replace(/\'/g,"`")+"  ->  localNew: "+localNew.Value.replace(/\'/g,"`")+"'",0)*/;
						}
						if (matchedF && matchedB) break;
					}
				// forums.mozillazine.org  ->  [ f.mzln.org ]  ::  books.amazon.com  ->  [ b.amzn.com ]
				if (host.length > hostLimit && host.split(".").length > 1 && (host=host.split("."))) {
					for (var c = 0, alpha, alphaString; c < host.length-1 && host.join(".").length > hostLimit; c++) { 
						if ((host[c] = host[c][0] + host[c].slice(1).replace(vowelRe,"")) // ditch vowels
								&& host.join(".").length > hostLimit
								&& (alpha = {}) && (alphaString = "") ) { 
							for (var d in host[c]) if (!alpha[host[c][d]]) alphaString += alpha[host[c][d]] = host[c][d]; // ditch duplicate letters
							host[c] = alphaString; }
						if (c+1 < host.length-1 && host.join(".").length > hostLimit) host[c] = host[c][0]; }  // ditch all but the first letter
					host= hostLeft+ host.join(".") +hostRight; }
				hostHash[origHost].push([origTitle,n]);
			}
			if (!isTabMenu) host  = tabLeft+ snapBackArray[n][0][2]+(n==0?((parseInt(snapBackArray[n][0][2])>1?tabPlural:tabSingular)):"") +tabRight;

			// XXX theoretically, we could end up with a duplicate that would have been altered by secondary points, after the unaltered original. presently, the duplicate's changes would be lost.
			if (isDuplicate == false)
				 title            = preSliceTitle = (emptyRe.test(title)) ? (host==""||(host=="blank"&&(host=""))?blank:(isTabMenu?(spec=="about:blank"?blank:spec):blank)) : title.replace(headTailSpaceRe, "$1").toLowerCase(),
				 description_ptII = (host!=""?(joinder+host+spacer3):"");
			else title            = preSliceTitle = finalArray[isDuplicate][1][3],       
			     description_ptII = finalArray[isDuplicate][1][4];
			var accessKey = (++a > 26) ? "" : this.mb('sskey'+String.fromCharCode(97+a));
			var accessKeyDisplay = (accessKey == "") ? accessDefault : accessKey +accessRight;
			if (title.length > titleLimit) title = title.slice(0,titleLimit) +elipsis;
			var description = spacer1 + accessKeyDisplay + spacer2 + title + description_ptII;
			datasource.Assert(resource, this.rdf.GetResource(this.dataPrefix + 'label'), this.rdf.GetLiteral(description), true);
			datasource.Assert(resource, this.rdf.GetResource(this.dataPrefix + 'pos'  ), this.rdf.GetLiteral(n), true); // wow- using "#branch" resulted in much wierdness: the attribute's ultimate value was always pre-pended with "static."
			datasource.Assert(resource, this.rdf.GetResource(this.dataPrefix + 'aky'  ), this.rdf.GetLiteral(accessKey), true);
			sequence.AppendElement(resource);
			finalArray[n] = [[matchedF,matchedB],[spacer1,accessKeyDisplay,spacer2,preSliceTitle,description_ptII],resource]; // we could .push(), too; no difference
		}
		menu.builder.rebuild();
	},

	// Prompts for a session-name, then captures to it -- ..and the prompt-display part has separate logic, so session-renaming can also call it (same core-competent logic)
	sessionPrompt: function(isAll) {
		var titleText  = (isAll) ? this.mb('capturetitleall') : this.mb('capturetitleone');
		var promptText = (isAll) ? this.mb('capturemsgall') : this.mb('capturemsgone');
		var modEntry   = this.sessionPromptDisplay(titleText,promptText);
		if (!modEntry) return;
		var winName    = (isAll) ? null : this.winName; // ..captureAll() needs to know which window to capture, if not capturing all
		this.hiddenObserver.captureAll(this.prefBranchStatic+modEntry+".", true, true, winName); // @params: prefBranchSession, suppressSave, saveOnLast, wndName (if not capturing all)
	},
	sessionPromptDisplay: function(title,promptOrig,defaultEntry) {
		var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
		var done = false;
		var origEntry = (defaultEntry||""), modEntry=null;
		var junkTest=false, spaceTest=false, dupeTest=false;
		var junkRe = new RegExp("[^"+"wd.-+!@#$%^&*()=~?:;[]{}|\\/<>".replace(/(.)/g,"\\$1")+"]"); // -- /[^\w\d.\-+!@#$%^&*()=~?:;\[\]\{\}|\\\/\\<>]/ //[^_0-9a-zA-Z] -- en + em-dash don't play nice
		var spaceRe = new RegExp("^_*$");
		while(!done) {
			var alert = new Array(), prealert=[];
			if (junkTest)  alert.push(junkTest);
			if (spaceTest) alert.push(spaceTest);
			if (dupeTest)  prealert.push(dupeTest);
			if (alert.length    > 0) alert.unshift("\n");
			if (prealert.length > 0) prealert.push("\n");
			var promptMod = prealert.join("") + promptOrig + alert.join("");
			try{ origEntry = prompt(promptMod, origEntry, titleText); }
			catch(e) {
				// @params: prompt(window, title, message, *out entry-text, checkbox message, *out checkbox-checked)
				var origEntryWrapped = {value:origEntry};
				origEntry = promptService.prompt(window, title,promptMod,origEntryWrapped, null,{}) ?
						origEntryWrapped.value : null;   }
			if (typeof(origEntry) == "string") {
				modEntry = origEntry.replace(/ /g,'_'); // spaces -> underscores
				junkTest  = junkRe.test(modEntry) ? this.mb('capturestandard'):false;
				spaceTest = spaceRe.test(modEntry) ? this.mb('capturespace'):false;
					//var dupes = this.Branch.getChildList(this.prefBranchStatic+modEntry+".", {}); // array of pref-names holding window-sessions
					//var isDupe = (dupes && dupes.length > 0);
					var isDupe = this.sessionDupeCheck(modEntry);
					if (isDupe) {
						 var buttonPressed = this.promptService.confirmEx(window,title/*this.mb("replaceconfirmtitle")*/,this.mb("replaceconfirmmsg")+origEntry,this.promptService.BUTTON_TITLE_IS_STRING * this.promptService.BUTTON_POS_0 + this.promptService.BUTTON_TITLE_IS_STRING * this.promptService.BUTTON_POS_1,this.mb('keep'),this.mb('replace'),null,null,{});
						 var keepOriginal = (buttonPressed == 0);
						 dupeTest = (keepOriginal) ? this.hiddenObserver.msgRoll():false; } // if we're keeping the original, then cycle again for a name
					else dupeTest = false;
				if (!junkTest && !spaceTest && dupeTest==false) 
					done = true;
			}
			else modEntry = null,
				 done = true; 
		}
		return modEntry;
	},
	sessionDupeCheck: function(sessionName) {
		var prefBranchSession = sessionName+"."; // ..thinking ahead toward implementation-agnostic session storage
		var nameArray = this.Branch.getChildList(this.prefBranchStatic, {}); // array of pref-names holding window-sessions
		var name, nameObj = {asArray:[],asString:""},   startRe=new RegExp("^"+this.prefBranchStatic),   endRe=/\.[^\.]+$/;
		while ((name=nameArray.shift())) name=name.replace(startRe,"").replace(endRe,""), !nameObj[name]&&nameObj.asArray.push(name), nameObj[name]=true;
		if (nameObj.asArray.length == 0) return false;
		nameObj.asString = nameObj.asArray.join("|").replace(/([^a-zA-Z0-9\|])/g,"\\$1")
		var nameRe = new RegExp( "^("+nameObj.asString+")$" ,"i");
		//this.log(nameRe); //this.log(nameObj.toSource());
		//if (sessionName in nameObj) return true;
		if (nameRe.test(sessionName)) return true;
		else return false;
	},
	
	// Recaptures window on window-Close
	onClose: function(evt, isBaseClosure) {
		var shutdownRequested = this.checkShutdownRequest(null, true);
		if (this.closeWasHandled || !this.autoMode) return true; // only continue if we wont be handled later (origClose) or we're running automated (n27)
		this.closeWasHandled = true;
		var isAutoOrSync = this.autoLoad && (this.autoLoadBranch==this.prefBranchWindows || (this.shutdownsave && this.shutdownSaveBranch == this.autoLoadBranch));
		var lastBrowser = (this.getWindows("navigator:browser").length == 1); // we're not closed yet -- length:1
		if (lastBrowser && isAutoOrSync) this.hiddenObserver.removeWarnOnClose(); // if we're closing the last browser, and explicitly restoring the current session at startup
		if (lastBrowser && !shutdownRequested && (shutdownRequested=true)) this.hiddenObserver.observe(null, "quit-application-requested", null);
		if (!isBaseClosure && (!shutdownRequested||this.hiddenObserver.saveConfirm)) // in case the user opts-out, as we're racing the shutdown-request
			try{ this.captureWindow("onClose",null,null,true); } catch(e){setTimeout(function(e){throw 'SS onClose: '+e;},0,e); } // for shutdown by windowClosure -- recapture current scroll-states
		return true;
	},
	
	// Schedules pref-removal on window-Unload
	onUnload: function(evt) {
		if (evt.target // sidebar-closure trips us, and doesn't seem to include a target
				&& evt.target == evt.originalTarget // the targets don't match when a new document is simply unloading the old
				&& evt.target.nodeName.toLowerCase() != "tabbrowser") { // if the window is closing, not a tab..
			var metadata = [this.curTitle,this.curHost,this.lastTabCountForWindow,this.prefArray];
			var shutdownRequested = this.checkShutdownRequest(null, true);
			var lastBrowser = (this.getWindows("navigator:browser").length == 0); // everything's closed -- length:0
			var pendingOrNot =  (lastBrowser || shutdownRequested) ?
				 "SessionSaver-WindowClosePending" // last browser or shutting-down -- schedule this window for removal, when another browser opens
				 : "SessionSaver-WindowClosed";    // not last + not shutting-down -- remove this window's session
			this.hiddenObserver.observe(metadata, pendingOrNot, this.winName); // XXX Note: passing our metadata-array via the observer-service resulted in an xpcom-wrapping -- with no discernable way of unwrapping
			if (lastBrowser && !shutdownRequested) this.hiddenObserver.observe(null, "quit-application-requested", null); // manually trip it, if necessary -- the hidden-window's onunload-handler will check, also
			
			this.orbiterControl(true); // orbiter check
		}
	},
	
	// Designs SnapBack on tab-closure
	onTabPanelUnload: function(child) { // intercepting mPanelContainer.removeChild() -- avoids listening to all page/child unload-events, which crashed when an object unloaded html
		var Tabbrowser = window.getBrowser(), PanelContainer = Tabbrowser.mPanelContainer, sID = "__ssSnapBackID";
		try {
			var browser =child, id =browser[sID], data;
			if (!id && (browser=browser.firstChild)) { do {id=browser[sID];} while (!id && (browser=browser.nextSibling))}
			if (id && (data=this.activeTabs[id])) {
				//this.captureWindow("onTabPanelUnload",null,null,null,true); // XXX actually, we don't need this- the tab-select that automatically follows will trip next
				if (data[5]!="about:blank" || data[0]>1) { // XXX we're only keeping "about:blank" tabs if their history is greater than zero
					var Tabs = Tabbrowser.mTabContainer.childNodes, previousTabIDs = [], prevId;
					var cachedPrevCount = data[8], prevTab; // cachedPrevCount, as set by captureWindow("onTabPanelUnload")
					while (!prevTab && --cachedPrevCount>=0) prevTab = Tabs[cachedPrevCount];
					if (prevTab) { // scan + store the previous tab-id's
						do prevId = (prevTab[sID])?prevTab[sID]:(prevTab[sID]=Tabbrowser.getBrowserForTab(prevTab)[sID]=""+this.tabCounter++), previousTabIDs.push(prevId); // tag each browser, for snapback identification  XXX the id must be a string, or we end up setting id0 twice ( -- the existence test fails)
						while ((prevTab=prevTab.previousSibling))
					}
					data[2] = previousTabIDs.join(" ");
					this.closedTabs.unshift(data);
				}
				if (data[7]) data[7]=false, this.orbiterControl(); // no longer a "startup-session" tab
				delete this.activeTabs[id];
				// better cookie-handling (d1 n29)
				var keys = this.hostHash.keys[id]; delete this.hostHash.keys[id];
				for (var host in keys)
					if (!--this.hostHash[host]) {
						delete this.hostHash[host];
						var hostParts = host.split("."); hostParts.shift();
						if (hostParts.length>1) { // XXX slightly more delicate-handling, since one of our subHosts might also be a full host, for another view
							do { var subHost = hostParts.join("."); if (this.hostHash[subHost]==null) delete this.hostHash[subHost]; hostParts.shift();  } while (hostParts.length-1>0) }
					}
			}
		} catch(e) { this.log('onTabPanelUnload: '+e); } // XXX it seems partially-loaded tabs opened by link-click, then closed, will trip this (rightly so)
		PanelContainer.__ssBypass(child); // the stored, original copy of .removeChild
	},
	
	/*setSnapBackID(tab,Tabbrowser,sID) {
		tab[sID]=Tabbrowser.getBrowserForTab(tab)[sID]=""+this.tabCounter++;
	},*/
	
	// Captures a tab for various user-input events: either after 3secs of no-input, or 1min of sustained input
	inputEventRe: /input|select|option/i, //{click:/input|select|option/i,input:/textarea|input/i},
	onInput: function(evt,view) { // this callback will be heavily raced, in most scenarios; coded appropriately
		// all requisite properties are temporal to the page/pageView -- and destroyed, on page-unload
		var curTime = new Date().valueOf();
		var isTimedCall = Boolean(view);
		if (isTimedCall) elapsedUser = curTime - view.__ssInputUser; //, view.__ssTimeoutPending = false
		else {
			var  elem = evt.originalTarget;   if (evt.type=="click") if (!elem.nodeName || !this.inputEventRe/*[evt.type]*/.test(elem.nodeName)) return;
			if (evt.__ssTimedCall) evt.originalTarget = null;
			var  page = elem.ownerDocument;
			if (!page) {this.log('onInput: noPage'+elem.nodeName); return;}
			while (page.defaultView.frameElement) page = page.defaultView.frameElement.ownerDocument;
			view = page.defaultView;
			view.__ssInputUser = curTime;
			var elapsedUser = 0;
			var isPending = view.__ssTimeoutPending;
			if (isPending) return;
			if (!view.__ssInputSaved) view.__ssInputSaved = curTime;  }
		
		var elapsedSave = curTime - view.__ssInputSaved;
		if (elapsedSave < 60000 && elapsedUser < 3000) {
			view.__ssTimeoutPending = true; 
			view.clearTimeout(view.__ssTimeout);
			view.__ssTimeout = view.setTimeout(ssInput,3000, null,view); // XXX we might want the tab (->browser->contentDocument) so we don't lock ref to the "possibly unloading" page-element, here
			return; }
		
		view.__ssInputSaved = curTime;
		if (isTimedCall) view.__ssTimeoutPending = false;
		
		try{ var tab = this.getTabForPage(page||view.document); }catch(e){var error=e}
		if (!tab) {this.log('onInput: notab '+page.nodeName+(error?("   ->   "+error):"")); return;}
		setTimeout(this.captureCallTab, 100, this,"onInput",0,[tab]);  //this.captureTab("onInputOrClick",tab);
		
		//this.log("input-capture->   "+(isTimedCall?"Timed ->  ":" user ->  ")+"elapsedUser: "+(elapsedUser/1000)+"  ->  elapsed: "+(elapsedSave/1000));
	},
	
	onTabLoad: function(evt) {
		if (typeof(evt.persisted)!='undefined' && evt.persisted==false) return; // the bfcache-pageshow also fires for real page-loads; but evt.persisted will be set false, for these.
		// Ignore frame-loads
		if (evt && evt.originalTarget.defaultView && evt.originalTarget.defaultView != evt.originalTarget.defaultView.top /*&& evt.originalTarget.defaultView.frameElement*/) { // ps: onTabUnload() calls us without an event..
			var calledBy = "onTabLoad-partial", targetHost=null; try{targetHost=evt.originalTarget.defaultView.location.host;}catch(e){} /*return;*/ }
		else    calledBy = "onTabLoad", targetHost=null;

		var    localDoc = evt.originalTarget;
		while (localDoc && localDoc.defaultView && localDoc.defaultView.frameElement) localDoc = localDoc.defaultView.frameElement.ownerDocument;
		var tab = this.getTabForPage(localDoc);
		/*if (!localDoc.__lookupSetter__('__ssTab')) { var tab = this.getTabForPage(localDoc), ssObj = this; localDoc.__defineSetter__('__ssTab',function(a){return (a==ssObj) ? tab:null;}); } // closure-access
		else tab = localDoc.__ssTab = this;*/
		
		if (tab) this.captureTab(calledBy,tab, targetHost);
		else this.log('onTabLoad: notab '+evt.originalTarget.nodeName);
	},
	
	onTabSelect: function(evt) {
		if (typeof(this.selectedTabNonOrdinal)=='undefined') return;
		/*if (this.captureTabPending != null) { 
			var timerObj = this.captureTabPending;
			clearTimeout(timerObj.timer); 
			timerObj.timer = setTimeout(this.captureCallTab,1000,this,"onTabSelect",timerObj.lastSelected,null); 
			return; }*/
		var Tabbrowser = window.getBrowser(), Tabs = Tabbrowser.mTabContainer.childNodes;
		var curTab = Tabbrowser.selectedTab, id = curTab.__ssSnapBackID, lastSelected = this.selectedTabNonOrdinal;
		if (!id || !this.activeTabs || !this.activeTabs[id]) return;
		if (typeof(curTab.ordinal)!='undefined')
			 this.selectedTab = curTab.ordinal, this.selectedTabNonOrdinal = this.activeTabs[id][8];
		else this.selectedTab = this.selectedTabNonOrdinal = this.activeTabs[id][8];
		var lastTab = Tabs[lastSelected];
		if (lastTab) 
			/*this.captureTabPending={lastSelected:lastSelected}, 
			this.captureTabPending.timer =*/ 
			setTimeout(this.captureCallTab,500,/*1000,*/this,"onTabSelect",lastSelected,null/*,Tabs*/); //this.captureTab("onTabSelect",lastTab); //setTimeout(this.captureCallTab,2500,this,"onTabSelect",lastTab,null); // XXX maybe the last-focused tab was just closed
		else this.captureWindow("onTabSelect"); //setTimeout(this.captureCallWindow,2500,this,"onTabSelect"); // 2.5 sec delay
		//this.log('onTabSelect: '+lastSelected+"  ->  "+lastTab);
	},
	
	captureTabPending: null,
	captureCallTab: function(ssObj,calledBy,lastSelected,Tabs){ 
		//if (calledBy=='onTabSelect') ssObj.captureTabPending=null;
		if (!Tabs) Tabs = window.getBrowser().mTabContainer.childNodes; // ..huh. the 'Tabs' param registers as a random/negative number, if we dont pass anything
		var lastTab = Tabs[lastSelected];
		if (lastTab) ssObj.captureTab(calledBy,lastTab); 
		//ssObj.log("captureCallTab: "+lastSelected+"  ->  "+lastTab+"  ->  "+Tabs+":"+Tabs.length+"  ->  "+window.getBrowser().mTabContainer.childNodes);
	},
	emptyObj:{},
	areaTypes: [  {elem:'select',prop:'selectedIndex',prefix:'s'},  {elem:'input',types:{text:{key:0,prop:"value"},radio:{key:1,prop:"checked",conv:true},checkbox:{key:2,prop:"checked",conv:true}},prefix:'i'},  {elem:'textarea',prop:'value',prefix:'a'}  ],
	dsProps: {allowImages:'i',allowSubframes:'s',allowMetaRedirects:'m',allowPlugins:'p',allowJavascript:'j'},
	tabAttrs: {'protected':'p','locked':'l'}, // XXX 'protected' is.. protected, in non-explicit string
	captureTab: function(calledBy,tab, targetHost) {
		// Brilliant SnapBack - tabs
		var ordinal = (typeof(tab.ordinal) == 'number') ? tab.ordinal : (this.useCount=true)&&'none'; // get ordinal (tab-modifier, eg. miniT), or normal index
		var Tabbrowser = window.getBrowser(), browser = Tabbrowser.getBrowserForTab(tab), sID = "__ssSnapBackID";
		var id = (tab[sID])?tab[sID]:(tab[sID]=browser[sID]=""+this.tabCounter++); 
		var cachedPrevCount = (this.activeTabs[id]) ? this.activeTabs[id][8] : null; // set by .captureWindow() -- so .onTabPanelUnload() can determine which tab came before it (the tab-element will be gone, already)
		var snapBackPending = (this.activeTabs[id] && this.activeTabs[id][6]); // check for "snapback" flag -- for tabs which were opened, but whose history hasn't been added yet (pending timeout)
		
		// HistoryData for this tab -- from SnapBack..
		if (snapBackPending == true ) tabSession=this.activeTabs[id][1];
		// ..or the active-listing
		else {
			var oldHistory;
			
			try { oldHistory = browser.sessionHistory; } 
			catch(e) { oldHistory = null; }
			
			var count = (oldHistory ? oldHistory.count:0), tabSession = [];
			if (count > 0) {
				var activeIndex = (oldHistory.index < 0) ? 0 : ((oldHistory.index > oldHistory.count-1) ? oldHistory.count-1 : oldHistory.index ); // ensure active-index exists
				tabSession.push("z"+browser.markupDocumentViewer.textZoom); // text-zoom
				tabSession.push(activeIndex); // active-entry's index
				var newKeys ={},  oldKeys =this.hostHash.keys[id];   this.hostHash.keys[id]=newKeys;// clever hashing of urls for faster cookie-matching (d1 n29)
				for (var j = 0, index = oldHistory.index, postDataStream; j < oldHistory.count; j++) { // the count is tested "live" -- preferable
					var historyData = [], shHistoryEntry = oldHistory.getEntryAtIndex(j, false).QueryInterface(Components.interfaces.nsISHEntry); // it's a wrapped nsISHEntry + nsIHistoryEntry
					var url = shHistoryEntry.URI.spec;
					if (j == index) { // XXX NOT tested "live" -- theoretically, this would be a problem either way: if the index was updated to a shorter length and the cached-index was never reached, or the live-index jumped backwards, and was effectively skipped.  we'll err with the slight speed-gain from caching.
						var isTabLoad = (calledBy=="onTabLoad"||calledBy=="onTabLoad-partial"); // cookie-saving (slows things down slightly, so we'll only do this for page/frame loads)
						if (isTabLoad && shHistoryEntry.URI.scheme.indexOf('http') == 0) { // subframe cookie-capture support (d1 n29) -- cheers, to AnonEmoose, for the non-http-protocol fix
							var mainHost = shHistoryEntry.URI.host; newKeys[mainHost]=1, newKeys.mh=mainHost;
							if (oldKeys) {(oldKeys.mh!=mainHost||(calledBy=="onTabLoad-partial"&&(!oldKeys[targetHost]))) && this.hostHash.evictionQueue.push(oldKeys);} 
							else oldKeys=this.emptyObj;
							if (oldKeys[mainHost]) {;} // already entered, for *this tab  //delete oldKeys[mainHost]; }
							else if (this.hostHash[mainHost]) { this.hostHash[mainHost]++; } // already entered, for *another tab
							else { // unentered
								this.hostHash[mainHost]=1;
								var mainHostParts = mainHost.split("."), part; mainHostParts.shift(); // ditch the primary, since it's already hashed as the count
								do { part=mainHostParts.join("."); !this.hostHash[part] && (this.hostHash[part]=null); mainHostParts.shift();  } while (mainHostParts.length-1>0)   } // XXX no need to worry about sub-count, since we only delete if the main-count hits zero
								// XXX what about ip-urls -- should we incur the penalty to test, first?
						}
						if (false) { // XXX DISABLED: until i can be certain this isn't causing crashes. 10.13.05  (-it might just be our localstore.rdf)
							var dsProps   = this.dsProps;  // || (this.dsProps={allowImages:'i',allowSubframes:'s',allowMetaRedirects:'m',allowPlugins:'p',allowJavascript:'j'});
							var tabAttrs  = this.tabAttrs; // || (this.tabAttrs={protected:'p',locked:'l'};
							var propArray =["ds"], attrArray =["tb"], extraArray =[], ds =browser.docShell, has='hasAttribute', get='getAttribute';
							for (var prop in dsProps)  try{ (typeof(dsProps[prop])!='undefined') && propArray.push( dsProps[prop]+this.convertObj.forceNumber[ds[prop]])}catch(e){}
							for (var attr in tabAttrs) try{tab[has](attr) && propArray.push(tabAttrs[attr]+this.convertObj.forceNumber[tab[get](attr)])}catch(e){}
							if (propArray.length  > 0) extraArray.unshift(propArray.join(""));
							if (attrArray.length  > 0) extraArray.unshift(attrArray.join(""));
							if (extraArray.length > 0) tabSession.unshift("x"+extraArray.join(":")); // extra tab/docshell prop-data -> second-from-last
						}
						try {
							var frames = browser.contentWindow.frames, f = frames.length,   frameArray = [];
							while (f-- > 0 || f<0) {
								var frame = (f<0) ? browser.contentWindow:frames[f],   frameTextArray = (f<0) ? tabSession:[];
								if (!frame) { continue; }
								try{ // XXX is nested-try worth the penalty?
									var curType,mainType, types=this.areaTypes, t=types.length; //t=0; //||(this.areaTypes=[{elem:'textarea',prop:'value',prefix:'a'},{elem:'input',types:{text:{key:0,prop:"value"},radio:{key:1,prop:"checked",conv:true},checkbox:{key:2,prop:"checked",conv:true}},prefix:'i'},{elem:'select',prop:'selectedIndex',prefix:'s'}]); // XXX the child-objects can be cached on the SS-obj
									while (t-- > 0) { // reversed, for speed  (reversed this.areaTypes, too)  //++ < types.length
										mainType= curType =types[t]; //types[t-1]
										var areas=frame.document.getElementsByTagName(curType.elem), a=areas.length, area, areaArray=[];
										while (a-- > 0 && (area=areas[a])) {
											if (mainType.types) { if (area.type in mainType.types) curType=mainType.types[area.type]; else {continue;} }
											if (typeof(area[curType.prop])=='undefined' || area[curType.prop]==null || !area.offsetWidth || !area.offsetHeight) { continue; } // Nice !- we can save the various flags / other-input settings
											var areaTxt = curType.conv ? this.convertObj[area[curType.prop]]:escape(area[curType.prop]), areaId =area.id?escape(area.id):"", areaName =area.name?escape(area.name):"";
											areaArray.unshift(areaTxt+","+areaId+","+areaName+(curType.key?","+curType.key:'')); } // XXX unshift, because we're counting down, remember!
										if (areaArray.length > 0) frameTextArray.unshift(mainType.prefix+areaArray.join(":")) // textarea-data -> third-from-front
									}
								} catch(e) {this.log("area-capture failed: "+curType.toSource()+"   ->   "+e)} // XXX ..worth the penalty?
								if (f<0) { break; }
								if (!(frame.document && frame.document.location)) { continue; } // XXX sans brackets, it continues the greater loop?
								if (isTabLoad) { // subframe cookie-capture support (d1 n29)
									var childHost = frame.document.location.host;
									if (oldKeys[childHost]) { newKeys[childHost]=1; /*delete oldKeys[childHost];*/ }
									else if (this.hostHash[childHost]) { if (!newKeys[childHost]) {newKeys[childHost]=1,this.hostHash[childHost]++;} }
									else { 
										this.hostHash[childHost]=1;
										var childHostParts =childHost.split(".")/*, part*/; childHostParts.shift(); // ditch the primary, since we want this hashed as the count
										do { part=childHostParts.join("."); !this.hostHash[part] && (this.hostHash[part]=null); childHostParts.shift();  } while (childHostParts.length-1>0)   } // XXX no need to worry about sub-count, since we only delete if the main-count hits zero
								}
								var frameURL  = escape(frame.document.location.href),  
									elem      = frame.frameElement,
								    frameId   = elem.id ? escape(elem.id) : "",
								    frameName = elem.name ? escape(elem.name) : "",
								    frameText = frameTextArray.length > 0 ? escape(frameTextArray.join(" ")) : "",
								    framePostData = frame.__ssPostData ? escape(frame.__ssPostData) : "";
								frameArray.unshift(frameURL+","+frame.scrollX+","+frame.scrollY+","+frameId+","+frameName+","+frameText+","+framePostData); } // XXX unshift, because we're counting down, remember!
							if (frameArray.length > 0) tabSession.unshift("f"+frameArray.join(":")); // frame-data -> second-from-front
						} catch(e) {}
						// XXX the https-check is offloaded to the listeners, now
						if (browser.contentWindow.__ssPostData) { //&& shHistoryEntry.postData && !url.match(/^https/i) /*&& calledBy != "onTabLoad-partial"*/) { // XXX don't capture primary postData for secure-connections (most likely, online stores), or frame/subframe loads -- actually, subframe-capture is fine, now; there's almost no penalty, since handling has been offloaded
							var wnd = browser.contentWindow;
							var postDataText = (wnd && wnd.__ssPostData)?wnd.__ssPostData:"", adjusted=wnd.__ssAdjusted; adjusted && (wnd.__ssAdjusted=false); // initially, this was a workaround for LiveHttpHeaders; but it turns out we can capture postData for all subframes this way, too-  "yum"
							// XXX Future: use nsIMultiplexedDataStream,instead, when filedata is present
							if (postDataText != "" && adjusted) { 
								var ct =adjusted[0],   newPostDataText = adjusted[1]; // the original postData-stream (including embedded file-streams) but sans content-type/length
								//if (!contentType) contentType = "application/x-www-form-urlencoded"; // XXX we'll always have the content-type, now
								var stringStream = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream);
									stringStream.setData(newPostDataText, -1);
								var mimeStream = Components.classes["@mozilla.org/network/mime-input-stream;1"].createInstance(Components.interfaces.nsIMIMEInputStream);
								mimeStream.addHeader("Content-Type", ct);
								mimeStream.addContentLength = true;
									mimeStream.setData(stringStream);
								shHistoryEntry.postData = mimeStream;  // tip-tap, replace.
							}
							if (postDataText != "") tabSession.unshift("q"+postDataText); } // post-data -> send to front
						if (url == "about:config") { // special case for about:config
							var doc = browser.contentDocument, configTree = doc.getElementById("configTree"), configBox = doc.getElementById("textbox");
							historyData.push( ((configTree && configTree.treeBoxObject) ? configTree.treeBoxObject.getFirstVisibleRow():0) +","+ (configBox ? escape(configBox.value):"")  ); }
						else historyData.push( browser.contentWindow.scrollX+","+browser.contentWindow.scrollY ); // active-index scroll-position
						var activeURL = url; // for SnapBack
						try{ var activeTitle = browser.contentDocument.title } catch(e) { activeTitle = shHistoryEntry.title; } // for SnapBack -- snapbacked tabs don't have a title in their history-entry
						if (!activeTitle.length) { activeTitle = shHistoryEntry.title; var fileMatch; if ((fileMatch=activeTitle.match(this.activeTitleFileRe))) activeURL=unescape(fileMatch[1].replace(/\#[^\/\#]+$/,"")), activeTitle=unescape(fileMatch[2]); } // ..see, 'file:///' items have no document-title, so this avoids ending-up with "Blank" in the menu
					}
					else {
						var x={},y={}; shHistoryEntry.getScrollPosition(x, y); // XXX we could get the max-value against zero, here
						historyData.push( String(x.value)+","+String(y.value) );  } // scroll-position
					historyData.push(url); // url
					tabSession.push(  historyData.join(this.D[1])  ); // scroll + url 
				}
			}
			else { // if no history is available (popups, etc.), manually create the entry
				if (!browser) return (calledBy!="captureWindow") ? this.captureWindow(calledBy) : null; // the timing for onTabSelect (which is async by 500ms) fired after the selected-tab was closed, so we don't have a browser, anymore
				activeURL = browser.contentDocument.location.toString().replace(/&amp;/g, "&"); // url
				historyData = ["0,0",activeURL]; // scroll-position, url
				try { tabSession.push("z"+browser.markupDocumentViewer.textZoom); } // text-zoom
				catch(e) { tabSession.push("z"+1); } 
				tabSession.push(0); // zero-index
				tabSession.push(  historyData.join(this.D[1])  ); // scroll + url
				try { activeTitle = browser.contentDocument.title; } catch(e) { activeTitle = ""; } // url is caught, above -- again, SnapBack
			}
		
			tabSession = tabSession.join(this.D[2]);
			this.activeTabs[id] = [count,tabSession,null,id,activeTitle,activeURL,false,false,cachedPrevCount]; // [Note: use to check for ordinal, from time-to-time -rue]
			this.curTitle = activeTitle, this.curHost = activeURL; // for snapback-windows
		}
				
		tab.__ssLocalData = tabSession;
		
		//if (calledBy != "captureWindow") this.captureWindow(calledBy); // onward, fire
		switch(calledBy) {
			case "captureWindow": return;
			case "onTabSelect": this.captureDeferred(calledBy,3000); // to permit "tab selecting macros" to have breathing-room, when rapidly switching across large numbers of tabs, before the window-capture's "pause" penalty hits
			default: this.captureWindow(calledBy); // onward, fire
		}
	},
	//var x = "http://stuff.com/thing/it#here".match(/^[a-zA-Z]+\:\/{2,3}(?!.*?\.html?(?:\#[^\/\#]+)$)([^\/]+).*?([^\/]+)$/); x[2].replace(/\#[^\/\#]+$/,"")+"  -  "+x[1]
	activeTitleFileRe: /^[a-zA-Z]+\:\/{2,3}(?!.*?\.html?(?:\#[^\/\#]+)$)([^\/]+).*?([^\/]+)$/, //(?!html).{3,}(?!html).{3,} // /^[a-zA-Z]+\:\/{2,3}(?!.*?\.html?(?:\#[^\/\#]+)$)([^\/]+).*?([^\/]+)$/, // /^file\:\/\/\/([^\/]+).*?([^\/]+)$/,
	
	deferredTimer: null,
	captureDeferred: function(calledBy,delay){clearTimeout(this.deferredTimer); this.deferredTimer=setTimeout(this.captureCallWindow,delay,this,calledBy);},
	savePending: {},
	capturePending: {},
	captureCallWindow: function(ssObj,calledBy,a,b,c,d,e,f){ ssObj.captureWindow(calledBy,a,b,c,true,e,f); },
	captureWindow: function(calledBy, prefBranchSession, suppressSave, isWindowClosure, isTimedCall, n, winName) {
		if (typeof(winName) != "string") winName = this.winName; 
		if (typeof(prefBranchSession) != "string") prefBranchSession = this.prefBranchWindows; // if the 'sessionBranch' parameter wasn't passed, assume auto-save
		else var isManualBranch = (prefBranchSession != this.prefBranchWindows);
		
		if (this.savePending[prefBranchSession] && !(suppressSave||isWindowClosure||isTimedCall)) return; // if any saves are pending, no need to continue
		this.savePending[prefBranchSession] = true;
		
		if (window.__ssLevelI) delete window__ssLevevlI; if (window.__ssLevelII) delete window.__ssLevelII; // reset window-closure flags (eg. after the user opts-out at the "close with multiple tabs?" warning)
		if (this.capturePending[prefBranchSession]) { window.clearTimeout(this.capturePending[prefBranchSession]); delete this.capturePending[prefBranchSession]; }
		
		// Retry later, if tabbrowser is mid transition
		//if (window._content == null && ((typeof(n) == 'undefined'?(n=0):n++)||true) && n < 10) // trickz fo' shorta code
		if (window._content == null && ((typeof(n) == 'undefined'?(n=0):n++)||true)) // trickz fo' shorta code
			return (n>=10) ? (this.savePending[prefBranchSession]=false) : (this.capturePending[prefBranchSession] = window.setTimeout(this.captureCallWindow, 100, this,calledBy,prefBranchSession,suppressSave,isWindowClosure,isTimedCall,n,winName)); // 10x retry-limit

		// Only save once every 10secs, to keep things runnin' Smooth. -- but ignore the clock for window-closures, manual-captures, and (our own) timed-calls
		var logTime   = !(isManualBranch);
		var checkTime = !(isTimedCall||isWindowClosure||isManualBranch);
		if (checkTime) {
			var curTime = new Date().valueOf();
			var timeElapsed =  curTime - this.lastSaved;
			if (timeElapsed < 10000 && !(isWindowClosure||isTimedCall))
				return (this.capturePending[prefBranchSession] = window.setTimeout(this.captureCallWindow, 10000-timeElapsed, this,calledBy,prefBranchSession,suppressSave,isWindowClosure,true,winName));
		}
		if (logTime) this.lastSaved = new Date().valueOf();
		
		if (!(suppressSave||isWindowClosure)) this.checkShutdownRequest(true); // to "re-activate" pref-saving if a shutdown was prior-invoked (and stopped) -- suppressSave is sent by the shutdown-capture, so we'll ignore that case

		// Gather tab-histories + selected-tab
		// XXX  miniT sets *newTab ordinals, even if not active/updating the older tabs; this means snapback can introduce a 'colliding' tab, per ordinal-value
		var Tabbrowser = window.getBrowser(), Tabs = Tabbrowser.mTabContainer.childNodes, tabHistoryAll, i, id,data, sID="__ssSnapBackID", LData="__ssLocalData", localData, ordinalHash={'none':0};
		var slurp = (isWindowClosure||isManualBranch);
		if (typeof(Tabs[0].ordinal)!='number') !this.useCount && (this.useCount=true); // force count-ordering if we don't even have ordinals (eg. sans miniT)..
		else this.useCount && (this.useCount=false); // ..otherwise, try ordinals again -- maybe the collision has passed
		if (!this.useCount) { tabHistoryAll=[], i=-1; while (++i < Tabs.length) slurp && this.captureTab("captureWindow",Tabs[i]), localData = Tabs[i][LData], (id=Tabs[i][sID])&&(data=this.activeTabs[id])&&(data[8]=i), ordinal = typeof(Tabs[i].ordinal)=='number'?Tabs[i].ordinal:'none', (ordinal in ordinalHash) ? (this.useCount=true):(localData) && (tabHistoryAll[ordinal]=localData) && (ordinalHash[ordinal]=true) && (Tabs[i]==Tabbrowser.selectedTab) && ((this.selectedTab = ordinal)||true) && (this.selectedTabNonOrdinal = i); }
		if ( this.useCount) { tabHistoryAll=[], i=-1; while (++i < Tabs.length) slurp && this.captureTab("captureWindow",Tabs[i]), localData = Tabs[i][LData], (id=Tabs[i][sID])&&(data=this.activeTabs[id])&&(data[8]=i), tabHistoryAll[i] = localData, (Tabs[i]==Tabbrowser.selectedTab) && (this.selectedTabNonOrdinal = this.selectedTab = i); }  // .useCount is tested again, in case miniT's collision suddenly pays a visit (see above)
		tabHistoryAll = tabHistoryAll.join(this.D[3]);

		var chromeProperties = ""+ // coercion to string
				this.boolToPref[menubar     .visible] + this.boolToPref[toolbar     .visible]+
				this.boolToPref[locationbar .visible] + this.boolToPref[personalbar .visible]+
				this.boolToPref[statusbar   .visible] + this.boolToPref[scrollbars  .visible]; // window-chrome settings

		var tabCount = i; //window.getBrowser().browsers.length; // count using browsers, since miniT swaps the tab-elements around, and if mid-swap, would leave us.. in error.
		this.lastTabCountForWindow = tabCount; // for window-SnapBack
		
		// window-zoom-state (d1 n20)
		var isMaximized = (window.windowState == window.STATE_MAXIMIZED);
		var ssWindowState = isMaximized ? 1:0; // the state_maximized property isn't set (yet) when we load, so we'll use our own system
		var mw = this.mw || window.document.getElementById("main-window"), a = "getAttribute";
		
		var prefArray = []; // our window's attribute-array
		prefArray.push(winName);       // window-name  XXX this is recycled only on startup-restore -- to ensure no conflicts
		prefArray.push(mw[a]("width"  ));   // width
		prefArray.push(mw[a]("height" ));   // height
		prefArray.push(mw[a]("screenX"));   // screen-pos. x
		prefArray.push(mw[a]("screenY"));   // screen-pos. y
		prefArray.push(chromeProperties);   // window chrome
		prefArray.push(this.selectedTab);   // selected-tab's index
		prefArray.push(tabCount);           // total tabs
		prefArray.push(tabHistoryAll);      // indexed-string of tab histories
		prefArray.push(ssWindowState);      // window-zoom-state (d1 n20)
		this.prefArray = prefArray.join(this.D[0]); // stored, so onUnload() can easily retrieve (for window-snapback)
		delete this.savePending[prefBranchSession]; // this might not get set, if we saved the prefs (below) first

		// better cookie-handling (d1 n29)
		var keys;
		while ((keys=this.hostHash.evictionQueue.shift())) {
			for (var host in keys)
				if (!--this.hostHash[host]) {
					delete this.hostHash[host];
					var hostParts = host.split("."); hostParts.shift();
					if (hostParts.length>1) { // XXX slightly more delicate-handling, since one of our subHosts might also be a full host, for another view
						do {var subHost = hostParts.join("."); if (this.hostHash[subHost]==null) delete this.hostHash[subHost]; hostParts.shift();} while (hostParts.length-1>0)   
					}
				}
		}
		
		// more uniform with sessionRecall()'s code:
		var sessionBranch = this.prefService.getBranch(this.prefBranch + prefBranchSession);
		sessionBranch.setCharPref(winName, this.prefArray);
		if (!suppressSave) {
			var dataObj = {calledBy:calledBy, isWindowClosure:isWindowClosure, winName:winName};
			this.hiddenObserver.observe(null, "SessionSaver-SavePrefFile", dataObj); }  // notify our hidden-window observer to save
	},
	logCount: 0,
		
	// Loads the appropriate number of recalled-windows
	sessionRecall: function(overwriteTabs, prefBranchSession, isSyncRestore, overwriteWindows) {
		// if the 'prefBranchSession' parameter wasn't passed, assume auto-recall
		if (typeof(prefBranchSession) != 'string') prefBranchSession = this.prefBranchWindows;
		var sessionBranch = this.prefService.getBranch(this.prefBranch + prefBranchSession);
		
		// if the 'overwrite' parameters weren't passed, get the prefs
		if (typeof(overwriteTabs) != 'boolean')    overwriteTabs    = this.overwriteTabs;
		if (typeof(overwriteWindows) != 'boolean') overwriteWindows = this.overwriteWindows;
		var wndArray, prefArray, prefName, morePrefArray;
		
		// if the cookies pref is present (d1 nightly 25)
		var cookies = (sessionBranch.prefHasUserValue("cookies")) ? sessionBranch.getCharPref("cookies") : ""; // could use 'null', but this way, we only test for one condition, next
		if (cookies != "") {
			// wipe all existing session-cookies, if overwriting windows + tabs (startup-restore really doesn't matter)
			if (this.overwriteWindows && overwriteTabs) {
				var cookieManager = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager); 
				var oldCookies = cookieManager.enumerator; 
				while (oldCookies.hasMoreElements()) {   
					var c = oldCookies.getNext().QueryInterface(Components.interfaces.nsICookie); 
					if (c.expires == 0) cookieManager.remove(c.host,c.name,c.path,false); } //void remove ( AUTF8String domain , ACString name , AUTF8String path , PRBool blocked ) -- blocked indicates if the host should be permanently blocked
			}
			// add-in this session's
			var ioService = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
			var cookieService = Components.classes["@mozilla.org/cookieService;1"].getService(Components.interfaces.nsICookieService);
			var current; cookies = cookies.split("  |");
			while ((current = cookies.shift())) {
				var origCurrent = current;
				current = current.match(/^([^ ]+) (.+)$/);
				if (!(current && current[1] && current[2])) { if (!erred) setTimeout("throw 'cookies: "+cookies+"';"); var erred = true; setTimeout("throw 'cookie failed: "+origCurrent+"';"); continue; }
				try{ var uri = ioService.newURI(current[1], null, null),   channel = ioService.newChannelFromURI(uri); }catch(e){continue;}
				var cookieString = current[2] +"expires=0;"; // "pair=nostuff;domain=places.com;path=/;expires=0;";
				cookieService.setCookieString(uri, null, cookieString, channel); } // XXX do NOT set a cookie without a uri -- crashes moz1.3.1
		}

		// if the z-order pref is present (d1 nightly 7)
		if (sessionBranch.prefHasUserValue("zorder") && sessionBranch.getCharPref("zorder") != "") {
			wndArray = sessionBranch.getCharPref("zorder").split(",");
			var wndObj={}, pbs=prefBranchSession;
			for (var m in wndArray)  wndArray[m] = pbs+wndArray[m],  wndObj[wndArray[m]] = true;
			var branches = this.Branch.getChildList(pbs, {}); // array of pref-names holding window-sessions
			wndObj[pbs+"zorder"]  = true; // don't prune z-order, or cookies.
			wndObj[pbs+"cookies"] = true; 
			for (var b in branches) if (!wndObj[branches[b]]) this.Branch.deleteBranch(branches[b]); // prune non-z-indexed branches (unneeded)
		}
		else {
			wndArray = this.Branch.getChildList(prefBranchSession, {}); // array of pref-names holding window-sessions
			var compareFunction = function(a, b) {
				a = parseInt(a.replace(/\D*(\d+)$/, "$1")); // get trailing digits from string
				b = parseInt(b.replace(/\D*(\d+)$/, "$1"));
				return a-b; }
			wndArray.sort(compareFunction); // the ordering is initially skewed / random
		}
		
		// ignore empty prefs (user reset) and z-order pref
		for (var i = 0 ; i < wndArray.length ; i++) 
			if (!this.Branch.prefHasUserValue(wndArray[i]) || /(cookies|zorder)$/.test(wndArray[i]) ) 
				wndArray.splice(i--, 1);
		
		// if overwriting windows, close excess (d1 nightly 19)
		if ((wndArray.length > 0) && (overwriteWindows || prefBranchSession == this.prefBranchWindows)) {
			var openWindows = this.getWindows("navigator:browser"); // Note: we can't use z-order listing, because it does something really weird when there's only one window (moz1.3.1) : the first window is ignored, while a child is force-opened, which then loads normally
			var p = -1;
			while (openWindows.length > wndArray.length)
				if (openWindows[++p] != window) { openWindows[p].close(); openWindows.splice(p--, 1); }
		}
		
		// if the window-concatenation pref is present (d1 nightly 17)
		if (this.concatenate) {
			for (var more = 0; more < wndArray.length; more++) {
				morePrefArray = this.Branch.getCharPref(wndArray[more]).split(this.D[0]); // get stored window-session from pref
				if (!prefArray) { // only get 'prefArray' once -- skip adjustments, when doing so
					prefArray = morePrefArray;    prefName = wndArray[more];
					prefArray[5]   = prefArray[5].replace(/0/g, "1"); // we could parseInt() and get the max, but this would (theoretically) be undesirable, since concatenated popups wouldn't have certain chrome, yet in tabbed/concatenated mode, we'd want them to
					prefArray[9]   = 0; // don't maximize (d1 n20) - duh, since we're already adjusting to the "max-sizing" and such, this shouldn't be activated
					prefArray[10]  = isSyncRestore; // sync-restore suppresses size/chrome adjustments, for non-popups (d1 n29)
					continue; }
				 
				prefArray[1]   = prefArray[1] ? Math.max(prefArray[1],morePrefArray[1]) : morePrefArray[1]; // use the greatest width of all
				prefArray[2]   = prefArray[2] ? Math.max(prefArray[2],morePrefArray[2]) : morePrefArray[2]; // use the greatest height of all
				prefArray[3]   = prefArray[3] ? Math.min(prefArray[3],morePrefArray[3]) : morePrefArray[3]; // use the left-most x.position
				prefArray[4]   = prefArray[4] ? Math.min(prefArray[4],morePrefArray[4]) : morePrefArray[4]; // use the top-most y.position
				prefArray[7]  += morePrefArray[7]; // tabCount: we don't even use this, but it doesn't hurt..
				prefArray[6]   = morePrefArray[6];
				prefArray[8]   = new Array(morePrefArray[8], prefArray[8]).join(this.D[3]);
				wndArray.splice(more--, 1); }
		}

		for (var w = 0 ; w < wndArray.length ; w++) {
			if (this.concatenate) {if (!prefArray) break;}
			else {
				prefArray = this.Branch.getCharPref(wndArray[w]).split(this.D[0]); // get stored window-session from pref
				prefArray[10]  = isSyncRestore; // sync-restore suppresses size/chrome adjustments, for non-popups (d1 n29)
				if (wndArray.length == 1) {									// if only restoring one window:
					if (parseInt(prefArray[1]) < 200) prefArray[1] = 640; 	// disallow width  below 200px
					if (parseInt(prefArray[2]) < 150) prefArray[2] = 480; 	// disallow height below 150px
					if (parseInt(prefArray[3]) > screen.width-200)  prefArray[3] = 0; 	// disallow x.position beyond 200px from right
					if (parseInt(prefArray[4]) > screen.height-150) prefArray[4] = 0; 	// disallow y.position beyond 150px from bottom
					prefArray[5] = prefArray[5].replace(/0/g, "1"); 					// force full-chrome
				}
				prefName = wndArray[w]; }
						
			if (openWindows && openWindows[0]) // current window will be included
				openWindows.shift().SessionSaver.windowRecall(prefName, prefArray, overwriteTabs);
			else this.childRecall(prefName, prefArray); // ..otherwise, load the child.
		}
		
		if (!prefArray) this.onLoadPtII("partial"); // attach pref-observer, if load didn't complete
	},
	
	// Opens a child window with relevant session-data
	childRecall: function(prefName, prefArray) {
		var name = prefArray[0]+new Date().valueOf(); // make name "unique" (for window-mediator)
		var propArray = this[name] = ['placeholder', prefName, prefArray, true]; // store tab-histories as window.opener.(this.)name[]
		var isSyncRestore = prefArray[10];
		var windowArgs = (isSyncRestore) ? "" : ",width="+prefArray[1]+",height="+prefArray[2]+",screenx="+prefArray[3]+",screeny="+prefArray[4]; // doesn't always resize/position properly, so we also manually set these on window-load (first listener)
		var windowHandler = window.openDialog(this.browserChromeUrl, name, "chrome,all,dialog=no"+windowArgs, null);
		propArray[0] = windowHandler;
	},
			
	// Loads stored properties for current window
	windowRecall: function(prefName, prefArray, overwriteTabs) {
		if (prefName && prefName.match(/^[^\.]+\./)[0] == this.prefBranchWindows) { // if auto-recall (where branches / sessions are fixed)
			prefArray[0] = prefArray[0].replace(new RegExp(this.winPrefPrefix), ""); // ditch the lame "prefix" we used to attach (n19)
			this.winName = prefArray[0]; // hijacks the existing pref-branch
			this.winSlot = this.winName.match(/\d+$/)[0]; // extract index from name-string
			this.hiddenObserver.reserveSlot(this.winSlot, true); } // "reserve" index, overriding if necessary
		var content = window._content||window;
		if (new RegExp("^"+prefArray[0]).test(window.name) == false) window.name = prefArray[0]+new Date().valueOf(); // child-recalled windows are named when opened
		if (overwriteTabs) { // if overwriting tabs, assume layout can be overridden also
			var chromeProperties = prefArray[5].split("");
			for (var i=0; i<chromeProperties.length; i++)  chromeProperties[i]=this.boolToPref[chromeProperties[i]];
			var isLikelyPopup = !chromeProperties[0] && !chromeProperties[1] && !chromeProperties[4];
			var isSyncRestore = prefArray[10]; // sync-restore suppresses size/chrome adjustments, for non-popups (d1 n29)
			if (isSyncRestore == false || isLikelyPopup) { // if we're sync-restoring, and the window likely isn't a popup, we'll skip adjusting the size/chrome settings
				try{ 
				var mw = window.document.getElementById("main-window"),  s = "setAttribute";
				mw[s]("width"  ,prefArray[1]);// XXX apparently, these are applied *after the onload event-queue, by persistence
				mw[s]("height" ,prefArray[2]);
				mw[s]("screenX",prefArray[3]);
				mw[s]("screenY",prefArray[4]);
				}catch(e){this.log("windowRecall mw-stuff failed: "+e)}
				content.outerWidth  = window.outerWidth  = prefArray[1];
				content.outerHeight = window.outerHeight = prefArray[2];
				content.screenX     = window.screenX     = prefArray[3];
				content.screenY     = window.screenY     = prefArray[4];
				content.moveTo(prefArray[3], prefArray[4]), window.moveTo(prefArray[3], prefArray[4]);
				switch(prefArray[9]) {
					case "1": if (window.maximize) window.maximize(), setTimeout("window.maximize()"); break; // handle window-zoom (d1 n20)
					case "0": if (window.restore ) window.restore(),  setTimeout("window.restore()" ); }// ..and counter, against the default/browserFirstRun maximized state (d1 n29)
				
				menubar.visible =       chromeProperties[0]; // menubar chrome
				toolbar.visible =       chromeProperties[1]; // toolbar chrome
				locationbar.visible =   chromeProperties[2]; // locationbar chrome
				personalbar.visible =   chromeProperties[3]; // personalbar chrome
				statusbar  .visible =   chromeProperties[4]; // statusbar chrome
				scrollbars .visible =   chromeProperties[5]; // scrollbar chrome
			}
		}

		// restore window-tabs
		var selectedtab      = prefArray[6];
		var tabCount         = prefArray[7];
		var tabHistoryAll    = prefArray[8];
		this.tabRecall(tabHistoryAll, selectedtab, overwriteTabs);
	},
	
	// Loads the appropriate number of recalled-tabs in a window
	tabRecall: function(tabHistoryAll, selectedtab, overwriteTabs) {
		var Tabbrowser   = window.getBrowser();
		var sessionTabs  = tabHistoryAll.split(this.D[3]);
		var currentTabs  = new Array();
		var openTabCount = Tabbrowser.browsers.length;
		var showFX = !this.snapback_noFX;
		var newTab, x;
		
		if (showFX && overwriteTabs) Tabbrowser.mTabContainer.childNodes[0].parentNode.setAttribute("ss_f", 0); // fade-in prelim
		//if (overwriteTabs) Tabbrowser.mTabContainer.childNodes[0].setAttribute("ss_f", 0); // fade-in prelim for first-tab
		
		for (var t = 0, LData="__ssLocalData" ; t < sessionTabs.length ; t++) {
			if (!overwriteTabs || t >= openTabCount) // if we're not overwriting (current-window), OR we need another tab..
				 newTab = (!showFX || overwriteTabs) ? (/*delayedOpenTab?delayedOpenTab:*/Tabbrowser.addTab()) : this.addPositionedTab(x,x,x,x, [['ss_f',0]]); // ..open a new tab
			else newTab = Tabbrowser.mTabContainer.childNodes[t]; // otherwise, reuse the existing tab.
			var prevCount = (overwriteTabs) ? t : openTabCount+t;
			// Store local-history -- updated each tab-load, and aggregated per all tab-histories by .captureWindow()
			newTab[LData] = sessionTabs[t];
			currentTabs.push(newTab); // lock-and-load
		}

		// if overwriting, close any leftover tabs
		if (overwriteTabs)
			for (var i = sessionTabs.length; i < openTabCount; i++) Tabbrowser.removeTab(i);
		
		// initiate fade-in
		if (showFX) {
			if (overwriteTabs) { 
				Tabbrowser.mTabContainer.childNodes[0].boxObject.parentBox.setAttribute("ss_f", 0); // more fade-in prelim
				Tabbrowser.mTabContainer.childNodes[0].parentNode.removeAttribute("ss_f");          // ditto.
				this.flasher.start(Tabbrowser.mTabContainer.childNodes[0].boxObject.parentBox, true, "fade-inQ", 40); } // the fade.
			else
				for (var f = 0 ; f < sessionTabs.length ; f++)  
					this.flasher.start(currentTabs[f], true, "fade-in", null, (f+1<sessionTabs.length)?true:false, .75, (f==selectedtab)?currentTabs[f]:null, false, 500, false);
		}
		
		// restore tab-histories
		if (!this.activated) var isStartup = true;
		window.setTimeout(function() {SessionSaver.historyRecall(sessionTabs, currentTabs, selectedtab, overwriteTabs, openTabCount, isStartup);}, 100);
		
		// attach pref-observer, now that load is complete
		this.onLoadPtII("full");
	},
	
	// Loads the histories into recalled-tabs
	knownProps: {x:0,p:0,q:0,f:0,a:0,i:0,s:0,z:0},
	contentTypeRe:   /^(Content-Type: )([^\r\n]+)((\r\n){1,2}|\r|\n)/m,  
	contentLengthRe: /^(Content-Length: )([^\r\n]+)((\r\n){1,2}|\r|\n)/m,
	historyRecall: function(sessionTabs, currentTabs, selectedtab, overwriteTabs, openTabCount, isStartup) {
		var previousTabIDs = []; //, Tabbrowser = window.getBrowser(), isSnapBack=(isStartup==false);
		var ioService = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
		var Tabbrowser = window.getBrowser(),  isSnapBack=(isStartup==false);
		for (var t = 0; t < sessionTabs.length; t++) {
			var curTab =currentTabs[t], curBrowser =getBrowser().getBrowserForTab(curTab), curWebNav =curBrowser.webNavigation;
			// Check if we're loaded enough to continue
			if (t == 0) {
				try {  curWebNav.sessionHistory.QueryInterface(Components.interfaces.nsISHistoryInternal);  }
				catch(e) { // 10x retry-limit
					if (((typeof(n) == 'undefined'?(n=0):n++)||true) && n<10) // smokin some izzerb, that was flowin from the kizzerb.
						return window.setTimeout(function(){ SessionSaver.historyRecall(sessionTabs, currentTabs, selectedtab, overwriteTabs, openTabCount, isStartup, n); },100); } // 10x retry-limit
			}
			
			// Retrieve session history of current tab
			var newHistory = curWebNav.sessionHistory.QueryInterface(Components.interfaces.nsISHistoryInternal);

			// If necessary, clear current-session's history
			if (newHistory.count > 0) newHistory.PurgeHistory(newHistory.count);
			
			// tab-properties
			var tabSession  = sessionTabs[t].split(this.D[2]); // XXX (below) for tabs with nothing captured (eg. link->newtab failed) there's nothing to iterate, so we need to check 'tabSession[propPoint-1]' as a condition
				for (var propPoint=tabSession.length, propName;  tabSession[propPoint-1] && (propName=tabSession[propPoint-1].charAt(0));  propPoint--) if (propName=='z') break; else if (!propName in this.knownProps) tabSession.splice(propPoint++,1); // forwards-compatible, always
			var postData    = (tabSession[0].charAt(0) == "p") ? tabSession.shift().slice(1) : null; // post-data,        if any (nightly 26)
			var postDataII  = (tabSession[0].charAt(0) == "q") ? tabSession.shift().slice(1) : null; // post-data.ii,     if any (nightly 29)
				postDataII && (postData = unescape(postDataII));
			var frameData   = (tabSession[0].charAt(0) == "f") ? tabSession.shift().slice(1) : null; // frame-data,     if any (nightly 27)
			var selectData  = (tabSession[0].charAt(0) == "s") ? tabSession.shift().slice(1) : null; // select-data,    if any (nightly 28)
			var inputData   = (tabSession[0].charAt(0) == "i") ? tabSession.shift().slice(1) : null; // input-data,     if any (nightly 28)
			var areaData    = (tabSession[0].charAt(0) == "a") ? tabSession.shift().slice(1) : null; // textarea-data,  if any (nightly 28)
				var areaDataObj = (areaData||inputData||selectData) ? {'textarea':areaData,'input':inputData,'select':selectData} : null;
			var propData    = (tabSession[0].charAt(0) == "x") ? tabSession.shift().slice(1) : null; // extra tab/docshell props, if any (nightly 29.iii)
				if (tabSession[0].charAt(0) != "z") tabSession.splice(0, 0, "z1.0"); // add text-zoom if not stored (history-string will be in slot[1])
			var textZoom    = parseFloat( tabSession[0].substr(1, tabSession.shift().length-1) ); // text-zoom (nightly 13)
			var activeIndex = parseInt( tabSession.shift() );
			var tabHistory  = tabSession/*.slice(0)*/; // the entire rest of our "session-array" is tab history

			if (postData) {
				if (postDataII) {
					var contentType = postData.match(this.contentTypeRe),   contentLength = postData.match(this.contentLengthRe);
					contentType   && (postData = postData.replace( contentType[0],''   )) && (contentType = contentType[2])
					contentLength && (postData = postData.replace( contentLength[0],'' )); }
				if (!contentType) contentType = "application/x-www-form-urlencoded";
				var stringStream = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream);
				stringStream.setData(postData, postData.length);
				stringStream.QueryInterface(Components.interfaces.nsISeekableStream);
				var mimeStream = Components.classes["@mozilla.org/network/mime-input-stream;1"].createInstance(Components.interfaces.nsIMIMEInputStream);
				mimeStream.addHeader("Content-Type", contentType);
				mimeStream.addContentLength = true;
				mimeStream.setData(stringStream); } // set post-data -- this is only captured for the active-page

			// Reinstate saved-history
			activeIndex = (activeIndex < 0) ? 0 : ((activeIndex > tabHistory.length-1) ? tabHistory.length-1 : activeIndex ); // ensure active-index exists
			for (var i = 0; i < tabHistory.length; i++) {
				var entry = tabHistory[i].split(this.D[1]);
				var scrollPosition = entry[0].split(","); // array of x + y values
				var historyURL = entry[1];
				var newEntry = Components.classes['@mozilla.org/browser/session-history-entry;1'].createInstance(Components.interfaces.nsISHEntry);
				try { var newURI = ioService.newURI(historyURL, null, null); } catch(e) {newURI = ioService.newURI("about:blank",null,null); newURI.spec = historyURL;}
				// XXX 2005.05.04 - nsISHEntry switched to proper js-style capitalization: setTitle, setURI vs. SetTitle, SetURI
				(typeof(newEntry.SetURI)!='undefined') ? newEntry.SetURI(newURI) : newEntry.setURI(newURI);
				newEntry.saveLayoutStateFlag = true;
				newEntry.setScrollPosition( scrollPosition[0], scrollPosition[1] ); // x-pos, y-pos
				// XXX whoa- scope the docShellLoadInfo page -- there's a .target attribute, which would probably allow frame-postData restoration
				newEntry.loadType = (isStartup||(isSnapBack&&!postData)) ? Components.interfaces.nsIDocShellLoadInfo.loadHistory // http://lxr.mozilla.org/seamonkey/source/docshell/base/nsIDocShellLoadInfo.idl#73
						: Components.interfaces.nsIDocShellLoadInfo.loadReloadBypassCache;
				if (i == activeIndex && postData && mimeStream) newEntry.postData = mimeStream;
				newHistory.addEntry(newEntry, true);
				
				if (i != activeIndex) continue; // only active-index stuff, next
				try{
				 	var activeScrollPosition = scrollPosition, activeEntry = newEntry,
						activeURL = newURI.spec,   activeHost = activeURL;   activeHost = newURI.host; // get url + scroll-values for the active-page XXX host-retrieval fails for "chrome://.." urls, hence keeing it last, after the fallback
				} catch(e) {}
			}
			
			// Reselect tab that was open when session was stored
			if (t == selectedtab && overwriteTabs)
				if (getBrowser().selectedTab != curTab) getBrowser().selectedTab = curTab;

			// Set SnapBack history, so the tab can be restored, even if closed before finished loading
			var sID = "__ssSnapBackID"; // XXX.I should be cached outside the loop
			if (!isSnapBack) { // snapback-tabs will have already set this stuff -- in .snapBackTab()
				var id = (curTab[sID])?curTab[sID]:(curTab[sID]=curBrowser[sID]=""+this.tabCounter++); // tag each browser, for snapback identification
				if (activeURL == "about:blank") var snapTitle = "", snapHost = activeURL; // about:blank has no title, and we still need its host to reflect the original, for recallScroll's location-load compare
				else snapTitle = activeURL, snapHost = activeHost;
				var cachedPrevCount = (overwriteTabs) ? t : openTabCount+t;
				this.activeTabs[id] = [tabHistory.length,sessionTabs[t],null,id,snapTitle,snapHost,true,isStartup,cachedPrevCount]; }
			else
				id = curTab[sID];
			
			// Restore scroll-position + text-zoom + frame-stuff -- once tab loads
			if (isStartup && this.orbiterChild) this.orbiterChild++; // so we know when all startup-tabs have loaded
			try{
			curBrowser.__ssRecallParams = {  SessionSaver: this,
			                                 t:            t,
			                                 id:           id,
			                                 scrollX:      activeScrollPosition[0], // this avoids closure-access, on the locally-instantiated array
			                                 scrollY:      activeScrollPosition[1], 
			                                 frameData:    frameData, 
			                                 activeURL:    activeURL, 
			                                 areaDataObj:  areaDataObj,
			                                 textZoom:     textZoom,
			                                 propData:     propData,
			                                 curTab:       curTab, 
			                                 recallScroll: this.recallScroll  };
			var recallScroll = this.recallScroll;
			curBrowser.addEventListener('load', recallScroll, true); // <- Focal of scroll-restore (offloaded, now)
			//function timedRecall(b){b.__ssRecallScroll(null,true);}  // we'll pass the browser directly, since we're looping in the closure, and i'm not sure how "frozen" our spot in the loop-update stands
			//if (frameData) setTimeout(timedRecall, 1500, curBrowser) // to speed-up "apparent" restoration XXX let's try it for frameData-only
			} catch(e){ this.log('recallParams failed: '+activeIndex+" -> "+i+" : "+tabHistory.length+'\n\n'+e);}
			
			// Jump to active history-index (stored when saved)
			if (tabHistory.length > 0 && activeIndex >= 0) {
				if (!activeEntry.postData && postData && mimeStream) { // if the postdata failed to attach, we'll patch it in, manually
					var cacheService = Components.classes["@mozilla.org/network/cache-service;1"].getService(Components.interfaces.nsICacheService);
					try {
						var cacheSession = cacheService.createSession('HTTP',0,true);
						var cacheEntry = cacheSession.openCacheEntry(activeURL.match(/^[^#]+/), Components.interfaces.nsICache.ACCESS_WRITE,true);
						cacheEntry.doom(), cacheEntry.close();
					} catch (e) { cacheService.evictEntries(Components.interfaces.nsICache.STORE_ON_DISK); }
					cacheService.evictEntries(Components.interfaces.nsICache.STORE_IN_MEMORY);
					this.hiddenObserver.check[activeURL] ? this.hiddenObserver.check[activeURL]++ : (this.hiddenObserver.check[activeURL]=1);
					curWebNav.loadURI(activeURL,0,null,mimeStream,null)/*, alert(mimeStream+"\n\n"+postData)*/; }
				else {
					try{ curWebNav.gotoIndex(activeIndex); }
					catch(e) { /*continue;*/ } // skip scroll-recall if we can't load the tab
				}
			}
		}

		if (isStartup && this.orbiterChild)
			 this.orbiterChild--, // jump down to zero-based (we began at '1')
			 setTimeout(function(ssObj){ssObj.orbiterControl(true);},180000,this); // 3min fallback
	}, 	
	
	// Restores scroll-position + text-zoom + frame-stuff -- once tab loads
	truthObj: {'true':0},
	deferredScroll: function(f,u,o,id,post,frameElem,ssObj){ try{f.frameElement.addEventListener('load', o, true);}catch(e){var e_1=e;} try{ (post) ? ssObj.recallFramePost(u,post,frameElem) : (f.location=u);} catch(e){var e_2=e;} if (e_1||e_2) throw "deferredScroll blocked: "+u+"   ->   "+(e_1||"")+((e_1&&e_2)?"\n\n   +\n\n":"")+(e_2||""); },
	onFrameLoad: function(){ var onFrameLoad = arguments.callee; this.removeEventListener('load', onFrameLoad, true); var s=this.__ssScroll; if(!s)return; var x2=s[0], y2=s[1]; delete this.__ssScroll; var t = this.__ssText; delete this.__ssText; if (this.contentWindow.location == this.__ssUrl) (x2>0||y2>0) && this.contentWindow.scrollTo(x2,y2), (t) && setTimeout(SessionSaver.deferredInput,0,this,t,SessionSaver); if (this.__ssWillOrbit) /*setTimeout(function(a){throw 'onFrameLoad: '+a+' -> '+SessionSaver.activeTabs.toSource();},0,this.__ssSnapBackID),*/ SessionSaver.activeTabs[this.__ssSnapBackID][7]=false, SessionSaver.orbiterControl(); },
	recallScroll: function(evt, isTimedCall) {
		//if (this.__ssRecallParams.activeURL == "http://www.norvig.com/design-patterns/ppframe.htm") { var xt = true; }//evt.originalTarget.defaultView.frameElement?null:alert('tripped'); }
		if (typeof(this.__ssRunning)!='undefined' || (isTimedCall && !this.__ssRecallParams) || !(evt && evt.originalTarget && evt.originalTarget.defaultView && !evt.originalTarget.defaultView.frameElement))
			return;
		this.__ssRunning = true;
		var p = this.__ssRecallParams, check = 0, willOrbit = false; // we don't use 'check' yet, but it should allow us to remove the load-listener in advance, if the timeout correctly recalls everything first.
		var recallScroll = p.recallScroll, ssObj = p.SessionSaver, x = p.scrollX, y = p.scrollY; snapBackID = p.id; // id is actually declared, below
		if (!isTimedCall) {  delete this.__ssRecallParams; this.removeEventListener('load', recallScroll, true); }
		// Check for "snapback" flag -- for tabs which were opened, but whose history hasn't been added yet (pending timeout)
		var active = ssObj.activeTabs ? ssObj.activeTabs[snapBackID]:null, truth = ssObj.truthObj;
		if (active) {
			if (active[7] in truth) active[7] = false, willOrbit = true;   // Remove "orbiter-control"  flag, so we know this session didn't crash
			if (active[6] in truth) active[6] = false; }                   // Remove "snapback-pending" flag, so new history will be captured
		this.markupDocumentViewer.textZoom = p.textZoom;
		if (p.propData) try{ssObj.recallProps(p.curTab,this,p.propData)} catch(e){ssObj.log("recallProps failed: "+e)}; // restore extra misc-props (d1 nightly 29.iii)
		if (this.contentWindow.location != p.activeURL){ delete this.__ssRunning; /*alert((isTimedCall?"timed-":"")+"recallScroll failed: "+this.contentWindow.location+"  ->  "+p.activeURL);*/  var tab=ssObj.getTabForBrowser(this); ssObj.captureTab("recallScroll",tab); return (isTimedCall) ? null : ssObj.orbiterControl(); } // the user probably loaded a new page, before this one had finished
		if (p.activeURL == "about:config") { // special case for about:config
			var textbox = this.contentDocument.getElementById("textbox"); 
			var tree    = this.contentDocument.getElementById("configTree"), row = parseInt(x);
			try{  textbox.value = unescape(y), textbox.focus(), textbox.doCommand();  } catch(e){} 
			setTimeout(function() {  try{textbox.doCommand();}catch(e){} setTimeout(function(){ try{tree.treeBoxObject.scrollToRow(row);}catch(e){} },0);   },0);   }
		else if (x>0||y>0) this.contentWindow.scrollTo(x,y), check++; // only scroll if we're going anywhere..
		// Restore frames, if possible
		if (!p.frameData)  { delete this.__ssRunning; if (p.areaDataObj) setTimeout(ssObj.deferredInput,0,this,p.areaDataObj,ssObj); /*tab=ssObj.getTabForBrowser(this); ssObj.captureTab("recallScroll",tab);*/ return (willOrbit) ? ssObj.orbiterControl() : null; } // XXX orbiter
		var localFrames = this.contentWindow.frames;
		var frameInfo = p.frameData.split(':'); //.reverse(); // XXX we captured them by iterating in reverse -- so undo that.
		var equalFrameCount = (localFrames.length == frameInfo.length);
		var onFrameLoad = ssObj.onFrameLoad;
		var local, deferred,   textKeys ={'i':"input",'a':"textarea"};
		for (var c = 0, checkHash = {}, checkUrl; c < frameInfo.length;   c++) frameInfo[c]=frameInfo[c].split(","), checkUrl=unescape(frameInfo[c][0]), (!checkHash[checkUrl] && (checkHash[checkUrl]={length:0})), checkHash[checkUrl][c] = checkHash[checkUrl].length++; // this way, we can determine how many came before a given entry
		for (var d = 0, frameHash = {}, frameUrl; d < localFrames.length; d++) local = localFrames[d].frameElement, frameUrl=(local.contentWindow)?local.contentWindow.location:(local.hasAttribute("src")?local.getAttribute("src"):"about:blank"), (!frameHash[frameUrl] && (frameHash[frameUrl]=[])), frameHash[frameUrl].push(local), local.__ssFrameHashIndex = frameHash[frameUrl].length-1, local.__ssFrameURL = frameUrl;
		for (var f = 0, frameElem; f < frameInfo.length && !(frameElem=null); f++)  {
			var url =unescape(frameInfo[f][0]), id =unescape(frameInfo[f][3]), name =(frameInfo[f].length>4)?unescape(frameInfo[f][4]):id, x2 =parseInt(frameInfo[f][1]), y2 =parseInt(frameInfo[f][2]), text =(frameInfo[f].length>5 && frameInfo[f][5]!='')?unescape(frameInfo[f][5]).split(" "):null,  postData =(frameInfo[f].length>6 && frameInfo[f][6]!='')?unescape(frameInfo[f][6]):null;
				if (text && text.length>0) { var t, key, textObj={}; while ((t=text.shift())) key=textKeys[t.charAt(0)], textObj[key] = t.slice(1); text = textObj; }
			// if a frame has the 'name' attribute, it can be summoned directly from the window.frames hash
			(
				((id != '') && (frameElem=this.contentDocument.getElementById(id))) || ((name != '') && (localFrames[name]) && (frameElem=localFrames[name].frameElement))
						)
						&& (typeof(frameElem.__ssFrameHashIndex)!='undefined') && frameHash[frameElem.__ssFrameURL].splice(frameElem.__ssFrameHashIndex,1);
			if (!frameElem) { // if we couldn't get by id, we'll lookup all frames matching this url and choose one as close to the original hierarchy as possible
				var fLength = (frameHash[url])?frameHash[url].length:0, cPos = checkHash[url][f]; 
				if (fLength > 0) frameElem = (cPos > fLength-1) ? frameHash[url].pop() : frameHash[url].splice(Math.min(cPos,fLength-1),1)[0]; // no need to remove the check's hashed index-value
				else equalFrameCount && (frameElem=localFrames[f].frameElement); } // url-lookup + id both failed, so we'll blind-guess if we have an exact frame-count match
			if (!frameElem) continue; // no luck- "next."
			var frameView = frameElem.contentWindow;
			if (frameView && !postData) var scrollMax = frameView.scrollMax ? {x:frameView.scrollMaxX,y:frameView.scrollMaxY} : {x:frameElem.contentDocument.width,y:frameElem.contentDocument.height}; // newer builds have .scrollMax(X/Y), but all we can get for older builds is the document's complete width/height, which are slightly larger than the max scroll-zone -- but only slightly.
			if (frameView && !postData && frameView.location == url && scrollMax.x >= x2 && scrollMax.y >= y2) (x2>0||y2>0) && frameView.scrollTo(x2,y2), setTimeout(ssObj.deferredInput,0,frameElem,text,ssObj); // only scroll if we're going anywhere
			else if (!frameElem.__ssUrl) { // only if the timed-call didn't already set this
				frameElem.__ssScroll    = [x2,y2];
				frameElem.__ssUrl       = url;
				frameElem.__ssText      = text;
				frameElem.__ssPostData  = postData;
				if (willOrbit) frameElem.__ssWillOrbit = willOrbit, frameElem.__ssSnapBackID = snapBackID;
				// XXX set the location outside the onload-event queue, so any page-handlers which redirect wont stop us
				if (frameView && postData||(frameView.location != url)) setTimeout(ssObj.deferredScroll,0,frameView,url,onFrameLoad,id,postData,(postData?frameElem:null),(postData?ssObj:null)), deferred = true, active[7] = true;/*, xt?alert('deferring'+f+': '+url+'   ->   '+frameView.location):null;*/
				else frameElem.addEventListener('load', onFrameLoad, true); // ..just in case it's mid-attempt on the correct page
			}
		}
		// XXX restore text-fields outside the onload-event queue, so any page-handlers which also restore wont override us (*ahem* Google)
		if (p.areaDataObj) setTimeout(ssObj.deferredInput,0,this,p.areaDataObj,ssObj); //ssObj.recallInput(this, p.areaDataObj);
		delete this.__ssRunning;
		if (!isTimedCall && !deferred && willOrbit) ssObj.orbiterControl(); // XXX orbiter
	},
	// Restores subframe postData -- called by deferredScroll() (above)
	recallFramePost: function(url,postData,frameElem) { 
		try{
			// nice-  no need to iterate/match child-docshells ..we can QueryInterface to anything in "@mozilla.org/webshell;1", from webNav
			var webNav = (frameElem.contentWindow) ? frameElem.contentWindow.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebNavigation) : null;
		}catch(e){ return; }
		if (webNav) {
				var contentType = postData.match(this.contentTypeRe),   contentLength = postData.match(this.contentLengthRe);
				contentType   && (postData = postData.replace( contentType[0],''   )) && (contentType = contentType[2]);
				contentLength && (postData = postData.replace( contentLength[0],'' ));
			if (!contentType) contentType = "application/x-www-form-urlencoded";
			var stringStream = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream);
			stringStream.setData(postData, postData.length);
			stringStream.QueryInterface(Components.interfaces.nsISeekableStream);
			var mimeStream = Components.classes["@mozilla.org/network/mime-input-stream;1"].createInstance(Components.interfaces.nsIMIMEInputStream);
			mimeStream.addHeader("Content-Type", contentType);
			mimeStream.addContentLength = true;
			mimeStream.setData(stringStream); // set post-data -- this is only captured for the active-page
			webNav.loadURI(url,Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE,null,mimeStream,null); }
	},
	
	dsPropsRev: {i:'allowImages',s:'allowSubframes',m:'allowMetaRedirects',p:'allowPlugins',j:'allowJavascript'},
	tabAttrsRev: {p:'protected',l:'locked'},
	recallProps: function(tab, browser, propData) {
		var propSet, propArray = propData.split(":");
		while ((propSet=propArray.shift())) {
			propSet = propSet.split(""); // .split(",")   ->   we can have a comma-join for future, non-bool values; and just split the first block out and split again -- .split("") -- for the current design
			switch(propSet.shift()) {
				case "ds": 
					var prop,   ds = browser.docShell; 
					while ((prop=propSet.shift())) { var key = this.dsPropsRev[prop.charAt(0)],   value = this.convertObj[prop.slice(1)];
						ds[key]=value; }
					break;
				case "tb": 
					var attr;
					while ((attr=propSet.shift())) { key = this.tabAttrsRev[prop.charAt(0)],   value = this.convertObj[prop.slice(1)];
						tab.setAttribute(key,value); }
					break;
			}
		}
	},
	
	// Restores text-input fields, once the relevant view or subframe loads
	deferredInput: function(b,a,ss){ /*try{*/ss.recallInput(b,a);/*} catch(e){ss.log('deferredInput blocked: '+e);}*/},
	recallInput: function(browserOrFrame, areaDataObj) {
		// XXX add external-saving / immediate-viewing for data that cannot be restored -- *But: consider the impact of advertisement-fields + rotating scripts; maybe only do this for fields with data greater than n-length
		var localDoc = browserOrFrame.contentDocument;
		for (var n in areaDataObj) {
			if (!areaDataObj[n]) { continue; }
			var curType = null,   mainType = null,   subKeys = {};
			switch (n) {
				case "select":    curType  = { prop:"selectedIndex" };  break;
				case "textarea":  curType  = { prop:"value" };          break;
				case "input":     mainType = { types:{ text:{prop:"value"}, radio:#6={prop:"checked",conv:true}, checkbox:#6# } };
								  subKeys  = {'text':"text", '0':"text", '1':"radio", '2':"checkbox"};  break;
				default: continue; }
			var localAreas = browserOrFrame.contentDocument.getElementsByTagName(n);
			// XXX note- we're iterating the localAreas in reverse, below -- so unshift() [for nameHash, too! -rue]
			var areaInfo =areaDataObj[n].split(':'), c =areaInfo.length, d =localAreas.length, local, localArray =[], nameHash ={};
			while (c-- > 0) areaInfo[c] = areaInfo[c].split(",");
			while (d-- > 0) { local = localAreas[d]; if (local.offsetWidth && local.offsetHeight && (!mainType || local.type in mainType.types)) localArray.unshift(local), local.__ssRestored = false, (local.name) && ((!nameHash[local.name]&&(nameHash[local.name]=[local])) || nameHash[local.name].unshift(local)); } // XXX maybe remove, for speed?
			for (var a = 0; a < areaInfo.length; a++)  {
				var area = null, collided = false;
				var id =unescape(areaInfo[a][1])||'', data =unescape(areaInfo[a][0]), name =(areaInfo[a].length>2)?(unescape(areaInfo[a][2])||''):id, type =(areaInfo[a].length>3)?(subKeys[areaInfo[a][3]]||null):null;
				// if an area has the 'name' attribute (and the names didn't collide) it can be summoned directly from the object-HTMLCollection[name] hash
				(
					((id != '') && ((area=localDoc.getElementById(id))||(area=true))) 
						|| ((name != '') && ( (!nameHash[name]&&(area=true)) 
							|| (nameHash[name].length==1||(collided=true)) && (area=nameHash[name][0]) ))
							)
				if (area == true) continue; // require match for id; require non-colliding match for name; if name collides, continue searching
				if (area && !collided && type && type!=area.type) continue; // require match for type (but not when continuing name-collision-search)
				// sans id/name/non-colliding-name, we'll blind-guess, hoping to find one as close to the original hierarchy as possible
				// XXX hmm.. really, we should queue all "unmatched" items until the end, so we're only blindly using Un-used/restored fields ..perhaps only if it's not a colliding-name, though.
				if ( !area || area.__ssRestored) (localArray[a] && !localArray[a].id && (!localArray[a].name||localArray[a].name==name) && type?localArray[a].type==type:true) && (area=localArray[a]);
				if ((!area || area.__ssRestored) && localArray.length > 0) { var m = 0; do { (!localArray[m].id && (!localArray[m].name||localArray[m].name==name) && type?localArray[m].type==type:true) && (area = localArray[m]); } while (area.__ssRestored && ++m < localArray.length)   }
				if ( !area || area.__ssRestored) { this.log('unable to locate area for: '+id+'  ->  '+data); continue; } // no luck- "next."
					if (mainType) curType = mainType.types[area.type];
					if (curType.conv) data = this.convertObj[data];
				area.__ssRestored = true;
				area[curType.prop] = data; //,   area.setAttribute(curType.prop,data); // XXX set the attribute last, so radio+checkbox don't get "false" / "true"
			}
		}
		var isBrowser = (browserOrFrame.nodeName.toLowerCase() == "browser");
		if (isBrowser) var tab = this.getTabForBrowser(browserOrFrame); // it's the main browser; not a subframe
		else {
			var view = browserOrFrame.contentWindow;   if (!view) return this.log('unable to capture tab for: '+browserOrFrame.nodeName);   
			while (view.frameElement) view = view.frameElement.ownerDocument.defaultView;
			tab = this.getTabForPage(view.document); }
		if (tab) this.captureTab("recallInput",tab); // XXX necessary, because we're restoring after subframe-restorations, which will have tripped the tab-capture and "caught" empty/unset input-items
	},

	// Restart incomplete downloads -- cheers, to zeniko for the base-code
	downloadRecall: function() {
		var rdf             = this.rdf; 
		var container       = Components.classes["@mozilla.org/rdf/container;1"].createInstance(Components.interfaces.nsIRDFContainer);
		var ioService       = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var downloadManager = Components.classes["@mozilla.org/download-manager;1"].getService(Components.interfaces.nsIDownloadManager);
		var ds = downloadManager.datasource,   I=Components.interfaces,   dataPrefix="http://home.netscape.com/NC-rdf#";
		
		try {container.Init(ds, rdf.GetResource("NC:DownloadsRoot"));} catch(e) {/*this.log('downloadRecall: stopped');*/ return;} // Seamonkey doesn't support saveURL without user interaction, so we stop here (it doesn't support downloadManager.datasource, either)

		var downloads = container.GetElements();
		while (downloads.hasMoreElements()) {
			try{
				var next    = downloads.getNext().QueryInterface(I.nsIRDFResource);
				var nextRes = rdf.GetResource(next.Value);
				var  downloadState  = ds.GetTarget(nextRes, rdf.GetResource( dataPrefix + "DownloadState" ), true);
					 downloadState && downloadState.QueryInterface(I.nsIRDFInt) && (downloadState=downloadState.Value);
				if (!downloadState || downloadState != I.nsIDownloadManager.DOWNLOAD_DOWNLOADING) { continue; }
				var url  = ds.GetTarget(nextRes, rdf.GetResource( dataPrefix + "URL"  ), true).QueryInterface(I.nsIRDFResource).Value;
				var path = ds.GetTarget(nextRes, rdf.GetResource( dataPrefix + "File" ), true).QueryInterface(I.nsIRDFResource).Value;
				
				var linkChecker = Components.classes["@mozilla.org/network/urichecker;1"].createInstance(I.nsIURIChecker);
				linkChecker.init(ioService.newURI(url, null, null));
				linkChecker.loadFlags = I.nsIRequest.LOAD_BACKGROUND;
				linkChecker.asyncCheck(new this.LinkCheckerListener(url, path), null);
			} catch(e){}
		}
	},
	LinkCheckerListener: #3=function(url, path) { this.url=url, this.path=path; },
	LinkCheckerListenerPrototype: #3#.prototype={
		onStartRequest: function(aRequest, aContext) {},
		onStopRequest:  function(aRequest, aContext, aStatus) {
			if (aStatus == Components.results.NS_OK) {
				var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				try{file.initWithPath(this.path);} catch(e){return;} // XXX locale-specific filenames will fail? (non-ascii)
				if (file.exists) try{file.remove(false);} catch(e){}
				if (file.exists) return; // clearly, it wasn't removed
				window.saveURL(this.url, this.path, null, true, true); }
		}
	},
	// "Ende" -- cheers, again, to zeniko
	

	// Returns all open windows of a specified type
	getWindows: function(windowType, frontToBack) {
		if (typeof(frontToBack) != "undefined") 
			var enumerator = this.windowMediator.getZOrderDOMWindowEnumerator(windowType?windowType:null, frontToBack); // windowType, eg. 'navigator:browser'
		else enumerator = this.windowMediator.getEnumerator(windowType?windowType:null);
		var windowArray = new Array();
		
		while (enumerator.hasMoreElements())
			windowArray.push(enumerator.getNext());
		
		return windowArray;
	},

	// Returns the matching browser, for a given tab -- called by onTabPanelUnload()
	getTabForBrowser: function(browser) {
		var Tabbrowser = window.getBrowser(), Tabs = Tabbrowser.mTabContainer.childNodes; // the .getBrowser method resolves tabbed vs. non-tabbed modes -- otherwise, we'd just get .browsers directly
		try { 
			for (var t=0, match=false, l=Tabs.length; t < l && !match; t++) 
				if (Tabbrowser.getBrowserForTab(Tabs[t]) == browser)  match = Tabs[t];
		} catch(e) {this.log('getTabForBrowser: '+e);}
		return match;
	},

	// Returns the owning tab, for a given webpage -- called by onTabLoad()
	getTabForPage: function(page) {
		var Tabbrowser = window.getBrowser(), Tabs = Tabbrowser.mTabContainer.childNodes; // the .getBrowser method resolves tabbed vs. non-tabbed modes -- otherwise, we'd just get .browsers directly
		//try { 
			var cached = page.__ssCachedTabIndex,   cachedTab = (typeof(cached)!='undefined') ? Tabs[cached] : null;
			if (cachedTab && Tabbrowser.getBrowserForTab(cachedTab).contentDocument == page) match=cachedTab;
			else {
				for (var t=0, match=false, l=Tabs.length; t < l && !match; t++) 
					if (Tabbrowser.getBrowserForTab(Tabs[t]).contentDocument == page)  match=Tabs[t],  page.__ssCachedTabIndex=t;
			}
		//} catch(e) {this.log('getTabForPage: '+e);}
		//this.log("TabForPage: "+cached+"   ->   "+cachedTab+"  :"+(match==cachedTab?"cached":"new"));
		return match;
	},

	// Returns the owning browser, for a given webpage
	getBrowserForPage: function(page) {
		var browsers = window.getBrowser().browsers; // the .getBrowser method resolves tabbed vs. non-tabbed modes -- otherwise, we'd just get .browsers directly
		try { 
			for (var b=0, match=false, l=browsers.length; b < l && !match; b++) 
				if (browsers[b].contentDocument == page)  match = browsers[b];
		} catch(e) {this.log('getBrowserForPage: '+e);}
		return match;
	},

	// Checks if a shutdown request has been observed
	checkShutdownRequest: function(overrideClock, ignoreTime) {
		var shutdownRequested = (this.hiddenObserver && this.hiddenObserver.shutdownRequested); // check observer-object's flag
		// If the request was observed over 30 seconds ago, OR something new is loading, 
		// the user probably did something to keep things alive
		var ALongTimeAgo = (shutdownRequested && !ignoreTime &&
				(overrideClock ||
				(this.hiddenObserver.shutdownRequestedTime && 
						new Date().valueOf() - this.hiddenObserver.shutdownRequestedTime > 30000)));
		if (ALongTimeAgo) {
			shutdownRequested = this.hiddenObserver.shutdownRequested = this.closeWasHandled = false;
			this.hiddenObserver.saveConfirm = true;
			this.settingsBranch.setBoolPref("shutdown", false);
			this.hiddenObserver.observe(null, "SessionSaver-WindowCloseFlush", null); // flush any pending window-closures
			this.hiddenObserver.restoreWarnOnClose(); }  // restore browser.tabs.warnOnClose
		if (!shutdownRequested && this.cachedShutdownRequested) delete this.cachedShutdownRequested;
		return shutdownRequested;
	},

	// Checks if SessionSaver is loaded (to avoid "crash recovery" for new browser-windows)
	checkLoaded: function() {
		var alreadyLoaded = (typeof(this.hiddenWnd.SessionSaverObserver) != 'undefined');  // are we already loaded?..
		
		if (!alreadyLoaded)
			this.hiddenWnd.SessionSaverLoader = this,
			this.Loader.loadSubScript("chrome://sessionsaver/content/sessionsaver.js", this.hiddenWnd),
			this.Loader.loadSubScript("chrome://sessionsaver/content/ss-protocol.js" , this.hiddenWnd);
		else
			this.hiddenWnd.SessionSaverObserver.observe(null, "SessionSaver-WindowCloseFlush", null); // flush any pending window-closures
		
		return alreadyLoaded;
	},
	
	// Sets up SessionSaver's hidden-window observer;  creating a privileged iframe, for containment, if needed.
	setupHiddenWnd: function(){
		/*
			Most modern builds of the browser load 'about:blank' into the hidden-window -- which
			leaves us Un-able to run anything privileged in its context. We can get away with
			this for most stuff, since observers and such call with system privileges. But 
			setTimeouts will fail.
			
			The solution is to create an iframe in the hidden-window's document body, and set
			its location to a chrome-url. The trick is to set the location from a privileged
			call-thread. Just setting the "src" attribute will fail, since the iframe
			then loads asynchronously and suddenly doesn't have privilege to load chrome://... 
			Directly setting iframe.contentWindow.location keeps the subScriptLoader's
			privileges as parent for the load.
			
			XXX
			
			..oh yea: and the reason for all this is to keep from locking a reference to the
			first browser-window's instantiation context. Now, we're completely local to the 
			hidden-window.
		*/
		if (this.hiddenWnd) return this.hiddenWnd;
		this.hiddenWnd = Components.classes["@mozilla.org/appshell/appShellService;1"].getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow; // global hidden-window
		this.Loader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService(Components.interfaces.mozIJSSubScriptLoader);
		
		if (this.hiddenWnd.location+"" == "about:blank" || this.hiddenWnd.document.body) {
			// If the hidden-iframe already exists
			if ((this.hiddenIFrame = this.hiddenWnd.document.getElementById("little-oasis"))) {
				this.hiddenWnd = this.hiddenIFrame.contentWindow; }
			// ..or we need to create it
			else {
				this.hiddenIFrame = this.hiddenWnd.document.createElement("iframe");
				this.hiddenIFrame.id = "little-oasis";
				this.hiddenWnd.document.body.appendChild(this.hiddenIFrame);
				this.hiddenIFrame.contentWindow.location = "chrome://sessionsaver/content/little-oasis.html";
				this.hiddenWnd = this.hiddenIFrame.contentWindow; }
		}
		return this.hiddenWnd;
	},

	// Set version-dependant prefs
	setPrefs: function() {
		this.prefBranchInitialized = "prefs_set";

		var current = this.version =   "0.2.1.31.2.2"; // eg:   0.2.1.31.2.2    ->    v.2 d1 nightly 31 pass2 internal-ii
		var prefVer = this.Branch.prefHasUserValue(this.prefBranchInitialized) ? this.Branch.getCharPref(this.prefBranchInitialized) : null;
		var isCurrent = (this.versionCheck(current, prefVer) == 0); 
				// ..and version-independant, too.
				// disable tbmx sessions -- naturally, we override
				var setting, tbPrefix = "extensions.tabmix.", tbmxAll = ["cloesedWinToolsMenu","closedWinToolsMenu","sessionToolsMenu","sessions.manager","sessions.crashrecovery",]; // padded, in case 'cloesed' is ever un-misspelled. (1.3a, 10.07.05)
				var boolType = Components.interfaces.nsIPrefBranch.PREF_BOOL, type="getPrefType", set="setBoolPref";
				while ((setting=tbmxAll.shift())) if (this.rootBranch[type](tbPrefix+setting) == boolType)
					this.rootBranch[set](tbPrefix+setting,false);
		if (isCurrent) return;

		// critical changes across our builds can be handled, this way
		if (this.versionCheck(prefVer, "0.2.1.24.1")   == -1)
			this.settingsBranch.deleteBranch('mode'), this.Branch.deleteBranch('default_session.'), // remove deprecated prefs   
			this.switchSessionDelimiters(this.prefBranchWindows), this.switchSessionDelimiters(this.prefBranchStatic); // update delimiters

		if (this.versionCheck(prefVer, "0.2.1.25.3.4") == -1)
			if (this.rootBranch.getPrefType("javascript.options.showInConsole") == Components.interfaces.nsIPrefBranch.PREF_BOOL)
				this.rootBranch.setBoolPref("javascript.options.showInConsole", true); // show extension-errors

		if (this.versionCheck(prefVer, "0.2.1.27.1")   == -1)
			this.switchSessionPrefs(this.prefBranchStatic),       // update existing prefs to the new backup-suffix
			(this.crashLoad && this.settingsBranch.deleteBranch("crashload")), // we don't expose this pref, anymore -- default:true
			(this.settingsBranch.prefHasUserValue('filemenu') && !this.settingsBranch.getBoolPref('filemenu') && this.settingsBranch.deleteBranch("filemenu")); // we don't expose this pref, anymore -- default:false
		
		if (this.versionCheck(prefVer, "0.2.1.27.5")   == -1)
			this.isMac && this.hiddenObserver.setDontWarn(2, true); // flag, to activate hidden removal-submenu on macs -- the .platform-check seems.. "less-than-reliable", but hopefully not      ->      http://lxr.mozilla.org/mozilla/source/dom/src/base/nsGlobalWindow.cpp#6572 (GetPlatform)  +  http://lxr.mozilla.org/mozilla/source/netwerk/protocol/http/src/nsHttpHandler.cpp#619 (InitUserAgentComponents)
		
		if (this.versionCheck(prefVer, "0.2.1.28.4.1") == -1)
			this.snapback_noFX=true, this.settingsBranch.setBoolPref("nofx", true); // the fade-in gently bows out
		
		if (this.versionCheck(prefVer, "0.2.1.30.1")   == -1)
			this.hiddenObserver.disableWarnOnCloseHandling(); // alright, everyone can have the warnOnClose back
		
		this.Branch.setCharPref(this.prefBranchInitialized, current); // update pref to current
	},

	// Compare tokenized version-strings
	versionCheck: function(newVer, oldVer) {
		if (!newVer || ! oldVer) return (newVer||oldVer) ? (newVer?1:-1) : 0;
		var newArray = newVer.split("."), oldArray = oldVer.split(".");
		var n = 0, decided = 0;
		var hasDifferentLength = (oldArray.length != newArray.length);
		if (hasDifferentLength && newArray.length > oldArray.length) var longer = newArray, shorter = oldArray;
		else longer = oldArray, shorter = newArray;
		while (decided == 0 && longer.length > 0) {
			if (hasDifferentLength && !shorter[0]) { 
				while (parseInt(longer[0]) == 0) longer.shift(); 
				if (longer[0] && parseInt(longer.shift()) > 0) decided = longer; }
			else {
				var first = longer.shift(), second = shorter.shift();
				if (parseInt(first) > parseInt(second)) decided = longer;
				else if (parseInt(first) < parseInt(second)) decided = shorter; }
		}
		if (typeof(decided) == "object") decided = (decided == newArray) ? 1 : -1; // tri-state flag: -1:older, 0:same, 1:newer
		return decided;
	},
	
	// n24: it seems the pipe "|" is legal for urls, so we're moving to a new token-set
	switchSessionDelimiters: function(prefBranchSource) {
		//this.oldD = [" ",  "|", "||", "|||"];
		//this.D =    ["  ", "| "," |", " ||"];
		var d0 = new RegExp(this.oldD[0], "g");
		var d1 = new RegExp(this.oldD[1].replace(/(.)/g,"\\$1"), "g");
		var d2 = new RegExp(this.oldD[2].replace(/(.)/g,"\\$1"), "g");
		var d3 = new RegExp(this.oldD[3].replace(/(.)/g,"\\$1"), "g");
		var i2 = /\n/g;
		var i3 = /\t/g;
		var n0 = this.D[0];
		var n1 = this.D[1];
		var n2 = this.D[2];
		var n3 = this.D[3];
		isUpdatedRe = new RegExp(n0, "g");
		var branches = this.Branch.getChildList(prefBranchSource, {}); // array of pref-names holding window-sessions
		var sourceRe = new RegExp("^"+prefBranchSource);
		var sourceBranch = this.prefService.getBranch(this.prefBranch+prefBranchSource);
		for (var n in branches) { 
			var prefName = branches[n].replace(sourceRe, "");
			if (prefName in {"cookies":0,"zorder":0}) continue; // skip cookies + zorder
			if (sourceBranch.getPrefType(prefName) == Components.interfaces.nsIPrefBranch.PREF_STRING) {
				var string = sourceBranch.getCharPref(prefName);
				if (isUpdatedRe.test(string)) return; // XXX don't continue if the pref matches on our updated-delimiter
				else string = string.replace(d0,n0).replace(d3,"\t").replace(d2,"\n").replace(d1,n1).replace(i2,n2).replace(i3,n3);
				sourceBranch.setCharPref(prefName, string); }
		}
	},
	
	// n27: the old-style "rolling-suffix" wasn't good, so we're switching
	switchSessionPrefs: function(prefBranchSource) {
		var branches = this.Branch.getChildList(prefBranchSource, {}); // array of pref-names holding window-sessions
		var checkHash = {};
		var sourceRe = new RegExp("^("+prefBranchSource+".*?)[^\.]+$");
		var sourceBranch = this.prefService.getBranch(this.prefBranch+prefBranchSource);
		var testString = "_(SS_rolling-prior).";
		var testRe = new RegExp(testString.replace(/(\W)/g,"\\$1")+"$"); //  /\_\(SS\_rolling\-prior\)\./;
		// switch with case-variables [..hmm? -rue]
		for (var n in branches) { 
			var prefBranchTarget = branches[n].replace(sourceRe, "$1");
			if (checkHash[prefBranchTarget] || !testRe.test(prefBranchTarget)) continue;
			if ((checkHash[prefBranchTarget] = true) && this.hiddenObserver.rollBranch(prefBranchTarget,prefBranchTarget.replace(testRe,".")))
				this.Branch.deleteBranch(prefBranchTarget); 
		}
	},
	
	// "my log saw something, that night." -the log lady, twin peaks
	log: function(msg) { this.hiddenObserver.log(msg) },
	
	// launch the settings-pane
	openSettings: function(url,type) {
		var wnd = this.windowMediator.getMostRecentWindow(type||"sessionsaver:sessionsaverSettings");
		if (wnd && !wnd.closed) wnd.document.commandDispatcher.focusedWindow.focus(); // focusing the existing window..
		else wnd = window.openDialog((url||"chrome://sessionsaver/content/sessionsaverSettings.xul"),this.mb("settingstitle"), "chrome,centerscreen,resizable"); // ..or open it
		return wnd;
	},
	
	// configures the tools session-child context menu (via Tools > SessionSaver > right-click)
	childMenuSetup: function(childMenu,prefix,suffix) {
		var item        = (childMenu) ? childMenu.parentNode : document.popupNode;
		var restoreover = document.getElementById(  prefix+'restoreover'+suffix  );
		var restorenew  = document.getElementById(  prefix+'restorenew' +suffix  );
		var replaceone  = document.getElementById(  prefix+'replace-one'+suffix  );
		var replaceall  = document.getElementById(  prefix+'replace-all'+suffix  );
		var addone      = document.getElementById(  prefix+'add-one'    +suffix  );
		var addall      = document.getElementById(  prefix+'add-all'    +suffix  );
		var rename      = document.getElementById(  prefix+'rename'     +suffix  );
		var remove      = document.getElementById(  prefix+'delete'     +suffix  );
		var removeall   = document.getElementById(  prefix+'deleteall'  +suffix  );
		var startup     = document.getElementById(  prefix+'setstartup' +suffix  );
		var details     = document.getElementById(  prefix+'showdetails'+suffix  );
		var archive     = document.getElementById(  prefix+'archive'    +suffix  );
		var context     = (childMenu||document.getElementById("sessionsaver-tools-child-contextmenu"));
		var has="hasAttribute",get="getAttribute",set="setAttribute",rmv="removeAttribute";
		
		restoreover[set]('default', this.overwriteWindows);
		restorenew [set]('default',!this.overwriteWindows);
		
		// without multiple windows open, we don't want "Replace with All Windows..", etc. enabled
		var isOne = (this.getWindows("navigator:browser").length==1) ? true:false;
		replaceall[set]("hidden",isOne); // ..elegant; cheer   (--not the main-menu's approach) [yes, it is now. -rue]
		addall    [set]("hidden",isOne); 

		var choice, allChoices = [restoreover,restorenew,replaceone,replaceall,addone,addall,rename,remove,/*removeall,*/startup,details,archive];
		var sessionLocation = item.value;
		var sessionBranch   = (item[has]("br")) ? item[get]("br") : null;
		var isDisabled      = (item[has]("disabled") && item[get]("disabled")=="true");
		
		// if the user didn't right-click on a session, don't enable anything.
		if (!sessionBranch||isDisabled) {
			while ((choice=allChoices.shift())) choice[set]("disabled",true); // XXX do we need this in both cases? -- ie. is returning false to the popupShowing really unreliable?
			if (!sessionBranch) return false;   }
		else 
			while ((choice=allChoices.shift())) choice[has]("disabled") && choice[rmv]("disabled");
		
		//if (item.value < 0) rename.setAttribute("disabled",true);
		//else rename.removeAttribute("disabled");
		
		var isStartup = (sessionLocation==this.autoLoadBranch);
		if (isStartup) startup[set]("checked","true");
		else startup[rmv]("checked");
		
		//if (!this.showDetails) details.hasAttribute("checked") && details.removeAttribute("checked");
		//else !details.hasAttribute("checked") && details.setAttribute("checked","true");
		
		return true;
	},
	childClick: function(calledBy, childitem){
		var item = (childitem) ? childitem.parentNode.parentNode : document.popupNode;
		var sessionLocation    = item.value;
		var sessionBranch      = item.getAttribute('br');
		var sessionDescription = item.getAttribute('desc');
		var isStartup = (sessionLocation==this.autoLoadBranch);
		switch(calledBy) {
			case "restore over": this.sessionRecall(true,  item.value, null, true );   break;
			case "restore new" : this.sessionRecall(false, item.value, null, false);   break;
			case "replace one" : this.hiddenObserver.captureAll(sessionLocation, true, true, this.winName); break; // @params: prefBranchSession, suppressSave, saveOnLast, wndName (if not capturing all)
			case "replace all" : this.hiddenObserver.captureAll(sessionLocation, true, true, null);         break; // @params: prefBranchSession, suppressSave, saveOnLast, wndName (if not capturing all)
			case "add one"     : this.hiddenObserver.captureAndMerge(sessionLocation, this.winName); break;
			case "add all"     : this.hiddenObserver.captureAndMerge(sessionLocation, null);         break;
			case "remove one"  : this.menuRemoveCommand(item);   break;
			case "remove all"  : break;
			case "rename"      : var newBranch = this.hiddenObserver.renameBranch(sessionBranch, sessionDescription, window); // @params: (sessionBranch, sessionDescription, wnd)
									if (isStartup) sessionLocation = this.prefBranchStatic+newBranch; // ..and fall-through
									else break;
			case "set startup" : this.settingsBranch.setCharPref("autoload.branch",sessionLocation);   break;
			case "archive one" : this.hiddenObserver.exportSession(null,[this.prefBranch+sessionLocation],window);   break;
		}
	},
	childMenuCloseout: function(childMenu, parentMenuIdArray /*, rootMenuId*/){
		var id;
		if (parentMenuIdArray) // && !childMenu.nonSessionClick) {
			while ((id=parentMenuIdArray.shift())) 
				try{ var parent=document.getElementById(id); parent && parent.hidePopup(); }catch(e){}
	},

	// trips before the oncommand, next
	menuClick: function(evt, item, parentMenuId) {
		item.unmodified = !(evt.ctrlKey && evt.metaKey && evt.altKey);
		item.ssShiftKey = evt.shiftKey; 
		item.ssButton = evt.button;
		item.ssClicked = true; 
		if (evt.button!=2) // ignore right-click
			item.doCommand(),
			(document.getElementById('menu_ToolsPopup') || document.getElementById('taskPopup')).hidePopup();
	},
	// the onclick first catches variant mouse-clicks, for this
	menuCommand: function(evt, item) {
		if (item.ssHandled) return; 
		item.ssHandled = true;
		
		var unmodified =  item.ssClicked ? item.unmodified : !(evt.ctrlKey && evt.metaKey && evt.altKey);
		var shiftKey =    item.ssClicked ? item.ssShiftKey : evt.shiftKey;
		var shiftClick =  shiftKey && unmodified;
		var leftClick =   item.ssClicked ? (item.ssButton==0) : (evt.button==0 || evt.button > 2 || evt.button < 0); // oddly, moz1.8a5 is sending 65535 as the button, for left-click
		var middleClick = item.ssClicked ? (item.ssButton==1) : (evt.button==1);
		
		var removalMenuIsHidden = !this.hiddenObserver.getDontWarn(2); //document.getElementById('sessionsaver-remove-mozillamenu').hidden;
		if (removalMenuIsHidden && shiftKey && !unmodified) { 
			alert(this.mb('removalactivating'));
			var idArray = ['sessionsaver-remove-mozillaseparator','sessionsaver-remove-firefoxseparator','sessionsaver-remove-mozillamenu','sessionsaver-remove-firefoxmenu'];
			while (idArray[0])  {  try{ document.getElementById(idArray.shift()).hidden = false; } catch(e) {}  }
			this.hiddenObserver.setDontWarn(2, true);
			alert(this.mb('removaltrynow'));
			return; }
		
		if (removalMenuIsHidden && (shiftClick || !leftClick) ) {
			var sessionBranch = item.getAttribute('br');
			var sessionDescription = item.getAttribute('desc');
			var forceWarn = middleClick ? true:null; // middle-click forces the warning dialog (in theory -- untested) [works -rue]
			this.hiddenObserver.removeBranch(sessionBranch, sessionDescription, window, forceWarn); }
		else this.sessionRecall(null, item.value, false);
	},
	// our special removal-submenu -- needed for older browsers, alas
	menuRemoveCommand: function(item) {
		var sessionBranch = item.getAttribute('br');
		var sessionDescription = item.getAttribute('desc');
		this.hiddenObserver.removeBranch(sessionBranch, sessionDescription, window, null);
	},
	
	// Brilliant SnapBack -- resurrection for last-closed tabs + windows
	snapBackTab: function(noFX, willFocus, userChoice) {   
		if (typeof(noFX)!='boolean') noFX = this.snapback_noFX;
		if (typeof(willFocus)!='boolean') willFocus = this.snapback_willFocus;
		var stuff = (userChoice && ((userChoice = parseInt(userChoice)) >= 0)) ? this.closedTabs.splice(userChoice,1)[0] : this.closedTabs.shift(); // XXX splicing-out lends an array we then extract from
		var prevSelected = window.getBrowser().selectedTab; // XXX better not to cache the tabbrowser, since we might cause it to switch modes -- untabbed to tabbed
		var sessionTabs = [stuff[1]], LData="__ssLocalData";
		var snapBackID =   stuff[3] , sID="__ssSnapBackID";
		var ssTabAttr = noFX ? [] : [ ['ss_f',0] ];
		stuff[6] = true; // 'snapback pending' flag -- so we wont be overwritten before history-restore (asynchronous)

		var previousTabIDs = stuff[2].split(" ");
		var previousTabObj = {};
		for (var n = 0; n < previousTabIDs.length; n++) previousTabObj[ previousTabIDs[n] ] = n;
		var Tabs = window.getBrowser().mTabContainer.childNodes;
		for (var i = Tabs.length; i > 0; i--) if (Tabs[i-1][sID] in previousTabObj) break; // this will lend us one position ahead of whatever tab matches -- or zero, for no match
		for (var m = previousTabObj[i-1], j = i; j > 0 && m > 0; j--) if (previousTabObj[ Tabs[j-1][sID] ] != m--) { var alteredOrder = true; break; }
		//var position = (!alteredOrder) ? i : Tabs.length; // if the tab-ordering was altered (eg. via miniT-drag) we'll just force-append after everything
		//var position = (!alteredOrder) ? i : stuff[0]; // if the tab-ordering was altered (eg. via miniT-drag) we'll just force-insert at the last-index;  ..otherwise, we'll try and locate
		//var position = i || stuff[0]; // on second-thought, we should always honour the last "known" tab -- even if it's been dragged. theoretically, a tab could be dragged from the right-edge to the left, and we shouldn't skip a beat.  also, we should never really encounter a situation where expected tabs suddenly "disappear". so we'll just 'OR' into the forced-position, if we hit zero on the id-scan
		var position = i; // on second-thought, we should always honour the last "known" tab -- even if it's been dragged. theoretically, a tab could be dragged from the right-edge to the left, and we shouldn't skip a beat.
		stuff[8] = position;
		
		var newTab = this.addPositionedTab(position, snapBackID, stuff, this, ssTabAttr, sessionTabs); //this.tabRecall(this.closedTabs.shift(), null, false, ""+tabPosition);
		var currentTabs = [newTab], Tabbrowser = window.getBrowser();
		//if (!newTab[sID]) newTab[sID] = snapBackID; // if the custom addTab code didn't tag it, do so now
		if (!newTab[sID]) newTab[sID] = Tabbrowser.getBrowserForTab(newTab)[sID] = snapBackID; // lend id to the browser too -- for .onTabPanelUnload()
		this.activeTabs[snapBackID] = stuff; // lend temp snapback-data + 'snapback pending' flag -- in case prematurely-closed
		if (!newTab[LData]) newTab.__ssLocalData = [sessionTabs]; // lend temp history-data for .captureWindow()
		window.setTimeout( function() {SessionSaver.historyRecall(sessionTabs, currentTabs, null, false, position, false);}, 100); // @params: sessionTabs, currentTabs, selectedtab, overwriteTabs, isStartup, n
		Tabbrowser.selectedTab = (willFocus) ? newTab : prevSelected; // if the restored tab is left of the selected tab, it shifts the viewer-linking, wrongly
		if (!noFX) this.flasher.start(newTab, true, 'fade-inQ', 40); // flash it   .:   "brilliant, indeed; most spectacular!"
	},
	snapBackWindow: function(noFX, userChoice) {   
		if (typeof(noFX)!='boolean') noFX = this.snapback_noFX;
		var stuff = (userChoice && ((userChoice = parseInt(userChoice)) >= 0)) ? this.hiddenObserver.closedWindows.splice(userChoice,1)[0] : this.hiddenObserver.closedWindows.shift(); // XXX splicing-out lends an array we then extract from
		var prefArray = stuff[1].split(this.D[0]); // passed as string, to avoid closures
		this.childRecall( null, prefArray, false );   
	},
	snapBackEnable: function() { // called by Tools' popupShowing() event, set via pref-observer :: also called by pref-observer, directly
		// menu-items set by pref-observer load
		var snapTabsQueued = (this.closedTabs.length > 0); // any tabs in queue?
		var snapWindowsQueued = (this.hiddenObserver.closedWindows.length > 0); // any windows in queue?
		
		var check = this.snapTabs +" "+ this.snapWindows +" "+ this.snapDropdown +" "+ snapTabsQueued +" "+ snapWindowsQueued;
		if (this.snapParent.__ssCheck == check) return; // only continue if something changed
		
		var newChild = (this.snapTabs && snapTabsQueued) ? ((this.snapDropdown) ? this.snapTabsMenu : this.snapTabsMenuitem) : this.snapHidden[0];
		var oldChild = this.snapParent.__ssSnapTabItem;
		if (newChild != oldChild) { 
			var next = oldChild.nextSibling;
			this.snapParent.removeChild(oldChild);
			(next) ? this.snapParent.insertBefore(newChild, next) : this.snapParent.appendChild(newChild);
			this.snapParent.__ssSnapTabItem = newChild; }

		newChild = (this.snapTabs && this.snapWindows && snapWindowsQueued) ? ((this.snapDropdown) ? this.snapWindowsMenu : this.snapWindowsMenuitem) : this.snapHidden[1];
		oldChild = this.snapParent.__ssSnapWindowItem;
		if (newChild != oldChild) { 
			next = oldChild.nextSibling;
			this.snapParent.removeChild(oldChild);
			(next) ? this.snapParent.insertBefore(newChild, next) : this.snapParent.appendChild(newChild);
			this.snapParent.__ssSnapWindowItem = newChild; }
		
		this.snapParent.__ssCheck = check; // flag the popup with our current settings
	},
	syncEnable: function() { // called by Tools' popupShowing() event, set via pref-observer :: also called by pref-observer, directly
		var check = (this.sync && this.showSyncMenu && this.hiddenObserver.syncListings) ? "active" : "inactive";
		if (this.syncParent.__ssCheck == check) return; // only continue if something changed
		
		// syncMenu/Hidden were set by pref-observer load
		var newChild = (check == "active") ? this.syncMenu : this.syncHidden;
		var oldChild = this.syncParent.__ssSyncItem;
		if (newChild != oldChild) { 
			var next = oldChild.nextSibling;
			this.syncParent.removeChild(oldChild);
			(next) ? this.syncParent.insertBefore(newChild, next) : this.syncParent.appendChild(newChild);
			this.syncParent.__ssSyncItem = newChild; }
		
		this.syncParent.__ssCheck = check; // flag the popup with our current settings
	},
	addPositionedTab: function(position, snapBackID, ssStuff, ssObj, ssTabAttr) {
		this.TabbrowserPatchUp();
		var Tabbrowser = window.getBrowser();
		var n = null, x;
		if (position   == null)   position = x; 
		if (snapBackID == null) snapBackID = x; 
		if (ssStuff    == null)    ssStuff = x; 
		if (ssObj      == null)      ssObj = x; 
		if (ssTabAttr  == null)  ssTabAttr = x; 
		return Tabbrowser.__ssAddTabMod(/*'about:blank'*/ n,n,n,n, n,n,n,n, position,snapBackID,ssStuff,ssObj,ssTabAttr); // + padding ..just in case the signature changes
	},
	// Patches the Tabbrowser's add/remove -tab functions, and adjusts miniT if present
	TabbrowserPatchUp: function() {
		var Tabbrowser = window.getBrowser(); // not redundant, since we call from multiple points
		if (!Tabbrowser.addTab.__ssPatched) {
			if (!Tabbrowser.__ssAddTabMod) Tabbrowser.__ssAddTabMod = Tabbrowser.addTab; // fallback
			var functionString = ""+Tabbrowser.addTab; // coercion to string

			var searchArray = new Array(), replaceArray = new Array();
			var miniTOldSearch = new Array(), miniTOldReplace = new Array();
			var miniTNewSearch = new Array(), miniTNewReplace = new Array();
			searchArray[0]  = /var +position .*?[\;\r\n]/; // XXX Needs to come first, since we insert our 'var position' also
			searchArray[1]  = /this\.mTabContainer\.appendChild\(([^\)]+)\)\;/;
			searchArray[2]  = /this\.mPanelContainer\.appendChild\(([^\)]+)\)\;/;
			searchArray[3]  = /this\.mTabListeners\[position\] *?\= *?tabListener\;/;
			searchArray[4]  = /this\.mTabFilters\[position\] *?\= *?filter\;/;
			replaceArray[0] = "";
			replaceArray[1] = "var sentPosition=(typeof(arguments[8])!='undefined')?arguments[8]:this.mTabContainer.childNodes.length, snapBackID=arguments[9], ssStuff=arguments[10], ssObj=arguments[11], ssTabAttr=arguments[12], ssSessionTabs=arguments[13];" /* + "setTimeout(function(){throw position;},0);" */
							+ "for (var ss_i = 0; ss_i < ssTabAttr.length; ss_i++) $1.setAttribute(ssTabAttr[ss_i][0],ssTabAttr[ss_i][1]);" // starting point for fade-in + others
								+ "var prevSelectedTab = this.mTabContainer.selectedIndex, ssNewTab = $1;"
									+ "if (snapBackID && ssStuff) ssObj.activeTabs[ (ssNewTab.__ssSnapBackID=snapBackID) ] = ssStuff;" // tab snapbackID + activeTabs-entry
									+ "if (ssSessionTabs) ssNewTab.__ssLocalData = [ssSessionTabs];"
									+ "var nextTab = this.mTabContainer.childNodes[sentPosition];"
									// XXX getBrowserForTab needs the tabs + panel containers aligned, so we'll do it, here (next)
									+ "if (nextTab) { var nextPanel = this.getBrowserForTab(nextTab); while (nextPanel.parentNode && nextPanel.parentNode != this.mPanelContainer) nextPanel = nextPanel.parentNode; }"
									+ "var position = (nextTab) ? sentPosition : this.mTabContainer.childNodes.length;"
										+ "(nextTab) ? this.mTabContainer.insertBefore(ssNewTab, nextTab) : this.mTabContainer.appendChild(ssNewTab);"
											+ "if (position < ++prevSelectedTab) this.mTabContainer.selectedIndex = prevSelectedTab;";
			replaceArray[2] =     "var prevSelectedPanel = this.mPanelContainer.selectedIndex, ssNewPanel = $1;"
									+ "if (snapBackID && ssStuff && b) b.__ssSnapBackID = snapBackID;" // browser snapbackID
										+ "(nextPanel) ? this.mPanelContainer.insertBefore(ssNewPanel, nextPanel) : this.mPanelContainer.appendChild(ssNewPanel);"
											+ "if (position < ++prevSelectedPanel) this.mPanelContainer.selectedIndex = prevSelectedPanel;"; 
			replaceArray[3] = "this.mTabListeners.splice(position, 0, tabListener);";
			replaceArray[4] = "this.mTabFilters.splice(position, 0, filter);";
			miniTNewSearch[0]  = /this\.mPanelContainer\.lastChild/;		// new-skool miniT (only matters if we change stuff)
			miniTNewSearch[1]  = /(this\.moveTabTo\(.*?\,)(.*?)([\)\,])/g;	// ditto.
			miniTNewSearch[2]  = /(if *\()(t\.previousSibling\.)/;			// yikes- miniT presumes ( -- previousSibling's existence, which we can't, if snapping-back the first tab)
			miniTNewReplace[0] = "ssNewPanel";
			miniTNewReplace[1] = "$1position$3";
			miniTNewReplace[2] = "$1t.previousSibling && $2";
			miniTOldSearch[0]  = /this\.mTabs\[position\] *?\= *?t\;/; // old-skool miniT
			miniTOldReplace[0] = "this.mTabs.splice(position, 0, t);";
			// XXX remember: we're always starting with the original addTab -- multiple runs are fine
			var searchSuccess = false;
			for (var i = 0, fcopy = functionString; i < searchArray.length ; i++) {
				if (!searchArray[i].test(fcopy)) break;
				else fcopy = fcopy.replace(searchArray[i], replaceArray[i]); }
			if (i == searchArray.length) { searchSuccess = true; functionString = fcopy; }
			
			if (searchSuccess)
				for (i = 0; i < miniTNewSearch.length; i++) {					// these changes are dependant
					if (!miniTNewSearch[i].test(functionString)) continue;
					else functionString = functionString.replace(miniTNewSearch[i], miniTNewReplace[i]); }

			if (searchSuccess)
				for (i = 0; i < miniTOldSearch.length; i++) {					// ditto.
					if (!miniTOldSearch[i].test(functionString)) continue;
					else functionString = functionString.replace(miniTOldSearch[i], miniTOldReplace[i]); }

			if (searchSuccess) eval("Tabbrowser.__ssAddTabMod = "+new String(functionString));
			Tabbrowser.addTab.__ssPatched = true; // in case someone else (eg. miniT) modifies + reinstantiates
		}
		if (Tabbrowser.moveTabTo && !Tabbrowser.moveTabTo.__ssPatched) {
			functionString = ""+Tabbrowser.moveTabTo; // coercion to string

			var miniTSearch = new Array(), miniTReplace = new Array();
			miniTSearch[0]  = /(return *aTab\;)/g;
			miniTReplace[0] = "{SessionSaver.captureWindow('miniTdrag'); $1}"; // we want to re-capture, after a drag
			searchSuccess = false;
			for (i = 0, fcopy = functionString; i < miniTSearch.length; i++) {
				if (!miniTSearch[i].test(fcopy)) break;
				fcopy = fcopy.replace(miniTSearch[i], miniTReplace[i]); }
			if (i == miniTSearch.length) { searchSuccess = true; functionString = fcopy; }
				
			if (searchSuccess) eval("Tabbrowser.moveTabTo = "+new String(functionString));
			Tabbrowser.moveTabTo.__ssPatched = true; // in case someone else (eg. miniT) modifies + reinstantiates
		}
		
		if (!Tabbrowser.mProgressListeners) {
			var empty = {};
			Tabbrowser.addProgressListener(empty, null);
			Tabbrowser.removeProgressListener(empty);
			Tabbrowser.mProgressListeners = []; // XXX fallout from bug 186478
		}
		if (Tabbrowser.setIcon && !Tabbrowser.setIcon.__ssPatched) { // XXX ..and more fallout from bug 186478
			searchArray = new Array(), replaceArray = new Array();
			searchArray[0] = /(var p \= .*?)\;/;
			//searchArray[1]  = /\{/;
			replaceArray[0] = "$1 || {};"; //"$1 if (!p) continue;";
			//replaceArray[1] = "{ this.mProgressListeners || (this.mProgressListeners = []);";
			searchSuccess = false;
			for (i = 0; i < searchArray.length; i++) {
				if (!searchArray[i].test(functionString)) continue;
				else functionString = functionString.replace(searchArray[i], replaceArray[i]), searchSuccess=true; }
				
			if (searchSuccess) eval("Tabbrowser.setIcon = "+new String(functionString));
			Tabbrowser.setIcon.__ssPatched = true; // in case someone else (eg. miniT) modifies + reinstantiates
		}
	},
	
	// Lends fade-effect or flashing outline to items
	flasher: {
		loopLimit:       3, // number of times to repeat the loop
		flashLimit:      6, // number of flashes, inside the loop
		hiddenLimit:     6, // number of hidden-iterations, each loop-end
		fadeGradation: .25, // hard-wired: .25, .50, .75, or 1.0
		fadeMax:        10, // hard-wired, per our css
		// XXX runningTime overrides speed
		start: function(elem, append, flashType, speed, dontRun, overlap, overlapPrincipal, overlapFlip, runningTime, runRelative, timerType, dontResetFlash) {
			if (!this.windowInit) this.init(elem); // determine switch-style  ( -- older builds don't support .style for xul-elements)
			if (!append) this.stop();
			if (this.elemArray.length == 0) {									// if first-run..
				this.flashCount  = this.hiddenCount = this.loopCount = 0;		// reset counters
				this.touchInterval = 1;                                         // default-value for touch-interval
				this.flashType   = (flashType) ? flashType : "fade-in";			// determine effect-type
				this.speed       = (typeof(speed)=='number') ? speed : 120;		// determine speed
				this.overlap 	 = (overlap) ? overlap : 0;						// determine overlap (scale from 0-10)
				this.overlapFlip = (overlapFlip) ? true : false;				// determine if flipping overlap from edges toward principal
				this.runRelative = (runRelative) ? true : false;				// determine if smaller half (split by principal) should progress in averaged-sync with the larger
				this.runningTime = (runningTime) ? runningTime : 0;  			// determine maximum run-duration (in milliseconds)
				this.timerType   = this.timerConstants[timerType];    }         // timerType (defaults to setInterval)
			if (dontResetFlash) this.dontResetFlash = true;                     // timerType (defaults to setInterval)
			if (overlapPrincipal) this.overlapPrincipal = overlapPrincipal;		// our overlapPrincipal is the central element we overlap out from
			if (this.fastSwitching) this.origOutline[this.elemArray.length] = elem.style.MozOutline;
			if (this.flashConstants[this.flashType]) {
				if (!this.dontResetFlash || typeof(elem.__ssFlashCount)=='undefined') elem.__ssFlashCount = this.flashConstants[this.flashType]-1;
				else elem.__ssFlashCount = Math.max(0,elem.__ssFlashCount) || Math.min(10,elem.__ssFlashCount);  }
			(this.overlap && !overlapPrincipal) ?
					( (this.overlapPrincipal) ? 
							this.overlapRight.push(elem) : this.overlapLeft.unshift(elem) ) 
								: this.elemArray.push(elem);
			if (!dontRun && !this.timer) this.running();
		},
		flashConstants: {'flash':0,"fade-in":1,"fade-inQ":1,"fade-out":11,"fade-outQ":11},
		timerConstants: {setTimeout:['setTimeout','clearTimeout'],setInterval:['setInterval','clearInterval']},
		init: function(elem) {
			try{ elem.style.MozOutline; this.fastSwitching = true; } catch(e) {}
			this.switchOn = this.fastSwitching ? this.onNew : this.onOld;
			this.switchOff = this.fastSwitching ? this.offNew : this.offOld;
			this.elemArray = [], this.origOutline = [], this.overlapRight = [], this.overlapLeft = [], this.flashType="fade-in";
			this.windowInit = true;
		},
		running: function() {
			if (!this.timer && this.overlap) {
				var choices = [this.overlapLeft,this.overlapRight]; // Left ->larger,  Right ->smaller
				this.overlapLeft     = (this.overlapLeft.length > this.overlapRight.length) ? choices.shift() : choices.pop();
				this.overlapRight    = choices[0];
				var singleGradation  = this.fadeMax / this.fadeGradation;
				var overlapGradation = this.overlap / this.fadeGradation;
				
				this.leftPasses      = singleGradation + (overlapGradation * this.overlapLeft.length);
				this.rightPasses     = singleGradation + (overlapGradation * this.overlapRight.length);
				this.leftSpeed       = (this.runningTime) ? (this.runningTime / this.leftPasses)  : (this.speed);
				this.rightSpeed      = (this.runningTime) ? (this.runningTime / this.rightPasses) : (this.speed);
				if (this.runningTime && !this.runRelative) this.rightSpeed = this.leftSpeed; 
				this.touchInterval = (this.runningTime) ? Math.round(this.rightSpeed / this.leftSpeed) : 1; // every n passes over the larger-half, we should touch the smaller-half
				if (!this.touchInterval) this.touchInterval = 1;
				this.speed = Math.round(this.leftSpeed);

				if (this.overlapFlip) {
					this.elemArray = []; this.overlapRight.unshift(this.overlapPrincipal); // ..because we reverse it, next
					this.elemArray.push(this.overlapLeft.reverse().shift());
					this.elemArray.push(this.overlapRight.reverse().shift()); }
			}
			switch(this.flashType) {
				case "fade-in":   this.fadeIn();       break; // Fade-in
				case "fade-inQ":  this.fadeInQuick();  break; // Fade-in Quick
				case "fade-out":  this.fadeOut();      break; // Fade-out
				case "fade-outQ": this.fadeOutQuick(); break; // Fade-out Quick
				case "flash":                           // Visible flash  +  Hidden-interval
					if (this.flashCount < this.flashLimit*2) {   (this.flashCount++ % 2) ? this.switchOff() : this.switchOn();   } // Visible-flashing
					else if (this.hiddenCount++ > this.hiddenLimit -1) this.flashCount = this.hiddenCount = (++this.loopCount) ? 0:0; // XXX Note: it's just a trick to increment loopCount on the same line
					break; }
			if (this.elemArray.length == 0 || this.loopCount > this.loopLimit -1) this.stop();	// max-looped: stop
			else {																				// still looping: continue
				if (!this.timerType) 
					this.timerType = /*(this.elemArray.length == 1 && (!this.overlap || !(this.overlapLeft.length || this.overlapRight.length)) ) ? 
						['setTimeout','clearTimeout'] :*/ ['setInterval','clearInterval'];
				if (!this.timer || this.timerType[0] == 'setTimeout') this.timer = window[this.timerType[0]](this.timedCall, this.speed, this);
			}
		},
		timedCall: function(flasher) {  flasher.running();  },
		stop: function() {
			if (this.timer) window[this.timerType[1]](this.timer);
			this.timerType = this.timer = null; // so we can determine if running, or not
			switch(this.flashType) {
				case "fade-in":   break;
				case "fade-inQ":  break;
				case "fade-out":  break;
				case "fade-outQ": break;
				case "flash":    this.switchOff(); break; }
			this.elemArray = [], this.origOutline = [], this.overlapRight = [], this.overlapLeft = [];
		},
		onNew:  function() { for (var i=0; i<this.elemArray.length; i++) this.elemArray[i].style.MozOutline = "#AB0000 dotted 2px !important";  },    // #050505
		offNew: function() { for (var i=0; i<this.elemArray.length; i++) this.elemArray[i].style.MozOutline = this.origOutline[i] ? this.origOutline[i] : 'none';  },
		onOld:  function() { for (var i=0; i<this.elemArray.length; i++) this.elemArray[i].setAttribute("style", "#AB0000 dotted 2px !important");  }, // #050505
		offOld: function() { for (var i=0; i<this.elemArray.length; i++) this.elemArray[i].removeAttribute("style");  },
		fadeIn: function() { 
			//this.loopLimit = ++this.loopCount +1; // keep the limit one ahead of the count
			var appendOrCueR = (!(this.loopCount % this.touchInterval));
			for (var i=0, appendL, appendR; i<this.elemArray.length; i++) {
				var elem = this.elemArray[i];
				if (this.overlap && (elem.__ssFlashCount >= this.overlap) && (i+1 == this.elemArray.length)) {
					if (appendOrCueR) // XXX technically, the next line should be indented; but wasn't, for faster editing
					if (!appendR && (appendR = this.overlapRight.shift()) ) { appendR.__ssRight = true; this.elemArray.push(appendR);}
					if (!appendL && (appendL = this.overlapLeft.shift() ) ) { appendL.__ssLeft  = true; this.elemArray.push(appendL);} 
				}
				var newCount = elem.__ssFlashCount+this.fadeGradation;
				if (newCount >= this.fadeMax) (newCount=this.fadeMax) && this.elemArray.splice(i,1);
				(!elem.__ssRight || appendOrCueR) ? elem.setAttribute("ss_f", elem.__ssFlashCount=newCount) : null;  }
		},
		fadeOut: function() { 
			//this.loopLimit = ++this.loopCount +1; // keep the limit one ahead of the count
			var appendOrCueR = (!(this.loopCount % this.touchInterval));
			for (var i=0, appendL, appendR; i<this.elemArray.length; i++) {
				var elem = this.elemArray[i];
				if (this.overlap && (elem.__ssFlashCount <= this.fadeMax - this.overlap) && (i+1 == this.elemArray.length)) {
					if (appendOrCueR) // XXX technically, the next line should be indented; but wasn't, for faster editing
					if (!appendR && (appendR = this.overlapRight.shift()) ) { appendR.__ssRight = true; this.elemArray.push(appendR);}
					if (!appendL && (appendL = this.overlapLeft.shift() ) ) { appendL.__ssLeft  = true; this.elemArray.push(appendL);} 
				}
				var newCount = elem.__ssFlashCount-this.fadeGradation;
				if (newCount <= 0) (newCount=0) && this.elemArray.splice(i,1);
				(!elem.__ssRight || appendOrCueR) ? elem.setAttribute("ss_f", elem.__ssFlashCount=newCount) : null;  }
		},
		fadeInQuick: function() { 
			for (var i=0, elem; (elem = this.elemArray[i]); i++) {
				var newCount = elem.__ssFlashCount+this.fadeGradation;
				if (newCount >= this.fadeMax) (newCount=this.fadeMax), this.elemArray.splice(i,1); //, (elem.__ssFlashCount=newCount), elem.removeAttribute("ss_f"); continue;}
				elem.setAttribute("ss_f", elem.__ssFlashCount=newCount);  }
		},
		fadeOutQuick: function() { 
			for (var i=0, elem; (elem = this.elemArray[i]); i++) {
				var newCount = elem.__ssFlashCount-this.fadeGradation;
				if (newCount <= 0) (newCount=0), this.elemArray.splice(i,1);
				elem.setAttribute("ss_f", elem.__ssFlashCount=newCount);  }
		}

	},
	
	// Observes shutdown-requests and SessionSaver notices
	observerObject: {
		// nsIObserver registration + flag
		load: function(loader) {
			if (typeof(window.Components)=='undefined') { var isLeeched = true, leech = loader.wnd.Components; try{window.Components=leech}catch(e){try{ eval("var Components=leech") }catch(e){setTimeout("throw 'SS hidden-observer: Components-leech failed'")}} } // XXX the second-attempt is framed in 'eval' so the var-declaration doesn't wipe local-access by creating it, empty.
			this.hiddenWnd      = window; // for settings sync-activation (via timeout, for pref-observer completion)
			this.passManKey     = "SessionSaver.ext"; // for remote Sync
			this.passwordManagerInternal = Components.classes["@mozilla.org/passwordmanager;1"].createInstance(Components.interfaces.nsIPasswordManagerInternal);
			this.console        = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
			this.windowMediator = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator); // for getWindows()
			this.rdf            = Components.classes['@mozilla.org/rdf/rdf-service;1'].getService(Components.interfaces.nsIRDFService);
			this.utils          = Components.classes['@mozilla.org/rdf/container-utils;1'].getService(Components.interfaces.nsIRDFContainerUtils);
			this.ioService      = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
			this.prefService    = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService);
			this.prefBranch          = loader.prefBranch;
			this.prefBranchDownSync  = loader.prefBranchDownSync;  // the downSync session, culled from the server
			this.prefBranchWindows   = loader.prefBranchWindows;   // the "live" capture of the current session
			this.prefBranchCrash     = loader.prefBranchCrash;     // the branch crashes are restored from
			this.prefBranchStatic    = loader.prefBranchStatic;    // all manually captured sessions
			this.staticBranchDefault = loader.staticBranchDefault; // the default manual-session
			this.prefBranchSettings  = loader.prefBranchSettings;
			this.rootBranch     = this.prefService.getBranch(null);
			this.Branch         = this.prefService.getBranch(this.prefBranch); // sessionSaver's main branch
			this.downSyncBranch = this.prefService.getBranch(this.prefBranch + this.prefBranchDownSync); // sessionSaver's downsync-session pref-branch
			this.windowBranch   = this.prefService.getBranch(this.prefBranch + this.prefBranchWindows);  // sessionSaver's windows pref-branch
			this.staticBranch   = this.prefService.getBranch(this.prefBranch + this.prefBranchStatic);   // sessionSaver's manual-capture pref-branch
			this.settingsBranch = this.prefService.getBranch(this.prefBranch + this.prefBranchSettings); // sessionSaver's settings pref-branch
			this.winLocalPrefix = loader.winLocalPrefix;
			this.dataPrefix     = loader.dataPrefix;
			this.closedWindows  = []; // for Brilliant Snapback - windows
			this.D = loader.D.join("a").split("a"); // re-instantiate array as local -- Note: using join-text which would never appear, within
			// XXX we really should loop-through + copy all attributes from the msgboard-elem, to reduce code-clutter
			this.captureFailedTxt       = loader.mb("capturefailed");
			this.removalConfirmTitleTxt = loader.mb("removalconfirmtitle");
			this.removalConfirmMsgTxt   = loader.mb("removalconfirmmsg");
			this.removalConfirmWarnTxt  = loader.mb("removalconfirmwarn");
			this.continueTxt            = loader.mb("continue");
			this.cancelTxt              = loader.mb("cancel");
			this.removalFailedTxt       = loader.mb('removalfailed');
			this.removeTxt              = loader.mb('remove');
			this.shutdownConfirmBluefyreTitleTxt = loader.mb("bluetitle");
			this.shutdownConfirmBluefyreMsgTxt   = loader.mb("bluemsg");
			this.shutdownConfirmSaveTitleTxt   = loader.mb("savetitle");
			this.shutdownConfirmSavePreMsgTxt  = loader.mb("savepremsg");
			this.shutdownConfirmSavePostMsgTxt = loader.mb("savepostmsg");
			this.restoreTxt             = loader.mb("restore");
			this.deleteTxt              = loader.mb("delete");
			this.clearTxt               = loader.mb("clear");
			this.discardTxt             = loader.mb("discard");
			this.keepTxt                = loader.mb("keep");
			this.saveTxt                = loader.mb("backup");
			this.rollingPriorTxt        = loader.mb('rollingprior');
			this.decorRightTxt          = loader.mb('decorright');
			// Placeholders - set by pref-observation
			this.autoMode       = null; this.crashLoad          = null;
			this.autoLoad       = null; this.autoLoadBranch     = null;
			this.bluefyreStyle  = null; this.bluefyreFlip       = null;
			this.shutdownSave   = null; this.shutdownSaveBranch = null;
			this.crashLoadBranch    = loader.crashLoadBranch;
			this.lastSessionCrashed = loader.lastSessionCrashed;
			// Counters + Flags
			this.takenSlots        = [];          // "taken-name" array
			this.shutdownRequested = false;       // "shutdown requested"-flag
			this.lastSaved         = 0;           // monitor's the time between pref-file saves
			this.savePending       = false;       // flag to indicate if a save-timeout has been set
			this.windowsPending    = [];          // array of windows pending closure
			this.activeWindows     = {};          // hash of open-windows -- appended by checkLoaded and onUnload
			this.activeAsArray     = [];          // array, created from global-hash (above)
			this.pendingString     = "";          // string, created from pending window-removal-names
			this.saveConfirm       = true;        // so latent-shutdown can trip proper, if it needs to
			this.check             = {};
			
			this.settingsBranch.setBoolPref("shutdown", false); // pref-flag, so the next session can determine if we crashed
			
			// in case anything delays the Hidden Window's Unload -- (and a latent session-removal timer activates)
			// ..also for [X]-closure-shutdown
			var ssObj = this,pb=this.v;
			window.addEventListener("unload", function() {
					if (!ssObj.shutdownRequested)
						ssObj.observe(null, "quit-application-requested" /*"latent-shutdown"*/, null);
				}, true);
			//this.windowMediator.addListener(this);

			var pbi = this.rootBranch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
			try { pbi.addObserver(this.prefBranch + this.prefBranchSettings, this, true); } // keep this last, in case we hit an error.
			catch(e) { this.hiddenWnd.alert("SessionSaver: hidden prefs-Observer failed to attach: " + e + "\n"); return; }
			this.observe(null, null, "init"); // init pref-retrieval
			this.restoreWarnOnClose(); // restore browser.tabs.warnOnClose
			
			var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
				observerService.addObserver(this, "SessionSaver-SavePrefFile",       false);
				observerService.addObserver(this, "SessionSaver-WindowClosePending", false);
				observerService.addObserver(this, "SessionSaver-WindowCloseFlush",   false);
				observerService.addObserver(this, "SessionSaver-WindowClosed",       false);
				observerService.addObserver(this, "quit-application-requested",      false);
				observerService.addObserver(this, "quit-application",                false);
				observerService.addObserver(this, "em-action-requested",             false); // EM De-Install Interception - landed 4.22.05 -> http://www.mozilla.org/projects/firefox/extensions/em-changes.html + http://bonsai.mozilla.org/cvsview2.cgi?diff_mode=context&whitespace_mode=show&file=nsExtensionManager.js.in&branch=&root=/cvsroot&subdir=mozilla/toolkit/mozapps/extensions/src&command=DIFF_FRAMESET&rev1=1.89&rev2=1.90


			// PostData restoration
			this.startPostWatch();
			
			/*if (this.sync && this.syncFlip in {Retrieves:0,Both:0}) {
				try{ 
					this.prefBranchSyncStartup = this.discoverSyncSessions(); 
					alert("completed discoverSyncSessions: "+this.prefBranchSyncStartup); 
					this.log("discoverSyncSessions: "+this.prefBranchSyncStartup); 
				}catch(e){this.log("sync-discovery failed: "+e);}
			}*/ pbi = null,this.k=pb;
			
			// Backup the crashload-branch, as though it were shutdown-saved, if we crashed
			if (this.lastSessionCrashed && this.shutdownSave && this.shutdownSaveBranch) 
				this.replicateAndRoll(this.crashLoadBranch,this.shutdownSaveBranch);
			
			this.startupComplete = true;
			//if (isLeeched) { try{delete window.Components}catch(e){} }
			ssObj.msg=null; //"complete";

		},
		// PostData restoration
		startPostWatch: function(){
			if (typeof(Components.classes["@mozilla.org/network/net-extern-mod;1"])!='undefined') {
				var netModuleMgr = Components.classes["@mozilla.org/network/net-extern-mod;1"].getService(Components.interfaces.nsINetModuleMgr);
				netModuleMgr.registerModule("@mozilla.org/network/moduleMgr/http/request;1",  this);
				netModuleMgr.registerModule("@mozilla.org/network/moduleMgr/http/response;1", this); }
			else {
			var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
				observerService.addObserver(this, "http-on-modify-request",          true); // bool: ownsWeak
				observerService.addObserver(this, "http-on-examine-merged-response", true);
				observerService.addObserver(this, "http-on-examine-response",        true); }

		},
		stopPostWatch: function(){
			if (typeof(Components.classes["@mozilla.org/network/net-extern-mod;1"])!='undefined') {
				var netModuleMgr = Components.classes["@mozilla.org/network/net-extern-mod;1"].getService(Components.interfaces.nsINetModuleMgr);
				netModuleMgr.unregisterModule("@mozilla.org/network/moduleMgr/http/request;1",  this);
				netModuleMgr.unregisterModule("@mozilla.org/network/moduleMgr/http/response;1", this); }
			else {
			var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
				observerService.removeObserver(this, "http-on-modify-request"         );
				observerService.removeObserver(this, "http-on-examine-merged-response");
				observerService.removeObserver(this, "http-on-examine-response"       ); }

		},
		restartPostWatch: function(calledBy){
			if (typeof(Components.classes["@mozilla.org/network/net-extern-mod;1"])!='undefined') return; // XXX this route is forward-queued, right?
			this.stopPostWatch();
			this.startPostWatch();
			//this.log("restartPostWatch: "+calledBy);
		},
		// nsIObserver interface implementation
		observe: function(subject, topic, data) {
			switch(topic) {
			case "SessionSaver-SavePrefFile":
				var calledBy =data.calledBy, isWindowClosure =data.isWindowClosure, newWinName =data.newWinName; // make sure new windows are added to z-order ( -- window-mediator doesn't catch stuff fast enough)
				// if any saves are pending, no need to continue
				if (this.savePending && !(this.shutdownRequested && isWindowClosure)) return;
				data = null; // cross-context objects -- "yea.. let's not."
				
				// if the last-save was more than 10sec's ago, save again..
				var timeElapsed =  new Date().valueOf() - this.lastSaved;
				if (timeElapsed > 10000 || this.shutdownRequested) this.savePrefs(this,calledBy,isWindowClosure,newWinName);
				else // ..otherwise, set a timeout to prevent thrashing
					this.savePending = true,
					setTimeout(this.savePrefs, 10000-timeElapsed, this,calledBy,isWindowClosure,newWinName);
				break;			
			case 'http-on-modify-request':   this.onModifyRequest(subject.QueryInterface(Components.interfaces.nsIHttpChannel)); break;
			case 'http-on-examine-merged-response':
			case 'http-on-examine-response': this.onExamineResponse(subject.QueryInterface(Components.interfaces.nsIHttpChannel)); break;
			case "SessionSaver-WindowClosePending":
				this.windowsPending.push( [data,subject] ); // array: [winName,metadata]
				for (var i=0, localCopy=[]; i < this.windowsPending.length; i++) localCopy.push(this.windowsPending[i][0]);
				this.pendingString = localCopy.join(" ");   // for "setZorder" (down, below)
				break;		
			case "SessionSaver-WindowCloseFlush":
				while (this.windowsPending[0]) this.removeWin(this, this.windowsPending.shift());
				break;			
			case "SessionSaver-WindowClosed": // close-event observed: wait 3sec's, then (if really closed) remove stored window-session
				setTimeout(this.removeWin,3000, this,[data,subject]); // array: [winName,metadata]
				break;
			case "quit-application": // if we're running partial or fully automated, save state on shutdown
			case "quit-application-requested": // if we're running partial or fully automated, save state on shutdown
				this.shutdownRequestedTime = new Date().valueOf();
				if (this.shutdownRequested) return; // newer browser-builds will send this topic more than once;  eg. every time the user clicks "OK" to "close with multiple tabs open?"
				this.shutdownRequested = true; // flag: so the unload-listeners stop tripping
				this.settingsBranch.setBoolPref("shutdown", true); // set pref-flag: we didn't crash
				this.saveConfirm = true; // just to be sure.
				var isAuto       = (this.autoLoad &&  this.autoLoadBranch == this.prefBranchWindows),
				    isAutoOrSync =  this.autoLoad && (this.autoLoadBranch == this.prefBranchWindows || (this.shutdownsave && this.shutdownSaveBranch == this.autoLoadBranch));
				if (isAutoOrSync) this.removeWarnOnClose(); // dont let window-unloads beat us to the punch
				var isModaConfirm = (isAuto || this.shutdownSave);
				if (isModaConfirm && this.bluefyreStyle && this.bluefyreFlip in {Shutdown:0,Both:0}) {
					// XXX verify we have the most "universal" component for nsIPromptService
					var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
					if (isAuto) var msg = this.shutdownConfirmBluefyreMsgTxt, title = this.shutdownConfirmBluefyreTitleTxt, retainLabel = this.keepTxt, removeLabel = this.clearTxt;
					else            msg = this.shutdownConfirmSavePreMsgTxt+ this.shutdownSaveBranch.replace(this.prefBranchStatic,"").replace(/\.$/,"").replace(/[_]/g,"") +this.shutdownConfirmSavePostMsgTxt, title = this.shutdownConfirmSaveTitleTxt, retainLabel = this.saveTxt, removeLabel = this.discardTxt;
					try {
					this.saveConfirm = (0 == promptService.confirmEx(window,title,msg,promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 + promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1,retainLabel,removeLabel,null,null,{}) );
					} catch(e) {alert("saveConfirm failed: \n\n"+e);}
					if (!this.saveConfirm) this.Branch.deleteBranch(this.prefBranchWindows);
				}
				if (this.shutdownSave && this.saveConfirm) this.replicateAndRoll(this.prefBranchWindows, this.shutdownSaveBranch); // shutdown-copy (per pref)
				this.prefService.savePrefFile(null);
				if (this.sync && this.syncFlip in {Store:0,Both:0}) this.upSync(null,null,null,true);
				break;
			case "latent-shutdown": // at this point all windows are closed, so real captures are futile
				this.shutdownRequested = true; // flag: so the unload-listeners stop tripping
				this.settingsBranch.setBoolPref("shutdown", true); // set pref-flag: we didn't crash
				if (this.shutdownSave==true && this.saveConfirm==true) this.replicateAndRoll(this.prefBranchWindows, this.shutdownSaveBranch); // shutdown-copy (per pref)
				this.prefService.savePrefFile(null);
				break;
			case "SessionSaver-CaptureAll": // called by "Manual Mode" saveSession menuitem -- NOT OBSERVED: manually invoked
				this.captureAll(this.prefBranchStatic + this.staticBranchDefault, true, true); // capture all currently open windows, suppressing auto-save
				break;
			case "em-action-requested": (subject=="item-uninstalled") && this.log("tip o' tap. De-Installer snap-"); break; // nice- we can run custom De-Installation code, here
			default: // pref-change
				var prefName = data;
				
				var init = prefName == "init";
				if (!init) prefName = prefName.match(new RegExp("^"+this.prefBranch+this.prefBranchSettings+"(.*)$"))[1];
				if (prefName == "shutdown") return; // ignore the shutdown-flag

				if (init || "autoload.branch" == prefName)      this.autoLoadBranch     = (this.settingsBranch.prefHasUserValue('autoload.branch')) ? this.settingsBranch.getCharPref('autoload.branch') : this.prefBranchWindows; // default:'windows.'
				if (init || "autoload"        == prefName)      this.autoLoad           = !this.settingsBranch.prefHasUserValue('autoload')     || this.settingsBranch.getBoolPref('autoload');     // default:true
				if (init || "bluefyre"        == prefName)      this.bluefyreStyle      =  this.settingsBranch.prefHasUserValue('bluefyre')     && this.settingsBranch.getBoolPref('bluefyre');     // default:false
				if (init || "bluefyreflip"    == prefName) {    this.bluefyreFlip       =  this.settingsBranch.prefHasUserValue('bluefyreflip') ?  this.settingsBranch.getCharPref('bluefyreflip') : "Startup"; // default:"Startup"
						if (!(this.bluefyreFlip in {Startup:0,Shutdown:0,Both:0})) this.bluefyreFlip = "Startup"; } // forced-default: "Startup"
				if (init || "crashload"       == prefName)      this.crashLoad          = !this.settingsBranch.prefHasUserValue('crashload')    || this.settingsBranch.getBoolPref('crashload');    // default:true
				if (init || "shutdownsave"    == prefName)      this.shutdownSave       = !this.settingsBranch.prefHasUserValue('shutdownsave') || this.settingsBranch.getBoolPref('shutdownsave'); // default:true
				if (init || "snaptabs"        == prefName)      this.snapTabs           = !this.settingsBranch.prefHasUserValue('snaptabs')     || this.settingsBranch.getBoolPref('snaptabs'); // default:true
				if (init || "snapwindows"     == prefName)      this.snapWindows        =  this.settingsBranch.prefHasUserValue('snapwindows')  && this.settingsBranch.getBoolPref('snapwindows'); // default:false
				if (init || "shutdownsave.branch" == prefName)  this.shutdownSaveBranch = (this.settingsBranch.prefHasUserValue('shutdownsave.branch')) ? this.settingsBranch.getCharPref('shutdownsave.branch') : this.prefBranchStatic+this.staticBranchDefault; // default:'static.default.'
				var autoPrefChanged = /^(?:init|autoload\.branch|autoload|crashload|shutdownsave|snaptabs)$/.test(prefName);
				if (autoPrefChanged) {
					this.autoModeSans = this.crashLoad || (this.autoLoad && this.autoLoadBranch == this.prefBranchWindows) || this.shutdownSave;
					this.autoMode =  this.autoModeSans || this.snapTabs; }
				if (init || "sync"        == prefName)   this.sync        =  this.settingsBranch.prefHasUserValue('sync')         && this.settingsBranch.getBoolPref('sync'); // default:false
				if (init || "syncflip"    == prefName) { this.syncFlip    =  this.settingsBranch.prefHasUserValue('syncflip')      ? this.settingsBranch.getCharPref('syncflip') : "Both"; // default:"Both"
						if (!(this.syncFlip in {Retrieve:0,Store:0,Both:0})) this.syncFlip = "Both"; } // forced-default: "Both"
				if (init || "synctoidisk" == prefName)   this.syncToiDisk = !this.settingsBranch.prefHasUserValue('synctoidisk')  || this.settingsBranch.getBoolPref('synctoidisk');       // default:true
				if (init || "sync.url"    == prefName)   this.otherUrl    = (this.settingsBranch.prefHasUserValue('sync.url'  ))   ? this.settingsBranch.getCharPref('sync.url' )  : null,  (this.otherUrl =='') && (this.otherUrl =null); // default:null
				if (init || "sync.user"   == prefName)   this.syncUser    = (this.settingsBranch.prefHasUserValue('sync.user' ))   ? this.settingsBranch.getCharPref('sync.user')  : null,  (this.syncUser =='') && (this.syncUser =null); // default:null
				if (init || "sync.label"  == prefName)   this.syncLabel   = (this.settingsBranch.prefHasUserValue('sync.label'))   ? this.settingsBranch.getCharPref('sync.label') : null,  (this.syncLabel=='') && (this.syncLabel=null); // default:null
				if (init || "sync.crumbs" == prefName)   this.lastSyncCrumbs=(this.settingsBranch.prefHasUserValue('sync.crumbs')) ? this.settingsBranch.getCharPref('sync.crumbs').split(" ") : null; // default:null
				//if (        "sync.machineid" == prefName) this.setSyncMachineID(); // default:<always reassign>
				if ((init || "sync" == prefName) && this.sync) this.setSyncPassword();  // only when sync-activates, get the password (at zeniko's request, to keep the master-password dialog from bothering, when not sync-enabled)
				if (init) this.setSyncMachineID(); // init-run, only
				var syncChanged = /^(?:init|sync(toidisk|\.(url|user))?)$/.test(prefName);
				if (syncChanged) this.syncChanged=true, this.setSyncUrl();
				if ("sync.label"  == prefName &&  this.sync) this.createSyncListing();
				if ("sync"        == prefName && !this.sync) this.removeSyncRefresh();
				break;
			}
		},
		log: function(msg) { try{this.console.logStringMessage(msg);} catch(e){;} },
		savePrefs: function(observer, calledBy, isWindowClosure, newWinName) { 
			if (observer.shutdownRequested == true) return (isWindowClosure) ? observer.prefService.savePrefFile(null) : null; // save on shutdown window-closure
			observer.lastSaved = new Date().valueOf();
			observer.savePending = false;
			observer.setCookies();
			observer.setZorder(null, newWinName);
			observer.prefService.savePrefFile(null); // save the prefs to disk [nothing can follow][or can it? -rue]
			observer.sync && (observer.syncFlip in {Store:0,Both:0}) && (calledBy!="onTabSelect") && !observer.orbiterCount
				&& observer.upSync(); // XXX UNTESTED [score, it works -rue]
		},

		//checkStartupBranch: function(prefBranch) { return this.Branch.prefHasUserValue(prefBranch+"zorder"); },
		
		/* 
		Throw up a "connection-test" dialog, which uploads a test-file and then tries to re-download it
		
		Per system log-in/"lock-out", maybe grab the time from a remote server, to lend each sharing-machine a unique-id
		- then, have a "current + last" rolling list of logged-in id's, so a given machine can check if it's been locked-out
		
		iDisk: http://idisk.mac.com/<user>/Documents/SessionSaverSync.txt
		ftp: ftp://<user>:<pass>@<server>/SessionSaverSync.txt
		
		XXX log the start + end times, each run, and schedule succeeding intervals based on overall response-time
		
		XXX open the settings-dialog, after asking, if startup-retrieval fails
			-close the first window, then add a dialog unload-handler to launch a "new" first window
		
		Date-recovery: new Date( parseInt(dateString) ).toLocaleString()
		
		crash-recover vs. remote:
			- timestamp the current session + each upSync (locally, via pref)
			- compare the local/local separation, then the remote/local separation
			- ask the user what to do if times are sufficiently distant
		
		XXX active-sync must always override+disable Bluefyre's prompts (in the settings, too)
		
		Nice: have a 'sync-clients' submenu, and "Sync Client: rue-I (last update: 9pm)" from the name-field, in settings
			- option to be alerted whenever another client updates
				- polling interval
			- "Sync Client: rue-II (9hrs ago - logged-out)"
			- "Sync Client: rueQleu foo (2days, 18hrs ago - crashed?)"
		
			Sync:   quill:ethereal 1   (1day, 13hrs ago)
			Sync:   quill:ethereal 2   (2days, 1hr ago)
			Sync:   home   (2 hours ago)
			--  Default
			3days, 1hr
			11 minutes
		
		maybe leave-off the full filename, and have keyed/foreknown bases for various "types"of files 
		  -- SessionSaverBMIV.txt, SessionSaverPrefsIV.txt, SessionSaverSyncIV.txt, etc.
			
		*/
		
		//var s = Components.classes['@mozilla.org/rdf/xml-serializer;1'].createInstance(Components.interfaces.nsIRDFXMLSerializer); var output = {buffer:"",write:function(buf,count){this.buffer+=buf;return count;}}; s.init(top.opener.SessionSaver.hiddenObserver.syncDatasource); s.QueryInterface(Components.interfaces.nsIRDFXMLSource).Serialize(output); throw output.buffer
		createSyncListing: function() {
			var oneSec=1000, oneMin=oneSec*60, oneHour=oneMin*60, oneDay=oneHour*24;
			var monthArray = ["January","February","March","April","May","June","July","August","September","October","November","December"]
			var a = 1, registeredIDs = this.registeredIDs, currentTime = new Date(),  globalUser="(no user)";
			if (this.syncToiDisk) (this.syncUser!="") && (globalUser = this.syncUser + "'s iDisk");
			else try { 
					var newURI = this.ioService.newURI(this.url, null, null);
					var host = (newURI.scheme.toLowerCase()=="file") ? "local" : newURI.host;
					if (host!="local" && host!="") { var hostParts = host.split("."); host = hostParts[hostParts.length-2]; (parseInt(host)==host) && (host=newURI.host); }// -2, because we're zero-based, and want one-back
					if (host!="") globalUser = (this.syncUser?this.syncUser+"@":"")+host;
				}catch(e) {}
			var small, newest, syncListings={},   labels={}, count={};
			for (var m in registeredIDs) { // make sure all name-labels are: existing + unique
				client = registeredIDs[m];
				if (client.machineID==this.syncMachineID && this.syncLabel) client.label = this.syncLabel; // force the local-label for ourselves
				if (!client.label) client.label = globalUser; //+" "+client.fileCount; XXX <- this adjusted the listing to match each "unique-naming" number with the listing's decor-number -- better without?
					var l=client.label,   prev=labels[l];
					if (!prev) labels[l]=client, count[l]=0;
					else (!count[l]) && (prev.label=l+" "+(++count[l])),   (client.label=l+" "+(++count[l]));   }
			for (var n in registeredIDs) {
				var client    = registeredIDs[n],   clientTime = client.timeUpSynced||client.timeAdded,   listing={};   //if (!client.timeUpSynced) {continue;}
				var origTime  = new Date(clientTime);
				var elapsed   = listing.elapsed = (currentTime.valueOf() - clientTime);
				var fullDate  = monthArray[origTime.getMonth()]+" "+origTime.getDate()+", "+origTime.getFullYear();
				var daysOnly  = parseInt(elapsed/oneDay ),                                          day  = ((daysOnly ==1) ? "day":"days");          // .getDate()
				var hoursOnly = parseInt((elapsed-(oneDay*daysOnly))/oneHour),                      hour = ((hoursOnly==1) ? "hr" :"hrs"),  hourFull = ((hoursOnly==1) ? " hour":" hours"); // .getHours()
				var minsOnly  = parseInt((elapsed-(oneDay*daysOnly)-(oneHour*hoursOnly))/oneMin ),  min  = ((minsOnly ==1) ? " minute" :" minutes"); // .getMinutes()
				var timeDisplay = 
					(elapsed > 7*oneDay) ? fullDate 
						: ( (elapsed > oneDay) ? (daysOnly+day+", "+hoursOnly+hour) 
							: ( (elapsed > oneHour) ? (hoursOnly+hourFull) 
								: (minsOnly+min) )
							);
				listing.accessKey  = a++; // was below listing.description
					var accessKeyDisplay = (a>10) ? " --" : listing.accessKey+")"; // "Sync:"
				listing.desc_ptI  = " "+ accessKeyDisplay +"   " + client.label +"  "+"("+timeDisplay;
				listing.desc_mid  = " ago";
				listing.desc_ptII = ")";
				listing.description = listing.desc_ptI + listing.desc_ptII;
				listing.machineID = client.machineID;
				if (a>10) listing.accessKey = "";
				var key = "client"+(a-1);
				syncListings[key] = listing; //GetAnonymousResource()
				if ((!newest || newest.elapsed > listing.elapsed) && ! (elapsed > 7*oneDay)) 
					newest=listing;
				//this.log("listing added: "+listing.description);
			}
			// Alter + Re-assert the newest description to include the word "ago", after its timestamp 
			if (newest) newest.description=   newest.desc_ptI+  newest.desc_mid  +newest.desc_ptII;
			this.syncListingsChanged = {}; // use SessionSaver.windowName
			this.syncListings = syncListings;
		},
		syncListings:null,   syncListingsChanged:{},
		setSyncListing: function(rdf,datasource,sequence,winNameUnique,resHash, override) {
			if (!this.syncListings || (this.syncListingsChanged[winNameUnique] && !override)) return;   this.syncListingsChanged[winNameUnique]=true;
			for (var n in this.syncListings) {
				var listing = this.syncListings[n],   client = this.registeredIDs[listing.machineID];
				var isDisabled = (client && client.syncHash) ? "false" : "true";
				var style = (client && client.machineID == this.syncMachineID) ? "pasha" : "cartier";
				var resource = rdf.GetResource(n); //rdf.GetAnonymousResource(); // XXX must be anonymous, since our key (n) wont be unique across listing-changed, and "re-asserting" doesn't clobber the old assertions -- a-la "sync"
				datasource.Assert(resource, resHash['label'], rdf.GetLiteral(listing.description), true);
				datasource.Assert(resource, resHash['value'], rdf.GetLiteral(listing.machineID  ), true);
				datasource.Assert(resource, resHash['aky'  ], rdf.GetLiteral(listing.accessKey  ), true);
				datasource.Assert(resource, resHash['dsbl' ], rdf.GetLiteral(isDisabled         ), true);
				datasource.Assert(resource, resHash['sync' ], rdf.GetLiteral(style              ), true);
				sequence.AppendElement(resource);
			}
		},
		// XXX to override parameters temporarily, we'll use __proto__ attachment with soft-access to 'this' -- so alterations can be "run" without saving first (ie. settings-window, Quick-Sync)
		asNonAsync: function(p) { if (!p) p = {isAsync:false}; /*else p.isAsync=false; p.syncChanged=false;*/ p.__proto__=this; return p;},
		contentType: "text/plain",   remoteFileRegistry: "SessionSaverRegistry.txt",
		remoteFileBase: "SessionSaverSync",   remoteFileName: null,   registeredIDs: {},
		idisk: {ptI:"http://idisk.mac.com/", ptII:"/Documents/"}, otherUrl: "",  // XXX becomes ->   ptI + user + ptII + remoteFileName  OR ->   otherUrl + remoteFileName
		url: null,  syncUser: null,  syncPass: null, isAsync: true, syncMachineID: null, timeUpSynced:0, registrySyncTime:0,
		setSyncMachineID: function(forceNew) {
			var newID = Math.floor(Math.random()*1000000000000);
			(!forceNew && this.settingsBranch.prefHasUserValue('sync.machineid')) ? 
					(this.syncMachineID = parseInt(this.settingsBranch.getCharPref('sync.machineid')))
					: this.settingsBranch.setCharPref('sync.machineid',(this.syncIDisNew = this.syncMachineID = newID));
		},
		setSyncPassword: function() {
			var host= {value:""}, username= {value:""}, password= {value:""};
			try{ this.passwordManagerInternal.findPasswordEntry(this.passManKey,"sync pass","",host,username,password); }catch(e) {}
			this.syncPass = password.value;
		},
		setSyncUrl: function(remoteFileName) {
			if (!remoteFileName) { var setLocal = true; remoteFileName = this.remoteFileName; }
			if (!remoteFileName) return null;
			var url = (this.syncToiDisk ? (this.idisk.ptI+this.syncUser+this.idisk.ptII) : (this.otherUrl+(this.otherUrl.slice(-1)!="/"?"/":""))) + remoteFileName;
			if (setLocal) this.url = url;
			else return url;
		},
		arabicToRoman: function(arabic) {
			if (arabic > 4999) return arabic; // XXX hmm.. hehe- 5000+ clients all sharing sessions via roman numerals ;P
			arabic = Math.round(arabic);
			if (!window.arabicToRoman) Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService(Components.interfaces.mozIJSSubScriptLoader).loadSubScript("chrome://sessionsaver/content/arabicToRoman.js",window);
			return arabicToRoman.convert(arabic); // conversion-code was relocated to its own file, to save space
		},
		createSyncRegistry: function(remoteFileCount, remoteIDArray) {
			var regArrayAll = [], time = new Date().valueOf();
			regArrayAll.push("t *" +"   "+time);
				if (remoteIDArray.length > 0) regArrayAll = regArrayAll.concat(remoteIDArray);
			regArrayAll.push("i "+ remoteFileCount +"   "+"m"+this.syncMachineID+" "+"t"+time+" "+"f"+escape(this.remoteFileName)+(this.syncLabel?" "+"l"+escape(this.syncLabel):""));
			return regArrayAll.join("\n");
		},
		addSyncRefresh: function() { if (this.syncRefreshTimer!=null) return; this.syncRefreshTimer = window.setInterval(this.syncRefresh,this.syncRefreshInterval,this); }, // 5-min polling interval
		removeSyncRefresh: function() { window.clearInterval(this.syncRefreshTimer); this.syncRefreshTimer=null;},
		syncRefresh: function(ssObj){ if (ssObj.sync) ssObj.initSync(ssObj.discoverDeferredCallback,true); else ssObj.removeSyncRefresh(); },
		syncRefreshTimer: null,  syncRefreshInterval: 300000,
		initSync: function(isAsync,isRefresh) {
			//if (!confirm("initSync()")) return;
			//this.log("initSync caller: "+arguments.callee.caller);
			this.removeSyncRefresh();
			if (isAsync) {
				var ssObj=this, callback=function(rv){ ssObj.initComplete(rv,callbackII,isRefresh); };
				var callbackII = function(rv) {
					if (rv.success) 
						ssObj.syncChanged=false, 
						ssObj.syncFailure.up=ssObj.syncFailure.down=0,  // XXX even though up/downComplete will reset these, the initial registration-check might have failed, pending creation+upload -- we'll just play all bets safe
						ssObj.discoverSyncSessions(isAsync,null,!Boolean(isRefresh)); // XXX ports the callback (if present) back into the discovery-phase
					else ssObj.log("Sync registration failed (async):  "+rv.msg/*+"   ->   "+isAsync*/), ssObj.syncListings=null, (typeof(isAsync)=='function') && isAsync(rv,ssObj), ssObj.syncCtxt && !ssObj.syncCtxt.closed && ssObj.syncCtxt._content && (ssObj.syncCtxt._content.status=" "), ssObj.syncCtxt=null;
				};
				this.downSync(this.remoteFileRegistry,callback);
				return {success:true, msg:"Init request sent"}; 
			}
			else {
				var origKill9Interval = this.kill9Interval;
				var attemptLimit=5;   do {var rv = this.downSync(this.remoteFileRegistry);} while (rv.success==null && --attemptLimit && (this.kill9Interval+=10000)) 
				this.kill9Interval = origKill9Interval;
				return this.initComplete(rv);   }
		},
		initComplete: function(rv, callbackII,isRefresh) {
			if (rv.success == null) { this.syncListings=null; return (callbackII) ? callbackII(rv) : rv; }// couldn't retrieve sync-registry
			var registeredIDs={},remoteFileCount=1,remoteIDArray = [];
			if (rv.success)
				for (var n in rv.resultHash) {
					var keyPair = n.match(/^([^ ]) ([^ ]+)/); if (!keyPair) {continue;} else var key=keyPair[1], name=keyPair[2];
					var result = rv.resultHash[n];
					switch(key) {
						case "t": var remoteLastUpdate = parseFloat(result); break;
						case "i": 
							var nameCount=parseInt(name), fileCount=remoteFileCount++;   remoteIDArray.push(n+"   "+result);
							var IDstuff = result.split(" "), d=-1, client={};
							while (++d < IDstuff.length) 
								switch (IDstuff[d].charAt(0)) {
									case "m": client.machineID = IDstuff[d].slice(1); break;
									case "f": client.fileName  = unescape(  IDstuff[d].slice(1)); break;
									case "t": client.timeAdded = parseFloat(IDstuff[d].slice(1)); break;
									case "l": client.label     = unescape(  IDstuff[d].slice(1)); break;  }
							if (client.machineID && client.fileName && client.timeAdded) registeredIDs[client.machineID] = client;
							client.fileCount = nameCount||fileCount; // filecount is for pref-iteration / autogeneration
							break;
					}
				}
			this.registeredIDs = registeredIDs,   this.registrySyncTime = new Date().valueOf(),   this.timeUpSynced=0;
			if (this.syncIDisNew) { while(this.syncMachineID in registeredIDs) this.setSyncMachineID(true); this.syncIDisNew=false;}
			if (this.syncMachineID in registeredIDs) { 
				this.remoteFileName = registeredIDs[this.syncMachineID].fileName;   this.setSyncUrl(); // XXX ..still not quite sure if we want this persisted (via pref) or not
				this.syncChanged = false;  var rvII = {success:true,msg:"ID found"};   this.syncFailure.up=this.syncFailure.down=0;
				return (callbackII) ? callbackII(rvII) : rvII; }
			else { // XXX this should never happen with async-calling [actually, it might -rue]
				this.remoteFileName = this.remoteFileBase+ this.arabicToRoman(remoteFileCount) +".txt";   this.setSyncUrl();
				//registeredIDs[this.syncMachineID] = {fileName:this.remoteFileName,timeAdded:new Date().valueOf()}; // XXX we don't want to look for ourselves, if we haven't pushed yet
				var syncRegistry = this.createSyncRegistry(remoteFileCount, remoteIDArray);
				if (callbackII) return (isRefresh) ? callbackII({success:false,msg:"Sync refresh failed"}) : this.upSync(this.remoteFileRegistry,syncRegistry,callbackII); // async
				rvII = this.upSync(this.remoteFileRegistry,syncRegistry);  
				if (rvII.success) this.syncChanged = false, this.syncFailure.up=this.syncFailure.down=0;
				else this.syncListings = null; // XXX at this point, we've failed to both download+upload Most Likely because we can't log-in -- so kill the listings, because there aren't any, now
				return rvII; }
		},
		// launch the settings-pane
		openSettings: function(url) {
			var wnd = this.windowMediator.getMostRecentWindow("sessionsaver:sessionsaverSettings");
			if (wnd && !wnd.closed) wnd.document.commandDispatcher.focusedWindow.focus(); // focusing the existing window..
			else wnd = window.openDialog((url||"chrome://sessionsaver/content/sessionsaverSettings.xul"),"settingstitle", "chrome,centerscreen,resizable"); // ..or open it
			return wnd;
		},
		// XXX UNUSED: the following (LocalSync) was an implementation of file import/export that piped completely through the existing sync-infrastructure, a-la QuickSync; various points of needless fragility result (conceptually) though, so this was scrapped for direct file-access, via nsIFilePicker
		LocalSync: function(type,dirUrl,fileName) { 
			//if (!this.syncStatusAdjust()) return this.revealSyncConfig();
			var syncToiDisk= false, otherUrl= dirUrl, user= null, pass= null, label= this.syncLabel, isAsync= false;
			var p = {syncToiDisk:syncToiDisk,otherUrl:otherUrl,syncUser:user,syncPass:pass,syncLabel:label, prefBranchSyncStartup:null, isStartupDiscovery:"quickSync"}; 
			var ssSoftObj = this.asNonAsync(p);
				ssSoftObj.setSyncUrl(fileName); // co-operation across boundaries -- nice
					ssSoftObj.syncChanged = false; // XXX nice- keeps the "sync index" from attempted update
				//var rv = ssSoftObj[type+"Sync"](ssSoftObj.remoteFileName) || {success:false,msg:"connection failed"};
				var ssObj =this; //, ctxtWrap; // =this.hiddenObserver.windowMediator.getMostRecentWindow("navigator:browser"); //={_content: {set status(msg){ssObj.syncStatusAdjust(msg);return msg;}} }; 
				if (type=="up") 
					//ssSoftObj.syncCtxt = null; //ctxtWrap, // XXX ..set manually, since there's no ideal entry with straight upSync
					ssSoftObj.upSync(ssSoftObj.remoteFileName,null,this.LocalWrap);
				else { 
					//var /*rvSuccess = {success:true,msg:"Discovery complete"}, */
					//	QuickWrap = function(rv,observer){ssObj.QuickSyncCallback(rv/*Success*/)};
					//ssSoftObj.discoverSyncSessions(QuickWrap,ctxtWrap);
					//ssSoftObj.discoverSyncSessions(this.QuickWrap,ctxtWrap,true);
					ssSoftObj.downSync(ssSoftObj.remoteFileName,this.LocalWrap);
				}
			/*
				var rv = (type=="up") ? ssSoftObj.upSync(ssSoftObj.remoteFileName,null,this.QuickSyncCallback) : ssSoftObj.discoverSyncSessions(QuickSyncCallback);
				if (!rv) rv = {success:false,msg:"connection failed"};
			var status = rv.msg;
			clearTimeout(this.QuickTimeout); this.syncStatusAdjust(status); this.QuickTimeout = setTimeout(function(sssObj){sssObj.syncStatusAdjust();},4000,this);
			*/
		},
		LocalWrap: function(a,b){if (window.closed) return; SessionSaverSettings.LocalSyncCallback(a,b)},
		LocalSyncCallback: function(rv,observer){ // XXX 'observer' is the ssSoftObj, remember -
			if (window.closed) return; // the user might close the settings-window, before QuickSync completes (async)
			if (!rv) rv = {success:false,msg:"Connection failed"};
			var status = rv.msg;
			//clearTimeout(this.LocalTimeout); this.syncStatusAdjust(status); this.LocalTimeout = setTimeout(function(ssObj){ssObj.syncStatusAdjust();},4000,this);
			if (!observer) return; // XXX QuickSync Store (up) only calls with 'rv'
			if (rv.success && observer.prefBranchSyncStartup && observer.prefBranchSyncStartup != observer.prefBranchWindows) {
				observer.log("observer.prefBranchSyncStartup: "+observer.prefBranchSyncStartup);
				var doubleCheck = confirm("Double-confirming: load the remote session?");
				if (!doubleCheck) return;
				var browserWnd = observer.windowMediator.getMostRecentWindow("navigator:browser");
				if (!browserWnd || browserWnd.closed) return alert("SessionSaver: \n...uh. you closed the last browser-window.\n\n\nYou need at least one open, to restore into. \nTry restarting the browser. ");
				browserWnd.sessionRecall(null, observer.prefBranchSyncStartup);
			}
		},
		importSession: function(wnd) {
			var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
			var stream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
			var streamIO = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
			var validFile = false;
			
			fp.init(wnd||window, "Select a File", fp.modeOpen);
			//fp.appendFilters(fp.filterText);
			var ext = this.exportFileExt, mask = this.exportFileMask;
			fp.appendFilter("SessionSaver Session",mask);
			fp.defaultExtension = ext;
		
			if (fp.show() != fp.returnCancel) {
				stream.init(fp.file, 0x01, 0444, null);
				streamIO.init(stream);
				var data = streamIO.read(stream.available());
				streamIO.close(); stream.close();
				this.findValidSession(data, true);
			}
		},
		findValidSession: function(data, shouldAssimilate, justSettings) {
			var resArrayAll = data.split("\n"), res, resultHash = {};
			while ((res=resArrayAll.shift())) res = res.split("   "), resultHash[res[0]] = res[1]; //, this.log('resultName: '+res[0]+' -> '+res[1].substr(0,30)+"...");
			var rv={resultHash:resultHash,data:data}, client={}, timeHash={'client':client}, timeArray=['client'];
			this.discoverComplete(rv,client,timeHash,timeArray);
				var d =(client.timeUpSynced)?(new Date(client.timeUpSynced)):(new Date()), curDate =(d.getMonth()+1)+"."+d.getDate()+"."+((d.getFullYear()+"").slice(2));
			// Note: the syncHash has its own special handling
			var notImported=[], notImportedHash={}; // we'll add the syncHash, if it matches the current session (window-branch)
			var k,m, hashType, pKey,gKey,cKey,   CI=Components.interfaces,   PB=CI.nsIPrefBranch; // ..we don't even use cKey now; oh well..
			var importSuffix = "", importKeys={a:["intHash","setIntPref","getIntPref",PB.PREF_STRING],b:["boolHash","setBoolPref","getBoolPref",PB.PREF_INT],c:["charHash","setCharPref","getCharPref",PB.PREF_BOOL]};
			var zorderRe = /^(.*)\.zorder$/i, zei, zHash={asArray:[],asName:{}}; // [******. hehe -rue]
			//   Main-Session From Archive (9.11.05).iv
			var s, s2, s2Cnt=2, sPadd="", s2Name="Main-Session_From_Archive_("+curDate+")", s2mName=s2Name.replace(/_/g," "), s2prefix=this.prefBranch+this.prefBranchStatic+s2Name,s2suffix="."; // -> Main-Session From Archive (10.25.05)
			var syncIsCopy = false; // ..a more difficult approach, but we'll check against the implicit of sync being a copy (--of our current session)
			for (s in client.syncHash) { while((s2=s2prefix+sPadd+s2suffix+s) && typeof(client.charHash[s2])!='undefined') sPadd="."+this.arabicToRoman(s2Cnt++), sPadd=sPadd.toLowerCase(); }
			for (s in client.syncHash) { if (!copyCheck) {var copyCheck=true; syncIsCopy=true} if (!(this.windowBranch.prefHasUserValue(s) && this.windowBranch.getPrefType(s)==PB.PREF_STRING && this.windowBranch.getCharPref(s) == client.syncHash[s])) {syncIsCopy = false;} }
			s2Name+=sPadd,  s2mName+=sPadd,  s2prefix+=sPadd; // logistically, this is linked with the loop/line 2-above
			//zHash[s2prefix]=0,zHash.asArray.unshift(s2mName),zHash.asName[s2Name]=s2mName;
			if (syncIsCopy) notImported.push(s2mName),notImportedHash[s2mName]=true,   zHash[s2prefix]=0,zHash.asArray.unshift(s2mName),zHash.asName[s2Name]=s2mName;
			else { // ..if the syncHash didn't match (directly) against our current session, then check it against the charhash, and move it in, once a unique-name is secured
				for (s in client.syncHash) { s2 = s2prefix+s2suffix+s; client.charHash[s2] = client.syncHash[s]; }
			}
			for (k in importKeys) { hashType = importKeys[k][0]; for (m in client[hashType]) {  if (hashType=="charHash"&&(zei=m.match(zorderRe))) { var name=zei[1], mName = name.replace(this.prefBranch+this.prefBranchStatic,""); var mName=mName.replace(/_/g," "); zHash[name]=0,zHash.asArray.push(mName),zHash.asName[name]=mName; if (this.rootBranch.prefHasUserValue(m)) zHash[name]=1; }   } }

			if (!shouldAssimilate) return zHash;

			var sessionCnt = zHash.asArray.length;
			if (sessionCnt==0 && !justSettings) return; // XXX the user might import other prefs, so this should be override-able
			var isMultiSession = (sessionCnt>1);
			if (!confirm("Double-confirming: import the following session"+(isMultiSession?"s":"")+"?:\n\n. . ."+zHash.asArray.join("\n. . ."))) return;
			var nameRe = /^(.*)(\.[^\.]+)$/, nei;
			//var notImported=[], notImportedHash={};
			for (k in importKeys) { 
				hashType=importKeys[k][0], pKey=importKeys[k][1], gKey=importKeys[k][2], cKey=importKeys[k][3]; 
				var renamedSessions = {};
				for (m in client[hashType]) { 
					var isExistingSession = (hashType=="charHash"&&(name=m.match(nameRe))&&zHash[name[1]]==1);  
					if (!isExistingSession) this.rootBranch.deleteBranch(m), this.rootBranch[pKey](m, client[hashType][m]); 
					else { 
						var sessionName = zHash.asName[name[1]];
						var m2root = name[1];
						if (renamedSessions[m2root]) var m2 = renamedSessions[m2root]+name[2];
						else {
							var mPadd="",mCnt=2, m2mod=m2root+"_("+curDate+")"; 
							do{m2=m2mod+mPadd+".zorder", mPadd="."+this.arabicToRoman(mCnt++)} while (this.rootBranch.prefHasUserValue(m2)) 
							this.rootBranch.deleteBranch(m2root);
							m2 = m2mod+mPadd+name[2];
							renamedSessions[m2root]=m2mod+mPadd;  }
						/* XXX unfortunately, the following *Could result in a session being partially imported:
							..if there's one pref matching for data, and another that either isn't present or doesn't match;
							   ..the only solution is to "batch compare", which isn't preferrable (abstraction-wise) */
						//if (!this.rootBranch.prefHasUserValue(m)||this.rootBranch[gKey](m)!=client[hashType][m])
							this.rootBranch[pKey](m2, client[hashType][m]);
						//else if (typeof(notImportedHash[sessionName])=='undefined') notImportedHash[sessionName]=true, notImported.push(sessionName);
					}  
				}
			}
			var extraInfo = "";
			var successInfo = (notImported.length < sessionCnt || justSettings) ? "Import Success." : (notImported.length==1?"Not imported.":"No sessions were imported.");
			if (notImported.length > 0) {
				if (notImported.length == 1)
					extraInfo += "Note: The import was ignored -- \nfor matching an existing session, both in name and content.";
				else
					notImported.unshift("Note: The following imports were ignored -- \nthey matched existing sessions, both in name and content: \n"),
					extraInfo += notImported.join("\n. . .");
			}
			if (extraInfo!="") extraInfo = "\n\n"+extraInfo;
			alert(successInfo + extraInfo);
		},
		exportFileExt: "ssv", exportFileMask: "*.ssv",
		exportSession: function(fileName, prefsToPush, wnd) {
				var d=new Date(),  curMonth=d.getMonth()+1,  curDate=(d.getMonth()+1)+"."+d.getDate()+"."+((d.getFullYear()+"").slice(2));
			// XXX Add: prompt for which session(s) to export; also, what to name current (if included); dump into the following array..
			var curName = null; //"Main-Session ("+curDate+")"; //"My last session ("+curDate+")" //.replace(/ /g,"_"); // (10.25.05)";
			//if (!prefsToPush) prefsToPush = ["adblock.","sessionsaver.static.+tfb.","sessionsaver.static.Memory_17.","sessionsaver.static.Memory_21."]; // XXX test-values [although, we are partial to adblock; naturally -rue]
			if (!prefsToPush) { var pushCurrent=true; prefsToPush = ["adblock.","extensions.tabmix.","sessionsaver.static."]; }// the real deal.
			else pushCurrent = false;
			var data = this.createUpSyncData(prefsToPush,pushCurrent,curName); // @params: prefsToPush, pushCurrent (bool)
				if (!data) return alert("There wasn't any session-data to export!");
			var zHash = this.findValidSession(data,false);
			var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
			var filestream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
			var buffered   = Components.classes["@mozilla.org/network/buffered-output-stream;1"].createInstance(Components.interfaces.nsIBufferedOutputStream);
			var binstream  = Components.classes["@mozilla.org/binaryoutputstream;1"].createInstance(Components.interfaces.nsIBinaryOutputStream); 
		
			fp.init(wnd||window, "Select a File", fp.modeSave);
			//fp.appendFilters(fp.filterText);
			var ext = this.exportFileExt, mask = this.exportFileMask;
			fp.appendFilter("SessionSaver Session",mask);
			fp.defaultExtension = ext;
				var sessionCnt  = zHash.asArray.length;
				var wordSpacer  = (curMonth >  9 && sessionCnt >  9) ? "":" ";
				var prefsTxt    = (curMonth < 10 && sessionCnt < 10) ? "+prefs":"+pref";
				if (sessionCnt > 1)
					var mainTxt = "("+sessionCnt+" sessions"+wordSpacer+prefsTxt+")"+" "+curDate; // "exports":"export" -> "sessions":"session"
				else
					mainTxt = zHash.asArray[0].slice(0,27); //31); //12)
			fp.defaultString    = fileName||(mainTxt+"."+ext); //("SS Export "+curDate+"."+ext);
			//fp.defaultString    = fileName||("SS Export "+curDate+"."+ext); // ss2d, ssxd, ssxp, ssd, ssp, ssc
			// XXX the session-count/names/pref-indicator will come from our initial (first) dialog, where the user chooses what to export
			// Memory 17 +prefs 10.25.05.ssv     
			// Untitled +prefs 10.25.05.ssv
			// (33 sessions+pref) 10.25.05.ssv
			// (33 sessions +pref) 9.25.05.ssv   <-  (strip space preceeding '+prefs', if month includes leading zero)
			// (3 sessions +prefs) 9.25.05.ssv   <-  (strip space preceeding '+prefs', if month includes leading zero + export-num is >= 10)
		
			if (fp.show() != fp.returnCancel) {
				if (fp.file.exists()) fp.file.remove(true);
				if (fp.file.exists()) return alert("The Export failed: try using a unique, or new, filename.");
				fp.file.create(fp.file.NORMAL_FILE_TYPE, 0666);
		
				//filestream.init(fp.file, 0x02, 0x200, null);
				filestream.init(fp.file, 0x02 | 0x08, 0644, 0);
				buffered.init(filestream, 64 * 1024);
				binstream.setOutputStream(buffered);
				binstream.writeBytes(data,data.length);
				//filestream.write(data, data.length);
				binstream.close(), buffered.close();
				filestream.close(); }
		},
		//top.opener.x = top.opener.SessionSaver.openSettings("chrome://sessionsaver/content/LHttp-override.xul","ss:test"); //.document.documentElement.innerHTML="<vbox style='border:solid,green,4px;'></iframe>"
		buildListDialog: function(listArray) {
			// XXX coming soon-    ...or else.
		},
		manualSync: function(evt, item) {
			var middleClick =item.ssClicked ? (item.ssButton==1) : (evt.button==1),  wnd =item.ownerDocument.defaultView;
			var isManualSync = {middleClick:middleClick, wnd:wnd};
			var client = this.registeredIDs[item.value], timeHash ={'client':client}, timeArray =['client'];
			var branch = this.discoverFinal(timeHash,timeArray,null,isManualSync); 
			if (isManualSync.cancelled) return; // the user was warned, and opted-out  //if (branch==false) return;
			//if (branch) { // XXX handled by discoverDeferredCallback, now
				var rvSuccess = {success:true,msg:'ManualSync'}, overrideObj ={Store:0,Retrieve:0,Both:0, prefBranchSyncStartup:branch, wnd:wnd};
				var result = this.discoverDeferredCallback(rvSuccess,this,overrideObj);
				if (typeof(result)=='string') alert(result); //if (result!=true) alert(result); //}
		},
		discoverDeferredCallback: function(rv,observer, overrideObj) {  // fed as the async-callback to discoverSyncSessions() (next) by the settings window -- when closing.
			//arguments.callee.__ssCalled=true; 
					if (!(this.syncFlip in (overrideObj||{Retrieve:0,Both:0}) )) return "Sync isn't set to permit this (..currently: Remote-"+this.syncFlip+" only)";
					var startupBranch = (overrideObj||observer).prefBranchSyncStartup;
						if (!startupBranch) return "Your session is already up-to-date."; //"No session-data could be found, for the Remote Client.";
					var goodStartupBranch = observer.Branch.prefHasUserValue(startupBranch+"zorder");
						if (!goodStartupBranch) return "The Remote-session didn't contain a valid z-order pref \n\n(..possibly due to a corrupted transfer?)"
						if (startupBranch == observer.prefBranchWindows) return "No newer Remote-sessions available.";
					var wnd = overrideObj && overrideObj.wnd; 
					var isSyncRestore = true;
					if (!wnd || wnd.closed) for (var n in observer.activeWindows) { wnd = observer.activeWindows[n]; if (wnd && !wnd.closed) break;  }
					if (!wnd || wnd.closed) { wnd = window.open(); wnd.setTimeout("SessionSaver.sessionRecall(null,'"+startupBranch+","+isSyncRestore+"');",1000); }
					else wnd.SessionSaver.sessionRecall(null,startupBranch,isSyncRestore);
					return true;
		},
		discoverSyncSessions: function(isAsync, ctxt, isStartup) {
			//if (!confirm("discoverSyncSessions()")) return;
			// we'll loop through all registered clients -- determined from initSync() -- discover their sync-files, 
			//  ..then choose the most-recently-updated sync + assimilate (pref-wise)
			if (typeof(this.isStartupDiscovery) in {'undefined':0,'boolean':0}) this.isStartupDiscovery = Boolean(isStartup); // XXX this permits QuickSync's shallow string for .isStartupDiscovery to override
			this.prefBranchSyncStartup = null;
			var timeHash={},timeArray=[],   fallback = /*(isAsync) ? null :*/ (this.lastSessionCrashed?this.crashLoadBranch:this.autoLoadBranch); // XXX remember, startup runs this async for ftp-urls, now
			if (isAsync) {
				if (ctxt) this.syncCtxt = ctxt; // ctxt is for ftp-progress status postings
				if (this.syncChanged) return this.initSync(isAsync); // running initSync asynchronous automatically calls discoverSync.. on completion
				var registeredIDs = this.registeredIDs; // XXX make sure we get the latest copy, since initSync replaces/resets this
				var registeredArray = [], client, finalCallback = (typeof(isAsync)=='function' ? isAsync:null); //this.log("finalCallback: "+typeof(isAsync)+":"+(typeof(isAsync)=='function')+"   ->   "+finalCallback);
				for (var id in registeredIDs) registeredArray.push(registeredIDs[id]); 
				var isFinal = {callback:finalCallback,registeredArray:registeredArray,count:registeredArray.length}, n=2; // the max-concurrent connections
				while (n-- && (client=registeredArray.shift())) { // XXX -!!! we had n as the second-condition, meaning one client was removed but never called !!! [good grief -rue]
						var callback=this.createCallback(client,timeHash,timeArray, fallback, isFinal); // XXX technically, we only need one closure -- recycling should be fine
						this.downSync(client.fileName, callback); }
				return {success:true,msg:"Discovery requests sent"};
			}
			else{ // registeredIDs, id, client are all declared above
				if (this.syncChanged && !(rvI=this.initSync()).success) { var rvI; rvI.resultValue = fallback; return rvI; }
				registeredIDs = this.registeredIDs; // XXX make sure we get the latest copy, since initSync replaces/resets this
				for (id in registeredIDs) { 
					client = registeredIDs[id];
					var origKill9Interval = this.kill9Interval;
					var attemptLimit=5;   do {var rv = this.downSync(client.fileName);} while (rv.success==null && --attemptLimit && (this.kill9Interval+=10000)) 
					this.kill9Interval = origKill9Interval;
					/*if (rv.success)*/ this.discoverComplete(rv,client,timeHash,timeArray);   }
				this.prefBranchSyncStartup = this.discoverFinal(timeHash, timeArray, fallback);
				return {success:true,msg:"Discovery complete",resultValue:this.prefBranchSyncStartup};
			}
		},
		createCallback: function(client,timeHash,timeArray, fallback, isFinal) {
			var ssObj=this,   rvSuccess = {success:true,msg:"Discovery requests complete"},   clientQueued=client; // XXX clientQueued is set, in case the first call is also the last
			var callback = function(rv,whatTheHeck){ // XXX it would be good to have a listing of which url/filenames succeeded or failed
					rv.success && ssObj.discoverComplete(rv,clientQueued,timeHash,timeArray);
					var isFinalCall = (!--isFinal.count);
					if (isFinalCall) {
						ssObj.prefBranchSyncStartup = ssObj.discoverFinal(timeHash,timeArray,fallback);
						isFinal.callback && isFinal.callback(rvSuccess,ssObj);  }
					else {
						clientQueued = isFinal.registeredArray.shift();
						if (clientQueued) ssObj.downSync(clientQueued.fileName,callback);   }
				};
			return callback;
		},
		discoverComplete: function(rv, client, timeHash, timeArray) {
			client.syncHash={},   client.intHash={},client.boolHash={},   client.charHash={},   client.isSynced=false,client.shutdown=false; // reset the client's pref-hashes
			for (var n in rv.resultHash) {
				var keyPair = n.match(/^([^ ]) ([^ ]+)/); if (!keyPair) {continue;} else var key=keyPair[1], name=keyPair[2];
				var result = rv.resultHash[n];   client.data = rv.data;
				switch(key) {
					case "s": client.syncHash[name] = result; break;
					case "i": 
						var IDstuff = result.split(" "), d=-1;
						while (++d < IDstuff.length) 
							switch (IDstuff[d].charAt(0)) { // XXX the machineID + fileName are also here, but we don't need them
								case "l": client.registrySyncTime = parseFloat(IDstuff[d].slice(1)); break; // the last time this client synced its registry (usually, just when the browser launched)
								case "q": client.crumbTime        = parseFloat(IDstuff[d].slice(1)); break; // the last clientID (+time) the current-client was synced with (in case we're crash-recovering, and we want to know if the "most-recent" client was derived from our last upload, or not
								case "r": client.crumbID          = IDstuff[d].slice(1); break;             // ..ditto
								case "t": client.timeUpSynced     = parseFloat(IDstuff[d].slice(1)); 
									timeHash[""+client.timeUpSynced]=client, timeArray.push(client.timeUpSynced);
									break;
								case "s": client.shutdown         = IDstuff[d].slice(1)=="1"; break;
								case "d": client.label            = unescape(IDstuff[d].slice(1)); break;   }
						break;
					case "a": client. intHash[name] = parseFloat(result); break;
					case "b": client.boolHash[name] = (result=="true"); break;
					case "c": client.charHash[name] = result; break;   }
			}
		},
		// var ssho = SessionSaver.hiddenObserver, syncClient = ssho.registeredIDs[this.value], branch = ssho.discoverFinal({0:syncClient},[0],null,true); branch && ssho.discoverDeferredCallback({success:true,msg:'ManualSync'},ssho,{Store:0,Retrieve:0,Both:0});
		discoverFinal: function(timeHash, timeArray, fallback, isManualSync) {
			if (!isManualSync) {
				this.syncCtxt && !this.syncCtxt.closed && this.syncCtxt._content && (this.syncCtxt._content.status=" ");
				this.syncCtxt = null;
				this.createSyncListing();
				this.addSyncRefresh();   
			}
			var registeredIDs = this.registeredIDs;
			if (timeArray.length > 0) {
				timeArray.sort().reverse();
				var timeKey = ""+timeArray.shift(),   syncClient=this.lastSyncClient = timeHash[timeKey],   syncCrumbs=this.lastSyncCrumbs = ["q"+syncClient.crumbTime,"r"+syncClient.crumbID];
				if (syncClient.machineID != this.syncMachineID) { 
					this.settingsBranch.setCharPref("sync.crumbs", syncCrumbs.join(" ")); // so these persist, even through a crash
					// Tracking the last-update-origin for a dysfunctional sync: 
					//   if it originated from us, AND is newer than the last update we upSync()'d, we'll prefer this remote session -- even over a crash
					var crashed      = !this.startupComplete && this.lastSessionCrashed;
					var origLastSyncCrumbID = (this.syncMachineID in registeredIDs) ? registeredIDs[this.syncMachineID].crumbID : 0;
					var sameOrigin   = syncClient.crumbID && (this.syncMachineID==syncClient.crumbID || (origLastSyncCrumbID && origLastSyncCrumbID==syncClient.crumbID));
					var localIsNewer = sameOrigin && this.timeUpSynced > syncClient.crumbTime; // XXX remember, we're comparing crumbTime, which is the last downSync
					// XXX we should ask the user, actually, whether to download the newest Remote session, or push the Local
					var deSynced     = this.timeUpSynced ? (this.timeUpSynced < syncClient.timeUpSynced) : true; //(this.registrySyncTime < syncClient.timeUpSynced); // we can also compare times directly to determine if the updates occurred within a short interval -- OH, we'll have a "shutdown" flag upSynced, too!
					//this.log("crashed: "+crashed+"\n"+"origLastSyncCrumbID: "+origLastSyncCrumbID+"\n"+"sameOrigin: "+sameOrigin+"\n"+"localIsNewer: "+localIsNewer+"\n"+"deSynced: "+deSynced+"\n\n"+"clientLabel: "+syncClient.label+"\n"+"clientID: "+syncClient.machineID);
					if (isManualSync) {  //if (!confirm("Load the Remote session, from "+syncClient.label+"?")) return fallback;  }  //if ((isManualSync||(this.isStartupDiscovery && this.syncFlip in {Both:0})) && !confirm("Sync has located a new remote-session, from "+syncClient.label+"..\n..Load the Remote session, or cancel, and keep the Local.")) return fallback;
						var storedValue = this.getDontWarn(3);
						var warn = isManualSync.middleClick||!storedValue; // force the warning, on middle-click
						if (warn) { // alert the user, if the "dontWarn" flag isn't set
							var dontWarn = {value:!storedValue};
							var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService); 
							var buttonPressed = promptService.confirmEx(isManualSync.wnd,"SessionSaver Manual-Sync: "+syncClient.label,"Load this client's session, or Cancel?\n",promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 + promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1,"Load","Cancel",null,"Ask every time",dontWarn);
							this.setDontWarn(3, !dontWarn.value); // flipped
							if (buttonPressed == 1) return (isManualSync.cancelled=true) && fallback;  }
					}
					else
						if (crashed) {
							if (localIsNewer) return fallback; // the forked-remote session isn't newer
							if (deSynced && !confirm("Another client used this session, after you crashed..\n..Load the updated session, or Ignore?" /*Another machine was updated after you crashed..\n..Load the Remote session, or cancel, and keep the Local?"*/)) return fallback;  }
					else 
						if (!deSynced) return fallback;
					else
						if (this.isStartupDiscovery && this.syncFlip in {Both:0} && !confirm("Sync has located a new session, from: \n > "+syncClient.label+"\n\n\n\n..Load the session, or Ignore?")) return fallback;
					var isSynced = false;   this.Branch.deleteBranch(this.prefBranchDownSync);
					for (var s in syncClient.syncHash) isSynced=true, this.downSyncBranch.setCharPref(s, syncClient.syncHash[s]);
					for (var a in syncClient .intHash) this.rootBranch.setIntPref (a, syncClient .intHash[a]);
					for (var b in syncClient.boolHash) this.rootBranch.setBoolPref(b, syncClient.boolHash[b]);
					for (var c in syncClient.charHash) this.rootBranch.setCharPref(c, syncClient.charHash[c]);
					if (isSynced) this.replicateAndRoll(this.prefBranchWindows, this.prefBranchStatic+"sync_backup."); //this.downSyncBackupBranch); // backup-copy
					if (isSynced) return this.prefBranchDownSync; }
			}
			return fallback; // we'll just update locally, if it's us
		},
		prefConverter: null,
		createUpSyncData: function(prefsToPush,pushCurrent,nameCurrent) { // returns a single string, of the relevant prefs
			var prefArrayAll = [];
			if (!this.prefConverter/*.set*/) { 
				this.prefConverter = { keyed:{}, hashed:{a:Components.interfaces.nsIPrefBranch.PREF_INT, b:Components.interfaces.nsIPrefBranch.PREF_BOOL, c:Components.interfaces.nsIPrefBranch.PREF_STRING}, retrieve:{a:"getIntPref",b:"getBoolPref",c:"getCharPref"} };
				var h = this.prefConverter.hashed; for (var n in h) this.prefConverter.keyed[h[n]]=n; /*this.prefConverter.set=true;*/ }
			if (typeof(prefsToPush)=='undefined') prefsToPush = ["adblock.","sessionsaver.static."];
			if (typeof(pushCurrent)=='undefined') pushCurrent = true;
			var push; 
			while ((push=prefsToPush.shift())) {
				var prefName, childArray = this.rootBranch.getChildList(push, {}); // array of pref-names, off this particular branch
				while ((prefName=childArray.shift())) {
					if (prefName.match(/^sessionsaver\.static\.sync_backup\./i)) {continue;}
					var key = this.prefConverter.keyed[ this.rootBranch.getPrefType(prefName) ];
					var getPrefAsType = this.prefConverter.retrieve[key];
					prefArrayAll.push(key+" "+prefName+"   "+this.rootBranch[getPrefAsType](prefName)); }
			}
			this.timeUpSynced = new Date().valueOf();
			var infoArray = [ "m"+this.syncMachineID, "t"+this.timeUpSynced, "f"+this.remoteFileName, "l"+this.registrySyncTime ];
				if (this.lastSyncClient) infoArray.push("q"+this.lastSyncClient.timeUpSynced), infoArray.push("r"+this.lastSyncClient.machineID);
				else if (this.lastSyncCrumbs) infoArray = infoArray.concat(this.lastSyncCrumbs);
				if (this.shutdownRequested) infoArray.push("s"+"1");
				if (this.syncLabel) infoArray.push("d"+escape(this.syncLabel));
			prefArrayAll.push("i *"+"   "+infoArray.join(" ")); // + crumbAdditions
			if (pushCurrent) {
				var curKey    = (nameCurrent) ? "c":"s";
				var curBranch = (nameCurrent) ? (this.prefBranch+this.prefBranchStatic+nameCurrent.replace(/ /g,"_")+".") : "";
				if (!this.Branch.prefHasUserValue(this.prefBranchWindows+"zorder")) return prefArrayAll.join("\n");
				for (var name in this.activeWindows) 
					if (this.activeWindows[name] && !this.activeWindows[name].closed && this.activeWindows[name].SessionSaver) 
						prefArrayAll.push(curKey+" "+curBranch+name+"   "+this.activeWindows[name].SessionSaver.prefArray);
				if (prefArrayAll.length == 0) return null;
				if (this.cookieString) prefArrayAll.push(curKey+" "+curBranch+"cookies"+"   "+this.cookieString);
				if (this.zOrderString) prefArrayAll.push(curKey+" "+curBranch+"zorder" +"   "+this.zOrderString);
			}
			return prefArrayAll.join("\n");
		},
		createPostInitCallback: function(args, callback){ var ssObj = this, caller = args.callee; return function(rv){rv.success ? caller.apply(ssObj,args) : (callback && callback(rv));}; },
		upSync: function(remoteFileName, data, callback, shutdownSync) {
			if (shutdownSync) return; // ..originally for mLA, but also best left so.
			//if (!confirm("upSync"+(remoteFileName?" > "+remoteFileName:"")+(callback?" > "+callback:""))) return;
				//if (this.shutdownRequested||shutdownSync) alert("upSync : shutdown\n\nupSyncPending: "+this.upSyncPending+"\nshutdownSync: "+Boolean(shutdownSync));
			if (!remoteFileName) {
				if  (this.upSyncPending && !shutdownSync /*&& !this.shutdownRequested*/) return {success:false,msg:"upSync pending"};
				else this.upSyncPending = true; }
			if (!data) data = this.createUpSyncData(); 
			var upTime = {start:0, timeout:null, dataLength:data.length};
			var request = new XMLHttpRequest();
			var isAsync = (!remoteFileName && !shutdownSync) || Boolean(callback); //!this.shutdownRequested;
			if (!remoteFileName && this.syncChanged) {
				if (isAsync) { this.upSyncPending = false; return this.initSync(this.createPostInitCallback(arguments,callback)); }
				else if (!this.initSync().success) { rv = this.upSyncComplete(request,upTime,"upSync registry-load failed"); callback && callback(rv); return rv; } // failure: init sync
			}
			var url = (remoteFileName) ? this.setSyncUrl(remoteFileName) : this.url;
			if (!url || !data) return this.upSyncComplete(request,upTime,(!url?"no url":"no data")); // failure: no url or data
				//this.log("params (up): "+url+" "+isAsync+" "+this.syncUser+" "+this.syncPass);
			request.open("PUT", url, isAsync, this.syncUser, this.syncPass); // @params: (method, url, [isAsync, user, pass]) -last 3 are optional
			request.setRequestHeader("Content-Type", this.contentType);
			// btw: though unneeded here, sending filestreams directly always fails for webdav/idisks; at least, under 1.3.1
			if (url.match(/^ftp|file/i)) {
				var onAlert=function(failMsg){rv=this.ssObj.upSyncComplete(request,upTime,failMsg); callback && callback(rv)}; this.overrideFTPCallbacks(request,onAlert);
				var stringStream = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream);
				var uploadChannel = request.channel.QueryInterface(Components.interfaces.nsIUploadChannel); // for ftp
				stringStream.setData(data, data.length);
				uploadChannel.setUploadStream(stringStream,this.contentType,-1); stringStream = uploadChannel = null;  } // XXX does the onload-handler's closure leak these?
			request.onload = function() {  rv = ssObj.upSyncComplete(request,upTime,null,fn); callback && callback(rv); ssObj=null;  };   var rv, ssObj = this, fn=(remoteFileName||this.remoteFileName);
				upTime.start = new Date;
			if (!isAsync) setTimeout(this.syncKill9, this.kill9Interval, this,"up",request,rv,fn); // if the dav-login fails, moz1.3.1 just blocks the thread, continually trying to get a response
			try{ request.send(data); }catch(e){ rv = this.upSyncComplete(request,upTime,"upSync request failed"); callback && callback(rv); }
			if (!isAsync) return rv || this.upSyncComplete(request,upTime,"upSync connection failed");
			else data=null, upTime.timeout = setTimeout(this.syncOrbiter, 45000, this,"up",request,callback);
			return null; // ..unneeded return value; just to rid us of the strict warnings
		},
		upSyncComplete: function(request, upTime, failMsg, fileName) {
				var endTime=new Date, startTime=upTime.startTime, dataLength=upTime.dataLength
			clearTimeout(upTime.timeout); this.upSyncPending = false; // ...was 1-up
			if (failMsg) { this.syncOrbiter(this,"up"); return {success:null,msg:failMsg||"upSync died"}; } 
			request.channel.notificationCallbacks = request.onload = null; // testing to see if it's "ftp" would just be unneeded overhead
			try{  if (request.getResponseHeader("Content-Type") == 'text/html') var failed = true;  }catch(e){}
			var statusShort = parseInt(request.status/100);
			if (failed || !(statusShort==2 || statusShort==0)) { this.syncOrbiter(this,"up",request); return {success:false,msg:failMsg || "Session-data didn't upload for "+fileName}; }
				//setTimeout(this.syncStats, 1000, this, startTime, endTime, dataLength, fileName, "up");
				this.syncStats(this, startTime, endTime, dataLength, fileName, "up");
			this.syncFailure.up = 0;
			return {success:true,msg:"Success"};
		},
		kill9Interval: 3000,
		downSync: function(remoteFileName, callback) {
			//if (!confirm("downSync"+(remoteFileName?" > "+remoteFileName:"")+(callback?" > "+callback:""))) return;
			if (!remoteFileName) {
				if  (this.downSyncPending) return {success:false,msg:"downSync pending"};
				else this.downSyncPending = true; }
			var downTime = {start:0, timeout:null};
			var request = new XMLHttpRequest();
			var isAsync = !remoteFileName || Boolean(callback);
			if (!remoteFileName && this.syncChanged) {
				if (isAsync) { this.downSyncPending = false; return this.initSync(this.createPostInitCallback(arguments,callback)); }
				else if (!this.initSync().success) { rv = this.downSyncComplete(request,downTime,"downSync registry-load failed"); callback && callback(rv); return rv; } // failure: init sync
			}
			var url = (remoteFileName) ? this.setSyncUrl(remoteFileName) : this.url;
			if (!url) return this.downSyncComplete(request,downTime,"no url"); // failure: no url
				//this.log("params (down): "+url+" "+isAsync+" "+this.syncUser+" "+this.syncPass);
			request.open("GET", url, isAsync, this.syncUser, this.syncPass);
			request.onload = function() { rv = ssObj.downSyncComplete(request,downTime,null,fn); callback && callback(rv); ssObj=null;  };   var rv, ssObj=this, fn=(remoteFileName||this.remoteFileName);
			/*if (url.match(/^ftp/i))*/ { var onAlert=function(failMsg){rv=this.ssObj.downSyncComplete(request,downTime,failMsg,null,url); callback && callback(rv,fn); }; this.overrideFTPCallbacks(request,onAlert); } // XXX dang, we have to cut-corners, here, because the downSyncComplete disassembles the .notificationCallbacks
				downTime.start = new Date;
			if (!isAsync) setTimeout(this.syncKill9, this.kill9Interval, this,"down",request,rv,fn); // if the file doesn't exist on the (ftp -only?) server, moz1.3.1 just blocks the thread, continually trying to get a response
			try{ request.send(""); }catch(e){ /*alert("downSync: request-send failed\n\n"+e);*/ rv = this.downSyncComplete(request,downTime,"downSync request failed",fn); callback && callback(rv); } // local/file-urls with nothing there will fail, here ..hmm.
			if (!isAsync) {
				try{ request.abort(); }catch(e){ /*alert('downSync: abort/close failed\n\n'+e);*/ this.log("downSync abort failed: \n\n"+e);}
				return rv || this.downSyncComplete(request,downTime,"downSync connection failed"); }
			else downTime.timeout = setTimeout(this.syncOrbiter, 45000, this,"down",request,callback); 
			return null; // ..unneeded return value; just to rid us of the strict warnings
		},
		downSyncComplete: function(request, downTime, failMsg, fileName, url) {
				var endTime = new Date, startTime = downTime.start; // ...was 2-down
			clearTimeout(downTime.timeout); this.downSyncPending = false;
			if (failMsg) { 
				var isNonRegistryLocalFile = (failMsg=="downSync request failed" && fileName && fileName!=this.remoteFileRegistry); // basically, we'll assume: if we can retrieve the registry, but not any other local-files, then they don't exist and we shouldn't worry to disable sync or count their failure
				this.syncOrbiter(this,"down",null,null,isNonRegistryLocalFile); 
				var isFtp55x = (url) ? false:null; // XXX 'url' is only sent from our onAlert callback-override  //((url && url.match(/^ftp\:/)) && (failMsg.match(/^\s*55[0-9](\s|$)/))) ? false:null; // XXX 550 (couldn't change directories to..); 553 (doesn't exist); XXX port this to upSyncComplete, too? -- (even though unneeded, there?)
				return {success:isFtp55x, msg:failMsg}; }
			request.channel.notificationCallbacks = request.onload = null; // testing to see if it's "ftp" would just be unneeded overhead
			//this.log(request.getAllResponseHeaders());
			try{ var reqContentType = request.getResponseHeader("Content-Type"); }catch(e){} // header-retrieval throws an error when a given header isn't present
			try{ data = request.responseText; }catch(e){}
			if ((reqContentType && reqContentType!=this.contentType) || !data || data=="") var failed = true;
			var statusShort = parseInt(request.status/100);
			if (failed || !(statusShort==2 || statusShort==0)) { this.syncOrbiter(this,"down",request); return {success:false,msg:failMsg || "Sync retrieval failed for "+fileName}; }
				//setTimeout(this.syncStats, 0, this, startTime, endTime, data.length, fileName, "down");
				this.syncStats(this, startTime, endTime, data.length, fileName, "down");
			this.syncFailure.down = 0;
			var resArrayAll = data.split("\n"), res, resultHash = {};
			while ((res=resArrayAll.shift())) res = res.split("   "), resultHash[res[0]] = res[1]; //, this.log('resultName: '+res[0]+' -> '+res[1].substr(0,30)+"...");
			return {success:true,msg:"Success",resultHash:resultHash,data:data};
		},
		overrideFTPCallbacks: function(request,onAlert) {
			var c = {}; c.ssObj=this, c.request=request, c.__proto__=this.callbackOverride;
			c.onAlert=onAlert; // our custom alert-callback
			request.channel.notificationCallbacks = c; 
		},
		callbackOverride: { 
			QueryInterface: function(iid) {
				var i=iid,e="equals", c=Components.interfaces;
				if (!i[e](c.nsISupports)&& !i[e](c.nsIInterfaceRequestor)&& 
				!i[e](c.nsIFTPEventSink)&& !i[e](c.nsIProgressEventSink) && !i[e](c.nsIPrompt)) { /*this.log(i);*/
					 return this.ssGetNative(i);} // we just pass it on, if it's not overridden
				else return this; 
			},
			getInterface: function(iid) { return this.QueryInterface(iid); },
			ssGetNative: function(iid){ try{ var retrieved = this.request.channel.loadGroup.notificationCallbacks.getInterface(iid); }catch(e){/*return null*/;} return retrieved; },
			cleanup: function(){this.request.onload=null; this.ssObj=this.request=this.onAlert=this.__proto__=null;},
			OnFTPControlLog: function(isServer,msg){ msg=msg.replace(/[\r\n]/g," "); this.log(msg); /*this.ssObj.log((isServer?"In ":"Out")+"   ->   "+msg);*/ },
			onProgress:function(req,ctxt,prog,progMax){ this.log("onprogress: "+prog+" / "+progMax); },
			onStatus:function(req,ctxt,status,statusArg){ this.log("status: "+status+"   ->   "+statusArg); },
			alert:function(title,msg){ msg=msg.replace(/[\r\n]/g," "); this.log(msg); this.onAlert(msg); }, // XXX basically, any ftp-alert == failure
			onAlert:null,   log:function(msg){ this.ssObj.syncCtxt && this.ssObj.syncCtxt && !this.ssObj.syncCtxt.closed && (this.ssObj.syncCtxt._content.status=msg); /*this.ssObj.log(msg);*/ }
		},
		syncClear: function(url){
			var cacheService = Components.classes["@mozilla.org/network/cache-service;1"].getService(Components.interfaces.nsICacheService);
			try {
				var cacheSession = cacheService.createSession('HTTP',0,true);
				var cacheEntry = cacheSession.openCacheEntry(url, Components.interfaces.nsICache.ACCESS_WRITE,true);
				cacheEntry.doom(), cacheEntry.close();
			}catch(e){ this.log("sync cache-clear failed: "+e); cacheService.evictEntries(Components.interfaces.nsICache.STORE_ON_DISK); }
			cacheService.evictEntries(Components.interfaces.nsICache.STORE_IN_MEMORY);
			cacheService.evictEntries(Components.interfaces.nsICache.STORE_ANYWHERE);
		},
		syncStats: function(ssObj, startTime, endTime, dataLength, fileName, type) {
				return; // XXX disabled for mLA  [and best left, so -rue]
				var elapsed = startTime ? (endTime.valueOf() - startTime.valueOf())/1000 : 0; // ms -> secs
				var ksize = dataLength / 1024;
				var speed = Math.round( ksize / (elapsed||1) * 100)/100; // elapsed can sometimes be zero (eg. local files)
				var time = (elapsed<1 && elapsed>0) ? Math.round(elapsed*100)/100 : Math.round(elapsed);
				var size = (ksize<1 && ksize>0) ? Math.round(ksize*100)/100 : Math.round(ksize);
				ssObj.log(type+"Synced: "+fileName+"   ->   "+size+"k in "+time+"secs   :   ("+speed+"kb/sec)");
		},
		syncKill9: function(ssObj, type, request, rv, fileName) { 
			if(!rv && request.readyState==1) 
				ssObj.syncOrbiter(ssObj,type,request,null,true), ssObj.log(type+"Sync "+type+"load failed: "+fileName);
		},
		syncOrbiter: function(ssObj, type, request, callback, noCount) { // orbiting about, watching for failed connections..
			var flag = type+"SyncPending";  //if (!ssObj[flag]) return;
			ssObj[flag] = false; 
			if (request) request.abort();
			if (callback) callback({success:false,msg:"request timed out"});
			/* // XXX disable (all following) for mLA. */
			return;
			if (!noCount && ++ssObj.syncFailure[type]>3) {
				ssObj.syncFailure[type]=0;
				if (ssObj.sync) {
					alert("SessionSaver Sync is de-activating:\n ...the "+type+"link has failed to connect, repeatedly;\n...you should check your login-settings."),
					ssObj.settingsBranch.setBoolPref("sync",false),   ssObj.sync=false; // XXX since the pref-observer might not catch it at shutdown, fast-enough
					var wnd = ssObj.windowMediator.getMostRecentWindow("sessionsaver:sessionsaverSettings");
					if (wnd && !wnd.closed && wnd.SessionSaverSettings && wnd.SessionSaverSettings.checkboxSyncEnable) 
						wnd.SessionSaverSettings.checkboxSyncEnable.setAttribute("checked",false);   } // be intelligent, if the settings-window is open
			}
		},
		syncFailure: {up:0, down:0}, // counter, for consecutive failures -- in either direction
		/*
			running-list of 'dontWarn' values:
				0. warn when removing stored-session
				1. persisted copy of browser.tabs.warnOnClose
				2. removalMenuIsShowing
				3. warn when manually loading remote-session (sync submenu)
		*/
		// gets an indexed-flag, from our collapsed pref-array
		convertObj: {'true':1,'false':0,'1':true,'0':false,'null':null,'':null,'undefined':null},
		getDontWarn: function(index) {
			var dontWarnValues = (this.settingsBranch.prefHasUserValue('dontwarn')) ? this.settingsBranch.getCharPref('dontwarn') : null; // default:null
			if (!dontWarnValues) return null;
			dontWarnValues = dontWarnValues.split(" "), value = (index >= 0) ? dontWarnValues[index] : null;
			return (value in this.convertObj) ? this.convertObj[value] : value;
		},
		// sets an indexed-flag, in our collapsed pref-array
		setDontWarn: function(index, value) {
			var dontWarnValues = (this.settingsBranch.prefHasUserValue('dontwarn')) ? this.settingsBranch.getCharPref('dontwarn').split(" ") : []; // default:[]
			value = (index >= 0 && value in this.convertObj) ? 
					this.convertObj[value] : null;
			if (value != null) dontWarnValues[index] = String(value);
			else delete dontWarnValues[index];
			this.settingsBranch.setCharPref('dontwarn', dontWarnValues.join(" "));
		},
		disableWarnOnCloseHandling: function(){
			this.restoreWarnOnClose();
			this.setDontWarn(1,1);
		},
		enableWarnOnCloseHandling: function(){
			this.setDontWarn(1,null);
			this.removeWarnOnClose();
		},
		removeWarnOnClose: function() {
				if (this.rootBranch.getPrefType("browser.tabs.warnOnClose") == Components.interfaces.nsIPrefBranch.PREF_BOOL
					&& this.rootBranch.getBoolPref("browser.tabs.warnOnClose") // we only care if it's 'true'
					&& this.getDontWarn(1) == null) { // XXX the user can force the warning by setting dontWarn.slot1 to 'warn'; the 'null' option keeps us from restoring more than once
				this.rootBranch.setBoolPref("browser.tabs.warnOnClose",false);
				this.setDontWarn(1,true); }
		},
		restoreWarnOnClose: function() {
			var previousSetting;
			if (this.rootBranch.getPrefType("browser.tabs.warnOnClose") == Components.interfaces.nsIPrefBranch.PREF_BOOL)
				if ((previousSetting=this.getDontWarn(1)) in {'true':0,'false':0}) // XXX the user can force the warning by setting dontWarn-1 to 'warn'; the 'null' option keeps us from restoring more than once
					this.rootBranch.setBoolPref("browser.tabs.warnOnClose", previousSetting),
					this.setDontWarn(1,null);
		},
		onModifyRequest: function(a) { 
			/*if (a.URI.spec in this.check) { if (--this.check[a.URI.spec]==0) delete this.check[a.URI.spec]; a.requestMethod = "POST"; } 
			this.cached=[null,a];*/
		},
		// Captures PostData for all views, including subframes.   ..data is stored as:  view.__ssPostData + view.__ssAdjusted
		onExamineResponse: function(request) { 
			try{
				if (request.requestMethod != "POST") return;
					request.QueryInterface(Components.interfaces.nsIUploadChannel);
			} catch(e){ this.log("ss onExamineResponse failed-I: "+e); return; }
			try {
				if (!request.uploadStream) return;
				var postDataStream = request.uploadStream;
				// We register once per document- subframes counting as separate documents
				//    ..each will trip the listener for both the document itself, and all child content
				request.QueryInterface(Components.interfaces.nsIRequest);
				if ((request.loadFlags & Components.interfaces.nsIChannel.LOAD_DOCUMENT_URI) && 
						request.loadGroup && request.loadGroup.groupObserver) {
					var go = request.loadGroup.groupObserver;
					var adjustedWrap = {adjusted:null};
					var postDataText = this.slurpPost(postDataStream,adjustedWrap,request);
						if (postDataText == null) return;
					var adjusted = adjustedWrap.adjusted;
						adjustedWrap.adjusted = null; // ..just in case
					var keyID = Math.random();
					var url = request.QueryInterface(Components.interfaces.nsIHttpChannel).URI.spec;
					go.QueryInterface(Components.interfaces.nsIWebProgress);
					go.addProgressListener(new this.webListener(url,postDataText,adjusted,keyID,1), this.webMask);
					go.addProgressListener(new this.webListener(url,postDataText,adjusted,keyID,2), 0x0b); // XXX duplicate, to counteract lhttp, which, oddly enough, seems to kill our listener when it adds its "capture-window" request/response interceptors
				}
			} catch(e){ this.log("ss onExamineResponse failed-II: "+e); return; }
		},
		undefinedRe:/^undefined/,   contentTypeRe:/^(Content-Type: )([^\r\n]+)((\r\n){1,2}|\r|\n)/m,   contentLengthRe:/^(Content-Length: )([^\r\n]+)((\r\n){1,2}|\r|\n)/m,
		slurpPost: function(postDataStream,adjustedWrap,request) {
			postDataStream.QueryInterface(Components.interfaces.nsISeekableStream); 
			try{ postDataStream.seek(0,0); } catch(e){ var shouldReplace = true; }
			var input = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
			input.init(postDataStream);   var postDataText="", size=input.available();
			if (typeof(size)!='number' || size<0 || size>500000) return null; // we can't do anything with zero, and large file-uploads completely choke the browser; so we'll pass on those, too (500+kb)
			// XXX assume we have binary data mixed-in (file-upload, likely) if the size is greater than 1024, or we couldn't rewind the stream
			//    -> binary data causes cut-off from the file-section down -- eg.: preview-posts on extensionmirror restore as "posted"
			if (shouldReplace || size>1024) { while (size--) postDataText+=(input.read(1)||"\0"); } // more "delicate" handling, for binary-data in the stream
			else postDataText = input.read(size); // ..or: straight-through read
			//try{ postDataStream.QueryInterface(Components.interfaces.nsISeekableStream).seek(0,0); }catch(e){} // XXX causes a crash, when anyone else touches the stream, afterwards
			postDataStream.close(),input.close();    postDataText=postDataText.replace(this.undefinedRe,'');
			/* XXX if liveHttpHeaders (or anyone else) registers an observer after us, theirs will be handled first (reverse-queue).
			    ..and, since anything (ie. LHttp) which touches+destroys the multiplexed postData-stream is permanent, 
			       ..the best we can do is re-register, to set ourselves back ahead in the queue for the next capture --
			          ..the present-attempted capture is simply written-off, lost. */
			if (postDataText.length == 0 && shouldReplace) { this.restartPostWatch("slurpPost"); return null; }
			var origPostDataText = postDataText; // ..include the file-stream, for uploadStream-resetting
			var contentType = postDataText.match(this.contentTypeRe),   contentLength = postDataText.match(this.contentLengthRe);
			if (contentType && contentType[2]) {
				var boundary = contentType[2].match(/(boundary\=)(.*)/); boundary && (boundary=boundary[2]);
				if (boundary) {
					var adjusted=false, boundaryArray = postDataText.split(boundary), p=boundaryArray.length; while (p--) if (boundaryArray[p]&&(boundaryArray[p].match(/[\x00-\x07]/m)))  adjusted=boundaryArray.splice(p++,1); //, this.log("adjusted: "+adjusted);
					if (adjusted) postDataText = boundaryArray.join(boundary);  }
			}
			if (adjusted) {
				var newPostDataText = origPostDataText;
				var ct =contentType[2],   replaceCT =contentType[0],   replaceCL =contentLength[0];
					replaceCL && (newPostDataText = newPostDataText.replace( replaceCT,'' ));
					replaceCT && (newPostDataText = newPostDataText.replace( replaceCL,'' ));
				//if (!contentType) contentType = "application/x-www-form-urlencoded"; // XXX we'll always have the content-type, now
				adjustedWrap.adjusted = [ct,newPostDataText]; // ..if not adjusted, contentType wont have any properties
				if (request) {
					var stringStream = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream);
						stringStream.setData(newPostDataText, -1);
					var mimeStream = Components.classes["@mozilla.org/network/mime-input-stream;1"].createInstance(Components.interfaces.nsIMIMEInputStream);
					mimeStream.addHeader("Content-Type", ct);
					mimeStream.addContentLength = true;
						mimeStream.setData(stringStream);
					request.QueryInterface(Components.interfaces.nsIUploadChannel);
					request.setUploadStream(mimeStream,ct,-1);  // tip-tap, replace.
				}
			}
			return postDataText;
		},
		deferredLog: function(ssObj,msg){ if (msg.join) msg=msg.join("\n"); ssObj.log(msg); }, // to break out of time-sensitive flow
		runTest: function(testItem) { // ..947 interfaces, total, for branch1.0.6
			var interfaces= Components.interfaces, res=""; 
			for (var n in interfaces) {   try{testItem.QueryInterface(interfaces[n]); res+=n+", "}catch(e){}   }
			try{res+=testItem}catch(e){}
			return (window.__ssZ = res); // sans or with fileStream (both):   nsIMIMEInputStream, nsISeekableStream, nsIInputStream, nsISupports   ->   [xpconnect wrapped (nsISupports, nsIInputStream, nsIMIMEInputStream, nsISeekableStream)]
		},
		comTest: function(flag) { var states=["transferring","stop","is_document","is_request","is_window"],x,res=[]; while((x=states.shift())) (flag & Components.interfaces.nsIWebProgressListener["STATE_"+x.toUpperCase()]) && (res.push(x)); return res.join(", ");},
		get webMask(){return Components.interfaces.nsIWebProgress.NOTIFY_STATE_ALL | Components.interfaces.nsIWebProgress.NOTIFY_LOCATION | Components.interfaces.nsIWebProgress.NOTIFY_ALL}, // will be: Components.interfaces.nsIWebProgress.NOTIFY_STATE_ALL | Components.interfaces.nsIWebProgress.NOTIFY_LOCATION | Components.interfaces.nsIWebProgress.NOTIFY_ALL, //Components.interfaces.nsIWebProgress.NOTIFY_ALL,
		webListener: #8=function(url,postData,adjusted,keyID,index) { 
			this.url      = url;
			this.postData = postData; 
			this.adjusted = adjusted||null; 
			this.keyID = keyID;
			this.index = index;
		},
		webListenerPrototype: #8#.prototype={
			onStateChange: function(webProgress, request, flags, status) {
				this.tryptic(webProgress,request,"stateChange"); // The content-view actually seems present from the earliest call, meaning we don't have to wait
			},
			protocols: {"http:":0}, // XXX no capture for secure-connections -- to avoid duplicate online-purchases/transactions
			http: "http:",
			tryptic: function(webProgress,request,calledBy) {
				try {
					var view = webProgress.DOMWindow;
					try{
						if (!view || !view.location || ""+view.location != this.url || !(view.location.protocol == this.http/*in this.protocols*/)) return; // XXX trying to test the request.channel's scheme would fail for imgIRequest, so we moved to testing view.location.protocol
					}catch(e){return;}
					var storedKeyID = (view.__ssKeyID) ? view.__ssKeyID:null;
					if (storedKeyID && storedKeyID != this.keyID) return; // still waiting for the old view to "depart"
					else if (!storedKeyID) // new view
						view.__ssKeyID    = this.keyID,
						view.__ssPostData = this.postData,   
						view.__ssAdjusted = this.adjusted; 
					webProgress.removeProgressListener(this); // released
				} catch (e) {SessionSaverObserver.log("ss tryptic failed: "+e)}

			},
			empty: #10=function(){return;},
			onProgressChange : #10#, onLocationChange:#10#, onStatusChange:#10#, onSecurityChange:#10#,
			GetWeakReference : function() {return this}, // XXX never called?
			QueryInterface   : function(iid) {
				if (!iid.equals(Components.interfaces.nsISupports) &&
						!iid.equals(Components.interfaces.nsISupportsWeakReference) &&
						!iid.equals(Components.interfaces.nsIWebProgressListener) &&
						!iid.equals(Components.interfaces.nsIHttpNotify))
					throw Components.results.NS_ERROR_NO_INTERFACE;
				return this;
			}
		},
		
		removeWin: function(observer, wndData){
			//var z = Components.stack, res=""; while(z.caller) res+=z.caller.name+"\n", z=z.caller; alert(res); // XXX debug
			var winName = wndData[0], metadata = wndData[1];
			if (observer.shutdownRequested) return;
			var win = observer.retrieveWindow(winName);
			if (win && !win.closed) return; // continue only if the window is gone completely or closed
			
			observer.removeWindow(winName);
			if (observer.autoMode == true) { 
				//var prefArray = observer.windowBranch.getCharPref(winName).split(observer.D[0]); // get stored window-session from pref
				var metadataClone = [metadata[0],metadata[1],metadata[2]]; // locally re-instantiated
				var prefArray = metadata[3];
				observer.closedWindows.unshift( [metadataClone,prefArray] ); // for Brilliant SnapBack - windows
				observer.windowBranch.deleteBranch(winName);
				var dataObj = {isWindowClosure:null,calledBy:"removeWin",newWinName:null}
				observer.observe(null, 'SessionSaver-SavePrefFile', dataObj); }
		},
		// renames a stored session-branch -- by replicating to the new-name, then deleting the old
		renameBranch: function(sessionBranch, sessionDescription, wnd) {
			var title = "SessionSaver - Rename", prompt = "Rename from "+sessionDescription+", to:", defaultValue = sessionDescription;
			var modEntry = wnd.SessionSaver.sessionPromptDisplay(title,prompt,defaultValue);
			if (!modEntry) return
			var prefBranchSource =this.prefBranchStatic+sessionBranch,   prefBranchTarget =this.prefBranchStatic+modEntry+".";
			this.replicateBranch(prefBranchSource,prefBranchTarget);
			//removeBranch(sessionBranch, null,null, false);
			try{ this.staticBranch.deleteBranch(sessionBranch); }
			catch(e) { alert(this.removalFailedTxt+e); }
			return modEntry+".";
		},
		// removes all children from a stored session-branch
		removeBranch: function(sessionBranch, sessionDescription, wnd, forceWarn) {
			//if (sessionBranch == this.staticBranchDefault) return; // ignore default  [permitted, now -rue]
			var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService); 
			var storedValue = this.getDontWarn(0);
			var warn = (typeof(forceWarn)=='boolean') ? forceWarn : !storedValue; // allow 'forceWarn' to override in either direction  ( -- even though we never do this)

			// alert the user, if the "dontWarn" flag isn't set
			if (warn) {
				var dontWarn = {value:!storedValue};
				var buttonPressed = promptService.confirmEx(wnd,this.removalConfirmTitleTxt,this.removalConfirmMsgTxt+sessionDescription+"\n",promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 + promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1,this.removeTxt,this.cancelTxt,null,this.removalConfirmWarnTxt,dontWarn); // was-> this.continueTxt, for the button
				this.setDontWarn(0, !dontWarn.value); // flipped
				if (buttonPressed == 1) return; }
			// zap.
			try{ this.staticBranch.deleteBranch(sessionBranch); } 
			catch(e) { alert(this.removalFailedTxt+e); }
		},
		// rolls a backup (of target), then replicates source to target
		replicateAndRoll: function(prefBranchSource, prefBranchTarget) {
			this.rollBranch(prefBranchTarget); // rolling-backup of the previous shutdown-save (if any)
			this.replicateBranch(prefBranchSource, prefBranchTarget); // the new copy
		},
		// rolls a backup of an existing branch
		rollBranch: function(prefBranchSource, newSourceName) {
			var rollingBackupBranch = ( newSourceName||prefBranchSource ).replace(/\.$/, this.rollingPriorTxt);
			return this.replicateBranch(prefBranchSource, rollingBackupBranch); // rolling-backup of the previous shutdown-save (if any)
		},
		//var appShell = Components.classes["@mozilla.org/appshell/appShellService;1"].getService(Components.interfaces.nsIAppShellService);  var hiddenWnd = appShell.hiddenDOMWindow; hiddenWnd.SessionSaverObserver.replicateBranch("windows.","replicateTest." );
		// replicates all children from the source-branch to the target-branch
		replicateBranch: function(prefBranchSource, prefBranchTarget) {
			if (!this.Branch.prefHasUserValue(prefBranchSource+"zorder")) return null; // only continue if the source-branch exists
			var branches = this.Branch.getChildList(prefBranchSource, {}),prefName; // array of pref-names holding window-sessions
			var sourceRe = new RegExp("^"+prefBranchSource.replace(/(\W)/g,"\\$1"));
			var sourceBranch = this.prefService.getBranch(this.prefBranch+prefBranchSource);
			var targetBranch = this.prefService.getBranch(this.prefBranch+prefBranchTarget);
			this.Branch.deleteBranch(prefBranchTarget); // empty the target, in preparation
			while((prefName=branches.shift())) {
				prefName = prefName.replace(sourceRe, "")
				switch (sourceBranch.getPrefType(prefName)) {
					case Components.interfaces.nsIPrefBranch.PREF_STRING: targetBranch.setCharPref(prefName, sourceBranch.getCharPref(prefName)) ; break;
					case Components.interfaces.nsIPrefBranch.PREF_INT:    targetBranch.setIntPref (prefName, sourceBranch.getIntPref (prefName)) ; break;
					case Components.interfaces.nsIPrefBranch.PREF_BOOL:   targetBranch.setBoolPref(prefName, sourceBranch.getBoolPref(prefName)) ; break;
				}
			}
			return true;
		},
		captureAndMerge: function(prefBranchSession, winName) {
			var prefBranchZorder = prefBranchSession+"zorder", CI=Components.interfaces, PB=CI.nsIPrefBranch;
			if (!this.Branch.prefHasUserValue(prefBranchZorder)||this.Branch.getPrefType(prefBranchZorder)!=PB.PREF_STRING) // "bad-stuff, hmm."
				{ this.captureAll(prefBranchSession,true,true,winName); return; } // ..so, just overwrite
			var z, zorders = this.Branch.getCharPref(prefBranchZorder).split(","), zorders2=zorders.concat();
			var takenSlots = {}, slotRe = /\d+$/;
			while ((z=zorders2.shift())) takenSlots[z.match(slotRe)[0]]=true;
				var i=-1, currentZorders = this.zOrderString.split(","), zorderHash={ asArray:currentZorders.concat()};
				while (++i < currentZorders.length) zorderHash[currentZorders[i]]=i;
			if (winName) { var activeWindows = {}; activeWindows[winName]=1; }
			else activeWindows = this.activeWindows;
			var didCapture = false;
			var newZorders = [];
			for (var name in activeWindows) {
				if (this.activeWindows[name] && !this.activeWindows[name].closed && this.activeWindows[name].SessionSaver) {
					var counter = 0;
					while (takenSlots[counter]) counter++;
					var newWinName = this.winLocalPrefix+counter, nx;
					var curWinName = this.activeWindows[name].SessionSaver.winName;
					newZorders[ zorderHash[curWinName] ] = newWinName;
					this.activeWindows[name].SessionSaver.captureWindow("captureAll",prefBranchSession, true, null,null,nx, newWinName); // save each window-state, suppressing auto-save if specified  -- //captureWindow: function(calledBy, prefBranchSession, suppressSave, isWindowClosure, isTimedCall, n, winName)
					didCapture=true;
				}
			}
			if (!didCapture) { alert(this.captureFailedTxt); return; }
			var zorderString = newZorders.concat(zorders).join(",");
			this.Branch.setCharPref(prefBranchSession+"zorder", zorderString);
			if (this.cookieString) {
				var prefBranchCookies = prefBranchSession+"cookies";
				if (!this.Branch.prefHasUserValue(prefBranchCookies)||this.Branch.getPrefType(prefBranchCookies)!=PB.PREF_STRING) 
					var storedCookieArray = [];
				else storedCookieArray = this.Branch.getCharPref(prefBranchCookies).split("  |")
				var cookieArray = this.cookieString.split("  |");
				var cookieStringMerged = cookieArray.concat(storedCookieArray).join("  |");
				if (cookieStringMerged!="") this.Branch.setCharPref(prefBranchSession + "cookies", cookieStringMerged)
			}
			this.prefService.savePrefFile(null);
		},
		// captures either: the current window, or all opened windows
		captureAll: function(prefBranchSession, suppressSave, saveOnLast, winName) {
			if (prefBranchSession) this.Branch.deleteBranch(prefBranchSession); // remove old session
			if (winName) { var activeWindows = {}; activeWindows[winName]=1; }
			else activeWindows = this.activeWindows;
			var didCapture = false;
			for (var name in activeWindows) 
				if (this.activeWindows[name] && !this.activeWindows[name].closed && this.activeWindows[name].SessionSaver) 
					this.activeWindows[name].SessionSaver.captureWindow("captureAll",prefBranchSession, suppressSave), didCapture=true; // save each window-state, suppressing auto-save if specified
			if (!didCapture) { alert(this.captureFailedTxt); return; }
			this.setCookies(prefBranchSession);
			this.setZorder(prefBranchSession);
			if (saveOnLast) this.prefService.savePrefFile(null);
		},
		// stores all session-cookies for active urls
		setCookies: function(prefBranchSession) {
			var cookieManager = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager); 
			var cookies = cookieManager.enumerator; 
			var activeHostHashes = [];
			for (var n in this.activeWindows) {
				var win = this.activeWindows[n];
				if (!(win && win.SessionSaver) || win.closed) { continue; } // skip if the window is gone or closed -- needed, since we don't remove windows from the hash, immediately
				activeHostHashes.push(win.SessionSaver.hostHash);
			}
			if (activeHostHashes.length == 0) return; // make sure we don't erase the cookies on a non-browser-win shutdown
			var sessionCookies = [];
			while (cookies.hasMoreElements()) {   
				var c = cookies.getNext().QueryInterface(Components.interfaces.nsICookie); 
				if (c.expires == 0 && c.host) {
					var hostD =  c.host.replace(/^\./,''); // host-domain
					var h=activeHostHashes.length, match=false; 
					while (h-- && !match) {
						if (!c.isDomain) { if (hostD in activeHostHashes[h]) match=true; } // fast-lookup for non-domain cookies [now for domain-cookies too -rue]
						else {
							var hostParts =hostD.split("."), curHash =activeHostHashes[h]; //hostParts.shift(); // ditch the primary, since we already tested [not by present-design -rue]
							do { if (hostParts.join(".") in curHash) match=true; hostParts.shift();  } while (hostParts.length-1 > 0 && !match)   }
					}
					if (!match) { continue; }
					var name = (c.name?c.name:"name") +"="+ (c.value?c.value:"")+";";
					var host = (c.isDomain&&hostD)?("domain="+hostD+";"):""; // dang- i was using "host=" instead of "domain=" (n25 p4)  -- http://lxr.mozilla.org/seamonkey/source/netwerk/cookie/src/nsCookieService.cpp#1558
					var path =  c.path?("path="+c.path+";"):"";
					var secure= c.isSecure?"secure;":"";
					var url = "http"+(c.isSecure?"s":"")+"://"+ (/*c.isDomain?c.host:*/hostD) +((c.path && c.path!="/")?c.path.replace(/^([^\/])/,"/$1"):""); // it seems we actually want the preceeding dot (.) before the host on domain-cookies
					//var expires = "expires=0;"; // we'll set this at recall, to save a little space
					sessionCookies.push(url+" "+name+host+path/*+expires*/+secure);
				}
			}
			var cookieString = sessionCookies.join("  |");
			if (!prefBranchSession) prefBranchSession = this.prefBranchWindows; // assume auto, if unspecified
			if (cookieString != "") this.Branch.setCharPref(prefBranchSession + "cookies", cookieString), this.cookieString = cookieString; // store array as string
			else if (this.Branch.prefHasUserValue(prefBranchSession + "cookies")) this.Branch.deleteBranch(prefBranchSession + "cookies"), this.cookieString = null; // don't store an empty string
		},
		// sets z-order pref
		setZorder: function(prefBranchSession, newWinName) {
			if (this.shutdownRequested) return; // Firefox 1.5+ under osX -> fails to properly retain zordering, at shutdown
			var name, zOrderString = new Array();
			var enumerator = this.windowMediator.getZOrderDOMWindowEnumerator("navigator:browser", false);
			while (enumerator.hasMoreElements())
				if ((name = enumerator.getNext().SessionSaver) && (name = name.winName)) zOrderString.push(name); // get each window's z-order -- but only if the window is loaded
			if (zOrderString.length < this.activeAsArray.length) { // some linux-builds don't retrieve full z-order? (n25 p5)
				var i = -1, z = 1;
				while (this.activeAsArray[++i])
					if (this.activeAsArray[i] != zOrderString[0]) zOrderString[z++] = this.activeAsArray[i];
			}
			zOrderString = zOrderString.join(",");
			if (newWinName && zOrderString.indexOf(newWinName) == -1) zOrderString = newWinName+","+zOrderString; // make sure new windows are added ( -- window-mediator doesn't catch stuff fast enough)
			if (!prefBranchSession) prefBranchSession = this.prefBranchWindows; // assume auto, if unspecified
			this.Branch.setCharPref(prefBranchSession + "zorder", zOrderString); // store array as string
			this.zOrderString = zOrderString;
		},
		// adds a window's listing to the global-hash
		addWindow: function(wnd, ssObj) {
			if (!ssObj.winName) { // session window-name (will be unique)
				 ssObj.winSlot = this.reserveSlot();
				 ssObj.winName = this.winLocalPrefix + ssObj.winSlot; } // build our unique name
			ssObj.winNameUnique = this.winLocalPrefix + (this.globalWindowCount++); // an "unrecycled" name, unique across the entire browsing-session -- used by initSyncMenu()
			this.activeWindows[ssObj.winName] = wnd; // add our window to the global-hash
			this.activeAsArray = [];
			for (var n in this.activeWindows) if (this.pendingString.indexOf(n) == -1) this.activeAsArray.push(n);
		},
		globalWindowCount:0,
		// return's the window-obj for a listing
		retrieveWindow: function(winName) {
			return this.activeWindows[winName];
		},
		// removes a window's listing, after it's been closed
		removeWindow: function(winName) {
			var winSlot = winName.match(/\d+$/)[0];
			delete this.takenSlots[winSlot];
			delete this.activeWindows[winName];
			this.activeAsArray = [];
			for (var n in this.activeWindows) if (this.pendingString.indexOf(n) == -1) this.activeAsArray.push(n);
		},
		// reserves a particular slot (or next available) for window-naming
		reserveSlot: function(slot, override) {
			if (!slot || (this.takenSlots[slot] && !override)) slot = this.nameCounter();
			this.takenSlots[slot] = true;
			return slot;
		},
		// UNUSED: frees a particular slot for window-naming
		releaseSlot: function(slot) {
			delete this.takenSlots[slot];
			return slot;
		},
		// returns the next available "slot" for window-naming
		nameCounter: function() {
			var counter = 0;
			while (this.takenSlots[counter]) counter++;
			return counter;
		},
		// UNUSED: called by the hidden-wnd's unload event
		latentShutdown: function () {
			this.shutdownRequested = true; // flag: so the unload-listeners stop tripping
			this.settingsBranch.setBoolPref("shutdown", true); // set pref-flag: we didn't crash
		},
		set msg(msg){this.msgRoll(msg);},
		msgRoll: function m(s) {
			if (s||!this.dpc) this.dpc=1,r=s,s=this;
			var r=this.dpr||(this.dpr=r);
			if(!r) { return r=s.msg=s['k'] }
			else return r[this.dpc++];
		},
		v: [,,"\157\156\145\40\157\146\40\164\150\157\163\145\40\144\141\171\163\54\40\150\155\155\77","\164\162\171\40\146\157\162\40\164\150\162\145\145\77","\144\145\154\151\143\151\157\165\163\40\145\156\164\162\157\160\171\56","\156\157\56\65\40\141\154\151\166\145\40\41\56\56\40\145\162\54\40\156\157\56\40\151\164\40\167\141\163\40\163\151\170\54\40\163\157\162\162\171\56","\147\157\154\146\56\40\171\157\165\40\153\156\157\167\55\40\167\150\145\162\145\40\164\150\145\40\160\141\162\164\171\47\163\40\141\164\56","\157\157\150\54\40\156\151\143\145\56","\144\151\154\141\164\151\163\155\54\40\146\162\151\145\156\144\55","\144\141\162\152\145\145\154\151\156\147\40\53\40\163\151\154\145\156\143\145\40\53\40\124\145\141\40\115\151\156\144","\56\56\141\154\167\141\171\163\54\40\145\166\145\162\40\164\150\145\40\157\160\164\151\155\151\163\164\54","\107\157\157\144\156\151\147\150\164\54\40\115\163\56\40\110\141\142\141\144\141\163\150\56\56\40\167\150\145\162\145\166\145\162\40\171\157\165\40\141\162\145\56"],
		// nsISupports interface implementation
		QueryInterface: function(iid) {
			if (!iid.equals(Components.interfaces.nsISupports) &&
				!iid.equals(Components.interfaces.nsISupportsWeakReference) &&
				!iid.equals(Components.interfaces.nsIHttpHeaderVisitor) &&
				!iid.equals(Components.interfaces.nsIHttpNotify) &&
				!iid.equals(Components.interfaces.nsIObserver))
			{	dump("SessionSaver observer object: QI unknown interface: " + iid + "\n");
				throw Components.results.NS_ERROR_NO_INTERFACE; }
	
			return this;
		}
	},
	
	// Pref-observer -- controls "Manual Mode" menuitems  +  "Auto Mode" listeners
	prefObserverLoad: function() {
		this.autoMode = null; // placeholders - set by "observe()"
		this.fileMenu = null;
		this.windowInit = false; // flag: are we initialized?
		
		// our "manual-mode" filemenu items
		this.menuItemArray = new Array();
		this.menuItemArray.push( document.getElementById("sessionsaver-separator-menuitem") );
		this.menuItemArray.push( document.getElementById("sessionsaver-header-menuitem") );
		this.menuItemArray.push( document.getElementById("sessionsaver-load-menuitem") );
		this.menuItemArray.push( document.getElementById("sessionsaver-save-menuitem") );

		// our "snapback" tools-menu items
		this.snapHidden = [document.createElement("menuitem"), document.createElement("menuitem")];
		this.snapHidden[0].hidden = true; this.snapHidden[1].hidden = true;
		this.snapHidden[0].id = "sessionsaver-tabback-hiddenitem"; this.snapHidden[1].id = "sessionsaver-windowback-hiddenitem";
		this.snapTabsMenuitem =    (document.getElementById("sessionsaver-tabback-mozillaitem") || document.getElementById("sessionsaver-tabback-firefoxitem"));
		this.snapTabsMenu     =    (document.getElementById("sessionsaver-tabback-mozillamenu") || document.getElementById("sessionsaver-tabback-firefoxmenu"));
		this.snapWindowsMenuitem = (document.getElementById("sessionsaver-windowback-mozillaitem") || document.getElementById("sessionsaver-windowback-firefoxitem"));
		this.snapWindowsMenu     = (document.getElementById("sessionsaver-windowback-mozillamenu") || document.getElementById("sessionsaver-windowback-firefoxmenu"));
		this.snapParent          =  this.snapTabsMenuitem.parentNode;
		this.snapParent.removeChild(this.snapTabsMenu);
		this.snapParent.removeChild(this.snapWindowsMenu);
		this.snapParent.__ssSnapTabItem    = this.snapTabsMenuitem;
		this.snapParent.__ssSnapWindowItem = this.snapWindowsMenuitem;
		// our "sync" tools-menu items
		this.syncHidden        = document.createElement("menuitem");
		this.syncHidden.hidden = true;
		this.syncHidden.id     = "sessionsaver-sync-hiddenitem";
		this.syncMenu          = (document.getElementById("sessionsaver-sync-mozillamenu") || document.getElementById("sessionsaver-sync-firefoxmenu"));
		this.syncParent        = this.syncMenu.parentNode;
		this.snapParent.__ssSyncItem = this.syncMenu;
		// mandatory    (.  ..   ...   oh, alright already.)
		this.toolsMenu     = (document.getElementById("taskPopup") || document.getElementById("menu_ToolsPopup"));
		

		this.pbi = this.rootBranch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
		try { this.pbi.addObserver(this.prefBranch+this.prefBranchSettings, this, true); } // keep this last, in case we hit an error.
		catch(e) { alert("SessionSaver: prefs-Observer failed to attach: " + e + "\n"); return; }
		
		this.observe(null, null, "init"); // initialize the menuitems
	},

	// removes the observer-object from service -- called when the window is no longer open
	removeObserver: function() {
		this.pbi.removeObserver(this.prefBranch+this.prefBranchSettings, this);
		delete this;
	},
	
	// observer-function
	/* subject: [wrapped nsISupports :: nsIPrefBranch], nsIPrefBranchInternal -- topic: "changed" */
	observe: function(subject, topic, prefName) {

		// if we don't have a valid window (closed)
		if ( !(typeof(document) == 'object' && document) ) {this.removeObserver(); return;} // remove observer + don't continue
		
		var init = prefName=="init", init2 = prefName=="init2";
		if (!init && !init2) prefName = prefName.match(new RegExp("^"+this.prefBranch+this.prefBranchSettings+"(.*)$"))[1];
		if (prefName == "shutdown") return; // ignore the shutdown-flag
		var addOrRemove, seeOrBypass;
		
		if (init || "autoload.branch" == prefName)      this.autoLoadBranch     = (this.settingsBranch.prefHasUserValue('autoload.branch')) ? this.settingsBranch.getCharPref('autoload.branch') : this.prefBranchWindows; // default:'windows.'
		if (init || "autoload"        == prefName)      this.autoLoad           = !this.settingsBranch.prefHasUserValue('autoload')      || this.settingsBranch.getBoolPref('autoload'); // default:true
		if (init || "crashload"       == prefName)      this.crashLoad          = !this.settingsBranch.prefHasUserValue('crashload')     || this.settingsBranch.getBoolPref('crashload'); // default:true
		if (init || "bluefyre"        == prefName)      this.bluefyreStyle      =  this.settingsBranch.prefHasUserValue('bluefyre')      && this.settingsBranch.getBoolPref('bluefyre');     // default:false
		if (init || "bluefyreflip"    == prefName) {    this.bluefyreFlip       =  this.settingsBranch.prefHasUserValue('bluefyreflip')   ? this.settingsBranch.getCharPref('bluefyreflip') : "Startup"; // default:"Startup"
				if (!(this.bluefyreFlip in {Startup:0,Shutdown:0,Both:0})) this.bluefyreFlip = "Startup"; }
		if (init || "shutdownsave"    == prefName)      this.shutdownSave       = !this.settingsBranch.prefHasUserValue('shutdownsave')  || this.settingsBranch.getBoolPref('shutdownsave'); // default:true
		if (init || "nofx"            == prefName)      this.snapback_noFX      =  this.settingsBranch.prefHasUserValue('nofx')          && this.settingsBranch.getBoolPref('nofx'); // default:false
		if (init || "willfocus"       == prefName)      this.snapback_willFocus = !this.settingsBranch.prefHasUserValue('willfocus')     || this.settingsBranch.getBoolPref('willfocus'); // default:true
		if (init || "shutdownsave"    == prefName)      this.shutdownSave       = !this.settingsBranch.prefHasUserValue('shutdownsave')  || this.settingsBranch.getBoolPref('shutdownsave'); // default:true
		if (init || "snapdropdown"    == prefName)      this.snapDropdown       = !this.settingsBranch.prefHasUserValue('snapdropdown')  || this.settingsBranch.getBoolPref('snapdropdown'); // default:true
		if (init || "snaptabs"        == prefName)      var  snapTabsChanged    =  this.snapTabs != (this.snapTabs = !this.settingsBranch.prefHasUserValue('snaptabs') || this.settingsBranch.getBoolPref('snaptabs')); // default:true
		if (init || "snapwindows"     == prefName)      var  snapWindowsChanged =  this.snapWindows != (this.snapWindows = this.settingsBranch.prefHasUserValue('snapwindows') && this.settingsBranch.getBoolPref('snapwindows')); // default:false
		if (init || "sync"            == prefName)      var  syncChanged        =  this.sync != (this.sync = this.settingsBranch.prefHasUserValue('sync') && this.settingsBranch.getBoolPref('sync')); // default:false
		if (init || "syncmenu"        == prefName)      var  syncMenuChanged    =  this.syncShowMenu != (this.showSyncMenu = !this.settingsBranch.prefHasUserValue('syncmenu') || this.settingsBranch.getBoolPref('syncmenu')); // default:true
		if (init || "shutdownsave.branch" == prefName)  this.shutdownSaveBranch = (this.settingsBranch.prefHasUserValue('shutdownsave.branch')) ? this.settingsBranch.getCharPref('shutdownsave.branch') : this.prefBranchStatic+this.staticBranchDefault; // default:'static.default.'
		if (init || prefName in {"shutdownsave":0,"shutdownsave.branch":0}) {
			var captureItemActive = (!this.shutdownSave || this.shutdownSaveBranch != this.prefBranchStatic+this.staticBranchDefault);
			this.menuItemArray[3].label = captureItemActive ? this.menuItemArray[3].getAttribute("activelabel") : this.menuItemArray[3].getAttribute("inactivelabel");
			this.menuItemArray[3].setAttribute("disabled", captureItemActive ? false:true);  }
		if ((init || snapTabsChanged || snapWindowsChanged) && (this.snapBackEnable()||true) && snapTabsChanged && (addOrRemove=(this.snapTabs)?"addEventListener":"removeEventListener")) 
			this.toolsMenu[addOrRemove]("popupshowing", ssSnapBackEnable, true); // SnapBack - enablement
		//if (/*(init || syncChanged || syncMenuChanged) && (this.syncEnable()||true) &&*/ 
		if (syncChanged||syncMenuChanged)
			addOrRemove = (this.sync&&this.showSyncMenu) ? "addEventListener":"removeEventListener",
			this.toolsMenu[addOrRemove]("popupshowing", ssSyncEnable, true), 
			this.syncEnable(); // Sync - enablement
		
		// Listeners
		//var autoPrefChanged = /^(?:init|autoload\.branch|autoload|crashload|shutdownsave|snaptabs)$/.test(prefName);
		var autoPrefChanged = /^(?:init2|autoload\.branch|autoload|crashload|shutdownsave|snaptabs)$/.test(prefName); // XXX NOT at init -- we'll call a second time, afterwards, to permit ftp-sync time to finish
		if (autoPrefChanged) {
			var newMode = this.crashLoad || (this.autoLoad && this.autoLoadBranch==this.prefBranchWindows) || this.shutdownsave || this.snapTabs;
			if (this.autoMode != (this.autoMode = newMode)) { // -also stores the mode
				var Tabbrowser = window.getBrowser(), Panels = Tabbrowser.mPanelContainer, Tabs = Tabbrowser.mTabContainer;
				addOrRemove = (newMode) ? "addEventListener" : "removeEventListener"; // if entering auto-mode, add tab-listeners. otherwise, remove listeners if loaded.
				seeOrBypass = (newMode) ? "Intercept"        : "Bypass";
				Tabbrowser[addOrRemove]('load',     ssTabLoad,   true);  // tab-save when loaded (normal)
				Tabbrowser[addOrRemove]('pageshow', ssTabLoad,   true);  // tab-save when loaded (from bfcache)
				Tabbrowser[addOrRemove]('input',    ssInput,     true);  // text-field capture on input
				Tabbrowser[addOrRemove]('click',    ssInput,     true);  // input/select-element capture on click
				Tabs      [addOrRemove]('select',   ssTabSelect, true);  // tab-save when switching tabs
				//setTimeout(function(){throw "_content-getter: "+window.__lookupGetter__("_content");});
				//window.watch("_content",function(a,b,c){setTimeout(function(){throw "snip-snap: "+a+' -> '+b+' : '+c;}); return c;});
						//Tabbrowser.mTabContainer.addEventListener('focus', function(evt){throw 'focused-tab: '+evt.target.nodeName;}, true);
						if (!Panels.__ssBypass) Panels.__ssBypass = Panels.removeChild, Panels.__ssIntercept = ssTabPanelUnload;
				Panels.removeChild = Panels['__ss'+seeOrBypass];       // tab-save when closed
				if (newMode && this.windowInit) this.captureWindow("prefObserver-init");  // if already loaded, capture the current session
			}
		}
		
		if (init || "overwritewindows" == prefName)  this.overwriteWindows  = !this.settingsBranch.prefHasUserValue('overwritewindows') || this.settingsBranch.getBoolPref('overwritewindows'); // default:true
		if (init || "overwritetabs"    == prefName)  this.overwriteTabs     = !this.settingsBranch.prefHasUserValue('overwritetabs')    || this.settingsBranch.getBoolPref('overwritetabs');    // default:true
		if (init || "concatenate"      == prefName)  this.concatenate       =  this.settingsBranch.prefHasUserValue('concatenate')      && this.settingsBranch.getBoolPref('concatenate');      // default:false
		if (init || "filemenu"         == prefName) { // File-menu items
			this.fileMenu = this.settingsBranch.prefHasUserValue('filemenu') && this.settingsBranch.getBoolPref('filemenu'); // default:false
			for (var n in this.menuItemArray) this.menuItemArray[n].hidden = !this.fileMenu; }
		
		if (init) this.windowInit = true;
		
	},
	
	// nsISupports interface implementation -- for weak-reference by pref-observer service
	QueryInterface: function(iid) {
		if (!iid.equals(Components.interfaces.nsISupports)
				&& !iid.equals(Components.interfaces.nsISupportsWeakReference)
				&& !iid.equals(Components.interfaces.nsIObserver)) {
			dump("SessionSaver Window Pref-Observer factory object: QI unknown interface: " + iid + "\n");
			throw Components.results.NS_ERROR_NO_INTERFACE; }
		return this;
	}
	
};


/*
** Window-load listeners + Hidden observer
*/

// Hidden-Window is loading
if (typeof(window.SessionSaverLoader) != "undefined") {
	window.SessionSaverObserver = window.SessionSaver.observerObject; // remember, we loaded this script a second time, locally
	SessionSaverObserver.load(window.SessionSaverLoader);
	window.SessionSaverLoader = null; // we can't delete them, so here's the next best thing
	window.SessionSaver = null;
	delete window.SessionSaverLoader;
	delete SessionSaver;
}
// LiveHttpHeaders capture-pane is loading (we overlay this, to reload our post-listeners)
else if (window.isLiveHttpHeaders__ssIntercept) { // location.toString.indexOf("chrome://livehttpheaders")==0) { // if (window.oHeaderInfoLive) { // the other scripts haven't loaded, yet
	SessionSaver.setupHiddenWnd();
	//SessionSaver.checkLoaded(); // ...this is kinda/slightly dangerous, since there's theoretical designs by which LHttp might be opened before the first browser-window; meaning, the window wouldn't think it was the first-opened, and restore
	function ssRestartPostWatch() { try{SessionSaver.hiddenWnd.SessionSaverObserver.restartPostWatch("live-load");}catch(e){} } // ..yea, easier to just wrap in a try-block; if it fails, SS wasn't loaded anywhere, so who cares -- it will be last whenever it loads
	function ssLHttpLoad() { window.removeEventListener("load",ssLHttpLoad,true); setTimeout(ssRestartPostWatch,100); }
	window.addEventListener("load",ssLHttpLoad,true);
}
// Browser-Window or Settings is loading
else {
	
	if (document.getElementById("sessionsaverSettings")) { ;}// for settings-load -- to copy the flasher
	else {
		// moz1.3.1 doesn't do anything if the listener isn't set to capture
		//   -- further, we can't remove a listener if it has inline-code.
		function ssLoad() { SessionSaver.onLoad(); }
		function ssClose(evt) { return SessionSaver.onClose(evt); } // XXX can now (theoretically) keep the window from closing
		function ssUnload(evt) { SessionSaver.onUnload(evt); }
		function ssTabLoad(evt) { SessionSaver.onTabLoad(evt); }
		function ssTabSelect(evt) { SessionSaver.onTabSelect(evt); }
		function ssInput(evt,view) { SessionSaver.onInput(evt,view); }
		function ssTabPanelUnload(a) { SessionSaver.onTabPanelUnload(a); }
		function ssSnapBackEnable() { SessionSaver.snapBackEnable(); }
		function ssSyncEnable() { SessionSaver.syncEnable(); }
		
		window.addEventListener('load', ssLoad, true); // window startup-check (for crash-recovery)
		SessionSaver.mw = window.document.getElementById("main-window"); // the higher window doesn't have attribute-methods
		if (SessionSaver.mw.hasAttribute("onclose")) {
			SessionSaver.mw.__ssOrigOnclose = SessionSaver.mw.getAttribute("onclose");
			SessionSaver.mw.__ssModOnclose  = "if (!ssClose(event)) return false; " + SessionSaver.mw.__ssOrigOnclose;
			SessionSaver.mw.setAttribute("onclose", SessionSaver.mw.__ssModOnclose); } // window-capture on close
		else window.addEventListener('close', ssClose, true);
		window.addEventListener('unload', ssUnload, true); // window-remove on unload
		
		if (!window.opener) // ..this should permit us 'room' to adjust the window.arguments, pending window-load completion; there's no .opener for the first browser-window
			SessionSaver.arguments = window.arguments, 
			window.arguments = [];
	}

	// Hidden window - common
	SessionSaver.setupHiddenWnd();
	
}
